/* ItemView.c generated by valac 0.56.16, the Vala compiler
 * generated from ItemView.vala, do not modify */

/*
 * Copyright (c) 2017-2019 José Amuedo (https://github.com/spheras)
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gdk/gdk.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <stdio.h>
#include <gio/gio.h>
#include <gio/gdesktopappinfo.h>
#include <cairo-gobject.h>
#include <float.h>
#include <math.h>
#include <pango/pango.h>
#include <gee.h>
#include <glib/gi18n-lib.h>

#define DESKTOP_FOLDER_ITEM_VIEW_PADDING_X 10
#define DESKTOP_FOLDER_ITEM_VIEW_PADDING_Y 44
#define DESKTOP_FOLDER_ITEM_VIEW_ICON_WIDTH 48
#define DESKTOP_FOLDER_ITEM_VIEW_DEFAULT_WIDTH 90
#define DESKTOP_FOLDER_ITEM_VIEW_DEFAULT_HEIGHT 90
#define DESKTOP_FOLDER_ITEM_VIEW_MAX_CHARACTERS 13
#define DESKTOP_FOLDER_ICON_SIZE 48
#define DESKTOP_FOLDER_DRAGN_DROP_file_drag_actions ((GDK_ACTION_COPY | GDK_ACTION_MOVE) | GDK_ACTION_LINK)
#define DESKTOP_FOLDER_ICON_DEFAULT_WIDTH 90
#define DESKTOP_FOLDER_LANG_ITEM_MENU_OPEN _ ("Open")
#define DESKTOP_FOLDER_LANG_ITEM_MENU_EXECUTE _ ("Execute")
#define DESKTOP_FOLDER_LANG_ITEM_MENU_OPEN_WITH _ ("Open With Other Application...")
#define DESKTOP_FOLDER_LANG_ITEM_MENU_CUT _ ("Cut")
#define DESKTOP_FOLDER_LANG_ITEM_MENU_COPY _ ("Copy")
#define DESKTOP_FOLDER_LANG_ITEM_MENU_RENAME _ ("Rename")
#define DESKTOP_FOLDER_LANG_ITEM_MENU_TRASH _ ("Move to Trash")
#define DESKTOP_FOLDER_LANG_ITEM_MENU_CHANGEICON _ ("Change Icon")
#define DESKTOP_FOLDER_LANG_ITEM_PROPSWINDOW_SHOW_FILEINFO _ ("Properties")
#define DESKTOP_FOLDER_LANG_DESKTOPFOLDER_MENU_OPEN_IN_TERMINAL _ ("Open in terminal")
#define DESKTOP_FOLDER_LANG_ITEM_DELETE_FOLDER_MESSAGE _ ("This action will DELETE the folder and ALL its content.\n" \
"<b>Are you sure?</b>")
#define DESKTOP_FOLDER_LANG_ITEM_DELETE_FILE_MESSAGE _ ("This action will DELETE the file.\n<b>Are you sure?</b>")
#define DESKTOP_FOLDER_LANG_ITEM_DELETE_LINK_MESSAGE _ ("This action will DELETE the link (just the link).\n" \
"<b>Are you sure?</b>")
#define DESKTOP_FOLDER_LANG_ITEM_CHANGEICON_MESSAGE _ ("Select the image icon to be used.")
#define DESKTOP_FOLDER_LANG_DIALOG_CANCEL _ ("_Cancel")
#define DESKTOP_FOLDER_LANG_DIALOG_SELECT _ ("_Select")
#define DESKTOP_FOLDER_WINDOW_DECORATION_MARGIN 10
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define DESKTOP_FOLDER_TYPE_ITEM_VIEW (desktop_folder_item_view_get_type ())
#define DESKTOP_FOLDER_ITEM_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DESKTOP_FOLDER_TYPE_ITEM_VIEW, DesktopFolderItemView))
#define DESKTOP_FOLDER_ITEM_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DESKTOP_FOLDER_TYPE_ITEM_VIEW, DesktopFolderItemViewClass))
#define DESKTOP_FOLDER_IS_ITEM_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DESKTOP_FOLDER_TYPE_ITEM_VIEW))
#define DESKTOP_FOLDER_IS_ITEM_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DESKTOP_FOLDER_TYPE_ITEM_VIEW))
#define DESKTOP_FOLDER_ITEM_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DESKTOP_FOLDER_TYPE_ITEM_VIEW, DesktopFolderItemViewClass))

typedef struct _DesktopFolderItemView DesktopFolderItemView;
typedef struct _DesktopFolderItemViewClass DesktopFolderItemViewClass;
typedef struct _DesktopFolderItemViewPrivate DesktopFolderItemViewPrivate;

#define DESKTOP_FOLDER_TYPE_ITEM_MANAGER (desktop_folder_item_manager_get_type ())
#define DESKTOP_FOLDER_ITEM_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DESKTOP_FOLDER_TYPE_ITEM_MANAGER, DesktopFolderItemManager))
#define DESKTOP_FOLDER_ITEM_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DESKTOP_FOLDER_TYPE_ITEM_MANAGER, DesktopFolderItemManagerClass))
#define DESKTOP_FOLDER_IS_ITEM_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DESKTOP_FOLDER_TYPE_ITEM_MANAGER))
#define DESKTOP_FOLDER_IS_ITEM_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DESKTOP_FOLDER_TYPE_ITEM_MANAGER))
#define DESKTOP_FOLDER_ITEM_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DESKTOP_FOLDER_TYPE_ITEM_MANAGER, DesktopFolderItemManagerClass))

typedef struct _DesktopFolderItemManager DesktopFolderItemManager;
typedef struct _DesktopFolderItemManagerClass DesktopFolderItemManagerClass;

#define DESKTOP_FOLDER_TYPE_EDITABLE_LABEL (desktop_folder_editable_label_get_type ())
#define DESKTOP_FOLDER_EDITABLE_LABEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DESKTOP_FOLDER_TYPE_EDITABLE_LABEL, DesktopFolderEditableLabel))
#define DESKTOP_FOLDER_EDITABLE_LABEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DESKTOP_FOLDER_TYPE_EDITABLE_LABEL, DesktopFolderEditableLabelClass))
#define DESKTOP_FOLDER_IS_EDITABLE_LABEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DESKTOP_FOLDER_TYPE_EDITABLE_LABEL))
#define DESKTOP_FOLDER_IS_EDITABLE_LABEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DESKTOP_FOLDER_TYPE_EDITABLE_LABEL))
#define DESKTOP_FOLDER_EDITABLE_LABEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DESKTOP_FOLDER_TYPE_EDITABLE_LABEL, DesktopFolderEditableLabelClass))

typedef struct _DesktopFolderEditableLabel DesktopFolderEditableLabel;
typedef struct _DesktopFolderEditableLabelClass DesktopFolderEditableLabelClass;
enum  {
	DESKTOP_FOLDER_ITEM_VIEW_0_PROPERTY,
	DESKTOP_FOLDER_ITEM_VIEW_NUM_PROPERTIES
};
static GParamSpec* desktop_folder_item_view_properties[DESKTOP_FOLDER_ITEM_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define DESKTOP_FOLDER_TYPE_FOLDER_MANAGER (desktop_folder_folder_manager_get_type ())
#define DESKTOP_FOLDER_FOLDER_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DESKTOP_FOLDER_TYPE_FOLDER_MANAGER, DesktopFolderFolderManager))
#define DESKTOP_FOLDER_FOLDER_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DESKTOP_FOLDER_TYPE_FOLDER_MANAGER, DesktopFolderFolderManagerClass))
#define DESKTOP_FOLDER_IS_FOLDER_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DESKTOP_FOLDER_TYPE_FOLDER_MANAGER))
#define DESKTOP_FOLDER_IS_FOLDER_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DESKTOP_FOLDER_TYPE_FOLDER_MANAGER))
#define DESKTOP_FOLDER_FOLDER_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DESKTOP_FOLDER_TYPE_FOLDER_MANAGER, DesktopFolderFolderManagerClass))

typedef struct _DesktopFolderFolderManager DesktopFolderFolderManager;
typedef struct _DesktopFolderFolderManagerClass DesktopFolderFolderManagerClass;

#define DESKTOP_FOLDER_TYPE_FOLDER_WINDOW (desktop_folder_folder_window_get_type ())
#define DESKTOP_FOLDER_FOLDER_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DESKTOP_FOLDER_TYPE_FOLDER_WINDOW, DesktopFolderFolderWindow))
#define DESKTOP_FOLDER_FOLDER_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DESKTOP_FOLDER_TYPE_FOLDER_WINDOW, DesktopFolderFolderWindowClass))
#define DESKTOP_FOLDER_IS_FOLDER_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DESKTOP_FOLDER_TYPE_FOLDER_WINDOW))
#define DESKTOP_FOLDER_IS_FOLDER_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DESKTOP_FOLDER_TYPE_FOLDER_WINDOW))
#define DESKTOP_FOLDER_FOLDER_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DESKTOP_FOLDER_TYPE_FOLDER_WINDOW, DesktopFolderFolderWindowClass))

typedef struct _DesktopFolderFolderWindow DesktopFolderFolderWindow;
typedef struct _DesktopFolderFolderWindowClass DesktopFolderFolderWindowClass;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define TYPE_DESKTOP_FOLDER_APP (desktop_folder_app_get_type ())
#define DESKTOP_FOLDER_APP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DESKTOP_FOLDER_APP, DesktopFolderApp))
#define DESKTOP_FOLDER_APP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DESKTOP_FOLDER_APP, DesktopFolderAppClass))
#define IS_DESKTOP_FOLDER_APP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DESKTOP_FOLDER_APP))
#define IS_DESKTOP_FOLDER_APP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DESKTOP_FOLDER_APP))
#define DESKTOP_FOLDER_APP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DESKTOP_FOLDER_APP, DesktopFolderAppClass))

typedef struct _DesktopFolderApp DesktopFolderApp;
typedef struct _DesktopFolderAppClass DesktopFolderAppClass;

#define DESKTOP_FOLDER_DRAGN_DROP_TYPE_DND_VIEW (desktop_folder_dragn_drop_dnd_view_get_type ())
#define DESKTOP_FOLDER_DRAGN_DROP_DND_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DESKTOP_FOLDER_DRAGN_DROP_TYPE_DND_VIEW, DesktopFolderDragnDropDndView))
#define DESKTOP_FOLDER_DRAGN_DROP_IS_DND_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DESKTOP_FOLDER_DRAGN_DROP_TYPE_DND_VIEW))
#define DESKTOP_FOLDER_DRAGN_DROP_DND_VIEW_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), DESKTOP_FOLDER_DRAGN_DROP_TYPE_DND_VIEW, DesktopFolderDragnDropDndViewIface))

typedef struct _DesktopFolderDragnDropDndView DesktopFolderDragnDropDndView;
typedef struct _DesktopFolderDragnDropDndViewIface DesktopFolderDragnDropDndViewIface;

#define DESKTOP_FOLDER_TYPE_ITEM_SETTINGS (desktop_folder_item_settings_get_type ())
#define DESKTOP_FOLDER_ITEM_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DESKTOP_FOLDER_TYPE_ITEM_SETTINGS, DesktopFolderItemSettings))
#define DESKTOP_FOLDER_ITEM_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DESKTOP_FOLDER_TYPE_ITEM_SETTINGS, DesktopFolderItemSettingsClass))
#define DESKTOP_FOLDER_IS_ITEM_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DESKTOP_FOLDER_TYPE_ITEM_SETTINGS))
#define DESKTOP_FOLDER_IS_ITEM_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DESKTOP_FOLDER_TYPE_ITEM_SETTINGS))
#define DESKTOP_FOLDER_ITEM_SETTINGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DESKTOP_FOLDER_TYPE_ITEM_SETTINGS, DesktopFolderItemSettingsClass))

typedef struct _DesktopFolderItemSettings DesktopFolderItemSettings;
typedef struct _DesktopFolderItemSettingsClass DesktopFolderItemSettingsClass;
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
typedef enum  {
	DESKTOP_FOLDER_DRAGN_DROP_TARGET_TYPE_STRING,
	DESKTOP_FOLDER_DRAGN_DROP_TARGET_TYPE_TEXT_URI_LIST,
	DESKTOP_FOLDER_DRAGN_DROP_TARGET_TYPE_XDND_DIRECT_SAVE0,
	DESKTOP_FOLDER_DRAGN_DROP_TARGET_TYPE_NETSCAPE_URL
} DesktopFolderDragnDropTargetType;

#define DESKTOP_FOLDER_DRAGN_DROP_TYPE_TARGET_TYPE (desktop_folder_dragn_drop_target_type_get_type ())
#define _gtk_target_list_unref0(var) ((var == NULL) ? NULL : (var = (gtk_target_list_unref (var), NULL)))
typedef enum  {
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_CUSTOM = 0,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_LINEAR,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_QUAD,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_QUAD,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_QUAD,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_CUBIC,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_CUBIC,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_CUBIC,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_QUART,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_QUART,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_QUART,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_QUINT,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_QUINT,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_QUINT,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_SINE,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_SINE,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_SINE,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_EXPO,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_EXPO,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_EXPO,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_CIRC,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_CIRC,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_CIRC,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_ELASTIC,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_ELASTIC,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_ELASTIC,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_BACK,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_BACK,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_BACK,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_BOUNCE,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_BOUNCE,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_IN_OUT_BOUNCE,
	DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_LAST
} DesktopFolderUtilFxAnimationMode;

#define DESKTOP_FOLDER_UTIL_FX_TYPE_ANIMATION_MODE (desktop_folder_util_fx_animation_mode_get_type ())

#define DESKTOP_FOLDER_TYPE_DESKTOP_WINDOW (desktop_folder_desktop_window_get_type ())
#define DESKTOP_FOLDER_DESKTOP_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DESKTOP_FOLDER_TYPE_DESKTOP_WINDOW, DesktopFolderDesktopWindow))
#define DESKTOP_FOLDER_DESKTOP_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DESKTOP_FOLDER_TYPE_DESKTOP_WINDOW, DesktopFolderDesktopWindowClass))
#define DESKTOP_FOLDER_IS_DESKTOP_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DESKTOP_FOLDER_TYPE_DESKTOP_WINDOW))
#define DESKTOP_FOLDER_IS_DESKTOP_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DESKTOP_FOLDER_TYPE_DESKTOP_WINDOW))
#define DESKTOP_FOLDER_DESKTOP_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DESKTOP_FOLDER_TYPE_DESKTOP_WINDOW, DesktopFolderDesktopWindowClass))

typedef struct _DesktopFolderDesktopWindow DesktopFolderDesktopWindow;
typedef struct _DesktopFolderDesktopWindowClass DesktopFolderDesktopWindowClass;

#define DESKTOP_FOLDER_TYPE_FOLDER_ARRANGEMENT (desktop_folder_folder_arrangement_get_type ())
#define DESKTOP_FOLDER_FOLDER_ARRANGEMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DESKTOP_FOLDER_TYPE_FOLDER_ARRANGEMENT, DesktopFolderFolderArrangement))
#define DESKTOP_FOLDER_IS_FOLDER_ARRANGEMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DESKTOP_FOLDER_TYPE_FOLDER_ARRANGEMENT))
#define DESKTOP_FOLDER_FOLDER_ARRANGEMENT_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), DESKTOP_FOLDER_TYPE_FOLDER_ARRANGEMENT, DesktopFolderFolderArrangementIface))

typedef struct _DesktopFolderFolderArrangement DesktopFolderFolderArrangement;
typedef struct _DesktopFolderFolderArrangementIface DesktopFolderFolderArrangementIface;

#define DESKTOP_FOLDER_TYPE_POSITION_SETTINGS (desktop_folder_position_settings_get_type ())
#define DESKTOP_FOLDER_POSITION_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DESKTOP_FOLDER_TYPE_POSITION_SETTINGS, DesktopFolderPositionSettings))
#define DESKTOP_FOLDER_POSITION_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DESKTOP_FOLDER_TYPE_POSITION_SETTINGS, DesktopFolderPositionSettingsClass))
#define DESKTOP_FOLDER_IS_POSITION_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DESKTOP_FOLDER_TYPE_POSITION_SETTINGS))
#define DESKTOP_FOLDER_IS_POSITION_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DESKTOP_FOLDER_TYPE_POSITION_SETTINGS))
#define DESKTOP_FOLDER_POSITION_SETTINGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DESKTOP_FOLDER_TYPE_POSITION_SETTINGS, DesktopFolderPositionSettingsClass))

typedef struct _DesktopFolderPositionSettings DesktopFolderPositionSettings;
typedef struct _DesktopFolderPositionSettingsClass DesktopFolderPositionSettingsClass;

#define DESKTOP_FOLDER_TYPE_FOLDER_SETTINGS (desktop_folder_folder_settings_get_type ())
#define DESKTOP_FOLDER_FOLDER_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DESKTOP_FOLDER_TYPE_FOLDER_SETTINGS, DesktopFolderFolderSettings))
#define DESKTOP_FOLDER_FOLDER_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DESKTOP_FOLDER_TYPE_FOLDER_SETTINGS, DesktopFolderFolderSettingsClass))
#define DESKTOP_FOLDER_IS_FOLDER_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DESKTOP_FOLDER_TYPE_FOLDER_SETTINGS))
#define DESKTOP_FOLDER_IS_FOLDER_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DESKTOP_FOLDER_TYPE_FOLDER_SETTINGS))
#define DESKTOP_FOLDER_FOLDER_SETTINGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DESKTOP_FOLDER_TYPE_FOLDER_SETTINGS, DesktopFolderFolderSettingsClass))

typedef struct _DesktopFolderFolderSettings DesktopFolderFolderSettings;
typedef struct _DesktopFolderFolderSettingsClass DesktopFolderFolderSettingsClass;
typedef struct _Block23Data Block23Data;

#define DESKTOP_FOLDER_TYPE_MENU_ITEM_SEPARATOR (desktop_folder_menu_item_separator_get_type ())
#define DESKTOP_FOLDER_MENU_ITEM_SEPARATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DESKTOP_FOLDER_TYPE_MENU_ITEM_SEPARATOR, DesktopFolderMenuItemSeparator))
#define DESKTOP_FOLDER_MENU_ITEM_SEPARATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DESKTOP_FOLDER_TYPE_MENU_ITEM_SEPARATOR, DesktopFolderMenuItemSeparatorClass))
#define DESKTOP_FOLDER_IS_MENU_ITEM_SEPARATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DESKTOP_FOLDER_TYPE_MENU_ITEM_SEPARATOR))
#define DESKTOP_FOLDER_IS_MENU_ITEM_SEPARATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DESKTOP_FOLDER_TYPE_MENU_ITEM_SEPARATOR))
#define DESKTOP_FOLDER_MENU_ITEM_SEPARATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DESKTOP_FOLDER_TYPE_MENU_ITEM_SEPARATOR, DesktopFolderMenuItemSeparatorClass))

typedef struct _DesktopFolderMenuItemSeparator DesktopFolderMenuItemSeparator;
typedef struct _DesktopFolderMenuItemSeparatorClass DesktopFolderMenuItemSeparatorClass;
typedef struct _Block24Data Block24Data;

struct _DesktopFolderItemView {
	GtkEventBox parent_instance;
	DesktopFolderItemViewPrivate * priv;
};

struct _DesktopFolderItemViewClass {
	GtkEventBoxClass parent_class;
	void (*create_label) (DesktopFolderItemView* self, const gchar* slabel);
};

struct _DesktopFolderItemViewPrivate {
	gboolean flagModified;
	gboolean flagMoved;
	DesktopFolderItemManager* manager;
	GtkMenu* menu;
	gboolean hide_extension;
	gchar* hidden_extension;
	GtkBox* container;
	DesktopFolderEditableLabel* label;
	GtkImage* icon;
	gboolean flag_dragdrop_started;
	GdkDragContext* drag_context;
	gint offsetx;
	gint offsety;
	gint px;
	gint py;
	gint maxx;
	gint maxy;
	GdkPoint start_drag_point;
};

struct _DesktopFolderDragnDropDndViewIface {
	GTypeInterface parent_iface;
	GtkWidget* (*get_widget) (DesktopFolderDragnDropDndView* self);
	GtkApplicationWindow* (*get_application_window) (DesktopFolderDragnDropDndView* self);
	GFile* (*get_file) (DesktopFolderDragnDropDndView* self);
	GtkImage* (*get_image) (DesktopFolderDragnDropDndView* self);
	GFile* (*get_file_at) (DesktopFolderDragnDropDndView* self, gint x, gint y);
	gboolean (*is_folder) (DesktopFolderDragnDropDndView* self);
	gboolean (*is_writable) (DesktopFolderDragnDropDndView* self);
	GFile* (*get_target_location) (DesktopFolderDragnDropDndView* self);
	gboolean (*is_recent_uri_scheme) (DesktopFolderDragnDropDndView* self);
	gchar* (*get_display_target_uri) (DesktopFolderDragnDropDndView* self);
	void (*on_drag_end) (DesktopFolderDragnDropDndView* self);
	void (*on_drag_motion) (DesktopFolderDragnDropDndView* self);
	void (*on_drag_leave) (DesktopFolderDragnDropDndView* self);
	DesktopFolderDragnDropDndView** (*get_all_selected_views) (DesktopFolderDragnDropDndView* self, gint* result_length1);
};

struct _DesktopFolderFolderArrangementIface {
	GTypeInterface parent_iface;
	gboolean (*have_margin) (DesktopFolderFolderArrangement* self);
	gboolean (*can_drag) (DesktopFolderFolderArrangement* self);
	gint (*get_sensitivity) (DesktopFolderFolderArrangement* self);
	gboolean (*can_organize) (DesktopFolderFolderArrangement* self);
	gboolean (*force_organization) (DesktopFolderFolderArrangement* self);
	void (*start_drag) (DesktopFolderFolderArrangement* self, DesktopFolderItemView* view);
	void (*motion_drag) (DesktopFolderFolderArrangement* self, gint x, gint y);
	void (*end_drag) (DesktopFolderFolderArrangement* self);
};

struct _Block23Data {
	int _ref_count_;
	DesktopFolderItemView* self;
	gchar* path;
	gchar* info_path;
};

struct _Block24Data {
	int _ref_count_;
	DesktopFolderItemView* self;
	gboolean isdir;
	GtkMessageDialog* msg;
};

static gint DesktopFolderItemView_private_offset;
static gpointer desktop_folder_item_view_parent_class = NULL;
static GdkPixbuf* desktop_folder_item_view_LINK_PIXBUF;
static GdkPixbuf* desktop_folder_item_view_LINK_PIXBUF = NULL;
VALA_EXTERN gint desktop_folder_folder_arrangement_DEFAULT_EXTERNAL_MARGIN;

VALA_EXTERN GType desktop_folder_item_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DesktopFolderItemView, g_object_unref)
VALA_EXTERN GType desktop_folder_item_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DesktopFolderItemManager, g_object_unref)
VALA_EXTERN GType desktop_folder_editable_label_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DesktopFolderEditableLabel, g_object_unref)
VALA_EXTERN void desktop_folder_item_view_create_label (DesktopFolderItemView* self,
                                            const gchar* slabel);
VALA_EXTERN DesktopFolderItemView* desktop_folder_item_view_new (DesktopFolderItemManager* manager);
VALA_EXTERN DesktopFolderItemView* desktop_folder_item_view_construct (GType object_type,
                                                           DesktopFolderItemManager* manager);
static gboolean desktop_folder_item_view_on_enter (DesktopFolderItemView* self,
                                            GdkEventCrossing* eventCrossing);
static gboolean _desktop_folder_item_view_on_enter_gtk_widget_enter_notify_event (GtkWidget* _sender,
                                                                           GdkEventCrossing* event,
                                                                           gpointer self);
VALA_EXTERN gboolean desktop_folder_item_view_on_leave (DesktopFolderItemView* self,
                                            GdkEventCrossing* eventCrossing);
static gboolean _desktop_folder_item_view_on_leave_gtk_widget_leave_notify_event (GtkWidget* _sender,
                                                                           GdkEventCrossing* event,
                                                                           gpointer self);
static gboolean desktop_folder_item_view_on_press (DesktopFolderItemView* self,
                                            GdkEventButton* event);
static gboolean _desktop_folder_item_view_on_press_gtk_widget_button_press_event (GtkWidget* _sender,
                                                                           GdkEventButton* event,
                                                                           gpointer self);
static gboolean desktop_folder_item_view_on_release (DesktopFolderItemView* self,
                                              GdkEventButton* event);
static gboolean _desktop_folder_item_view_on_release_gtk_widget_button_release_event (GtkWidget* _sender,
                                                                               GdkEventButton* event,
                                                                               gpointer self);
static gboolean desktop_folder_item_view_on_motion (DesktopFolderItemView* self,
                                             GdkEventMotion* event);
static gboolean _desktop_folder_item_view_on_motion_gtk_widget_motion_notify_event (GtkWidget* _sender,
                                                                             GdkEventMotion* event,
                                                                             gpointer self);
VALA_EXTERN void desktop_folder_item_view_refresh_icon (DesktopFolderItemView* self,
                                            const gchar* forced);
static gchar* desktop_folder_item_view_get_correct_label (DesktopFolderItemView* self,
                                                   const gchar* file_name);
VALA_EXTERN gchar* desktop_folder_item_manager_get_file_name (DesktopFolderItemManager* self);
static void desktop_folder_item_view_real_create_label (DesktopFolderItemView* self,
                                                 const gchar* slabel);
VALA_EXTERN DesktopFolderEditableLabel* desktop_folder_editable_label_new (const gchar* title_name);
VALA_EXTERN DesktopFolderEditableLabel* desktop_folder_editable_label_construct (GType object_type,
                                                                     const gchar* title_name);
static void desktop_folder_item_view_check_ellipse (DesktopFolderItemView* self);
static void ___lambda118_ (DesktopFolderItemView* self,
                    const gchar* new_name);
VALA_EXTERN gboolean desktop_folder_item_manager_rename (DesktopFolderItemManager* self,
                                             const gchar* new_name);
VALA_EXTERN void desktop_folder_editable_label_set_text (DesktopFolderEditableLabel* self,
                                             const gchar* value);
static void ____lambda118__desktop_folder_editable_label_changed (DesktopFolderEditableLabel* _sender,
                                                           const gchar* new_title,
                                                           gpointer self);
static void ___lambda119_ (DesktopFolderItemView* self);
VALA_EXTERN GType desktop_folder_folder_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DesktopFolderFolderManager, g_object_unref)
VALA_EXTERN DesktopFolderFolderManager* desktop_folder_item_manager_get_folder (DesktopFolderItemManager* self);
VALA_EXTERN GType desktop_folder_folder_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DesktopFolderFolderWindow, g_object_unref)
VALA_EXTERN DesktopFolderFolderWindow* desktop_folder_folder_manager_get_view (DesktopFolderFolderManager* self);
VALA_EXTERN void desktop_folder_folder_window_on_start_editing (DesktopFolderFolderWindow* self);
static void ____lambda119__desktop_folder_editable_label_on_start_editing (DesktopFolderEditableLabel* _sender,
                                                                    gpointer self);
static void ___lambda120_ (DesktopFolderItemView* self);
VALA_EXTERN void desktop_folder_folder_window_on_end_editing (DesktopFolderFolderWindow* self);
static void ____lambda120__desktop_folder_editable_label_on_stop_editing (DesktopFolderEditableLabel* _sender,
                                                                   gpointer self);
VALA_EXTERN void desktop_folder_util_show_error_dialog (const gchar* title,
                                            const gchar* message);
VALA_EXTERN void desktop_folder_item_view_rename (DesktopFolderItemView* self,
                                      const gchar* new_name);
VALA_EXTERN void desktop_folder_item_view_refresh (DesktopFolderItemView* self);
VALA_EXTERN GType desktop_folder_app_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DesktopFolderApp, g_object_unref)
VALA_EXTERN DesktopFolderApp* desktop_folder_folder_manager_get_application (DesktopFolderFolderManager* self);
VALA_EXTERN gboolean desktop_folder_app_get_desktop_visibility (DesktopFolderApp* self);
VALA_EXTERN void desktop_folder_item_view_fade_in (DesktopFolderItemView* self);
static GtkImage* desktop_folder_item_view_calculate_icon (DesktopFolderItemView* self);
VALA_EXTERN gboolean desktop_folder_item_manager_is_link (DesktopFolderItemManager* self);
static GtkImage* desktop_folder_item_view_draw_link_mark_gicon (DesktopFolderItemView* self,
                                                         GIcon* gicon);
VALA_EXTERN void desktop_folder_item_view_force_opened_folder_icon (DesktopFolderItemView* self);
VALA_EXTERN GtkImage* desktop_folder_item_view_get_image (DesktopFolderItemView* self);
VALA_EXTERN GType desktop_folder_dragn_drop_dnd_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DesktopFolderDragnDropDndView, g_object_unref)
VALA_EXTERN GFile* desktop_folder_dragn_drop_dnd_view_get_file (DesktopFolderDragnDropDndView* self);
VALA_EXTERN GType desktop_folder_item_settings_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DesktopFolderItemSettings, g_object_unref)
VALA_EXTERN DesktopFolderItemSettings* desktop_folder_item_manager_get_settings (DesktopFolderItemManager* self);
VALA_EXTERN const gchar* desktop_folder_item_settings_get_icon (DesktopFolderItemSettings* self);
static GtkImage* desktop_folder_item_view_draw_link_mark_pixbuf (DesktopFolderItemView* self,
                                                          GdkPixbuf* pixbuf);
VALA_EXTERN gboolean desktop_folder_item_manager_check_exist_cached (DesktopFolderItemManager* self);
static GtkImage* desktop_folder_item_view_draw_not_exist_mark_pixbuf (DesktopFolderItemView* self,
                                                               GdkPixbuf* pixbuf);
VALA_EXTERN gboolean desktop_folder_item_manager_is_desktop_file (DesktopFolderItemManager* self);
VALA_EXTERN gchar* desktop_folder_item_manager_get_absolute_path (DesktopFolderItemManager* self);
VALA_EXTERN const gchar* desktop_folder_editable_label_get_text (DesktopFolderEditableLabel* self);
VALA_EXTERN void desktop_folder_editable_label_set_lines (DesktopFolderEditableLabel* self,
                                              gint n);
VALA_EXTERN void desktop_folder_editable_label_set_ellipsize (DesktopFolderEditableLabel* self,
                                                  PangoEllipsizeMode mode);
VALA_EXTERN gboolean desktop_folder_app_get_single_click (DesktopFolderApp* self);
static void desktop_folder_item_view_cancel_movement_and_start_drag_action (DesktopFolderItemView* self,
                                                                     GdkEvent* event);
VALA_EXTERN GType desktop_folder_dragn_drop_target_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GeeList* desktop_folder_folder_manager_get_selected_items (DesktopFolderFolderManager* self);
VALA_EXTERN GType desktop_folder_util_fx_animation_mode_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void desktop_folder_util_gtk_animation_animate_move (GtkWidget* widget,
                                                     GdkPoint* to,
                                                     gdouble duration,
                                                     DesktopFolderUtilFxAnimationMode mode);
VALA_EXTERN void desktop_folder_item_settings_set_x (DesktopFolderItemSettings* self,
                                         gint value);
VALA_EXTERN void desktop_folder_item_settings_set_y (DesktopFolderItemSettings* self,
                                         gint value);
VALA_EXTERN void desktop_folder_item_manager_save_settings (DesktopFolderItemManager* self,
                                                DesktopFolderItemSettings* is);
VALA_EXTERN void desktop_folder_folder_window_on_item_moving (DesktopFolderFolderWindow* self,
                                                  gboolean moving);
VALA_EXTERN GType desktop_folder_desktop_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DesktopFolderDesktopWindow, g_object_unref)
VALA_EXTERN void desktop_folder_item_manager_save_current_position (DesktopFolderItemManager* self);
VALA_EXTERN void desktop_folder_item_view_start_editing (DesktopFolderItemView* self);
VALA_EXTERN void desktop_folder_editable_label_start_editing (DesktopFolderEditableLabel* self);
VALA_EXTERN void desktop_folder_item_view_select_only (DesktopFolderItemView* self);
VALA_EXTERN void desktop_folder_folder_window_unselect_all (DesktopFolderFolderWindow* self);
VALA_EXTERN void desktop_folder_item_manager_select_only (DesktopFolderItemManager* self);
VALA_EXTERN void desktop_folder_item_view_select_add (DesktopFolderItemView* self);
VALA_EXTERN void desktop_folder_item_manager_select_add (DesktopFolderItemManager* self);
VALA_EXTERN void desktop_folder_item_view_unselect (DesktopFolderItemView* self);
VALA_EXTERN void desktop_folder_item_manager_unselect (DesktopFolderItemManager* self);
VALA_EXTERN gboolean desktop_folder_item_view_is_selected (DesktopFolderItemView* self);
VALA_EXTERN gboolean desktop_folder_item_manager_is_selected (DesktopFolderItemManager* self);
VALA_EXTERN void desktop_folder_item_view_fade_out (DesktopFolderItemView* self);
static void desktop_folder_item_view_on_double_click (DesktopFolderItemView* self);
VALA_EXTERN GType desktop_folder_folder_arrangement_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DesktopFolderFolderArrangement, g_object_unref)
VALA_EXTERN DesktopFolderFolderArrangement* desktop_folder_folder_manager_get_arrangement (DesktopFolderFolderManager* self);
VALA_EXTERN gint desktop_folder_folder_arrangement_get_sensitivity (DesktopFolderFolderArrangement* self);
VALA_EXTERN GType desktop_folder_position_settings_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DesktopFolderPositionSettings, g_object_unref)
VALA_EXTERN GType desktop_folder_folder_settings_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DesktopFolderFolderSettings, g_object_unref)
VALA_EXTERN DesktopFolderFolderSettings* desktop_folder_folder_manager_get_settings (DesktopFolderFolderManager* self);
VALA_EXTERN gint desktop_folder_folder_settings_get_arrangement_padding (DesktopFolderFolderSettings* self);
VALA_EXTERN gint desktop_folder_item_view_RoundToNearestMultiple (gint i,
                                                      gint m);
VALA_EXTERN gboolean desktop_folder_folder_arrangement_have_margin (DesktopFolderFolderArrangement* self);
VALA_EXTERN void desktop_folder_folder_window_move_item (DesktopFolderFolderWindow* self,
                                             DesktopFolderItemView* item,
                                             gint x,
                                             gint y);
VALA_EXTERN void desktop_folder_folder_arrangement_end_drag (DesktopFolderFolderArrangement* self);
VALA_EXTERN void desktop_folder_folder_arrangement_start_drag (DesktopFolderFolderArrangement* self,
                                                   DesktopFolderItemView* view);
VALA_EXTERN void desktop_folder_folder_arrangement_motion_drag (DesktopFolderFolderArrangement* self,
                                                    gint x,
                                                    gint y);
VALA_EXTERN DesktopFolderItemManager* desktop_folder_item_view_get_manager (DesktopFolderItemView* self);
VALA_EXTERN gboolean desktop_folder_item_view_is_dragdrop_started (DesktopFolderItemView* self);
VALA_EXTERN void desktop_folder_item_view_on_drag_end (DesktopFolderItemView* self);
VALA_EXTERN gboolean desktop_folder_folder_arrangement_can_drag (DesktopFolderFolderArrangement* self);
VALA_EXTERN gboolean desktop_folder_folder_manager_are_items_locked (DesktopFolderFolderManager* self);
VALA_EXTERN gint desktop_folder_item_settings_get_x (DesktopFolderItemSettings* self);
VALA_EXTERN gint desktop_folder_item_settings_get_y (DesktopFolderItemSettings* self);
VALA_EXTERN GtkLabel* desktop_folder_editable_label_get_title_label (DesktopFolderEditableLabel* self);
static inline gint desktop_folder_item_view_RoundDownToMultiple (gint i,
                                                   gint m);
static void desktop_folder_item_view_show_popup (DesktopFolderItemView* self,
                                          GdkEventButton* event);
VALA_EXTERN void desktop_folder_item_view_execute (DesktopFolderItemView* self);
VALA_EXTERN void desktop_folder_item_manager_execute (DesktopFolderItemManager* self);
static Block23Data* block23_data_ref (Block23Data* _data23_);
static void block23_data_unref (void * _userdata_);
VALA_EXTERN gboolean desktop_folder_item_manager_is_executable (DesktopFolderItemManager* self);
static void __lambda109_ (DesktopFolderItemView* self,
                   GtkMenuItem* item);
static void ___lambda109__gtk_menu_item_activate (GtkMenuItem* _sender,
                                           gpointer self);
static void __lambda110_ (Block23Data* _data23_,
                   GtkMenuItem* item);
VALA_EXTERN void desktop_folder_item_manager_openwith (DesktopFolderItemManager* self,
                                           const gchar* filepath);
static void ___lambda110__gtk_menu_item_activate (GtkMenuItem* _sender,
                                           gpointer self);
VALA_EXTERN DesktopFolderMenuItemSeparator* desktop_folder_menu_item_separator_new (void);
VALA_EXTERN DesktopFolderMenuItemSeparator* desktop_folder_menu_item_separator_construct (GType object_type);
VALA_EXTERN GType desktop_folder_menu_item_separator_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DesktopFolderMenuItemSeparator, g_object_unref)
static void __lambda111_ (DesktopFolderItemView* self,
                   GtkMenuItem* item);
VALA_EXTERN void desktop_folder_item_manager_cut (DesktopFolderItemManager* self);
static void ___lambda111__gtk_menu_item_activate (GtkMenuItem* _sender,
                                           gpointer self);
static void __lambda112_ (DesktopFolderItemView* self,
                   GtkMenuItem* item);
VALA_EXTERN void desktop_folder_item_manager_copy (DesktopFolderItemManager* self);
static void ___lambda112__gtk_menu_item_activate (GtkMenuItem* _sender,
                                           gpointer self);
static void __lambda113_ (DesktopFolderItemView* self,
                   GtkMenuItem* item);
static void ___lambda113__gtk_menu_item_activate (GtkMenuItem* _sender,
                                           gpointer self);
static void __lambda114_ (DesktopFolderItemView* self,
                   GtkMenuItem* item);
VALA_EXTERN void desktop_folder_item_manager_trash_selected (DesktopFolderItemManager* self);
static void ___lambda114__gtk_menu_item_activate (GtkMenuItem* _sender,
                                           gpointer self);
static void __lambda115_ (DesktopFolderItemView* self,
                   GtkMenuItem* item);
static void desktop_folder_item_view_change_icon (DesktopFolderItemView* self);
static void ___lambda115__gtk_menu_item_activate (GtkMenuItem* _sender,
                                           gpointer self);
static void __lambda116_ (Block23Data* _data23_,
                   GtkMenuItem* item);
VALA_EXTERN void desktop_folder_item_manager_show_info (DesktopFolderItemManager* self,
                                            const gchar* filepath);
static void ___lambda116__gtk_menu_item_activate (GtkMenuItem* _sender,
                                           gpointer self);
VALA_EXTERN gboolean desktop_folder_dragn_drop_dnd_view_is_folder (DesktopFolderDragnDropDndView* self);
static void ___lambda117_ (Block23Data* _data23_,
                    GtkMenuItem* item);
VALA_EXTERN void desktop_folder_item_manager_open_in_terminal (DesktopFolderItemManager* self,
                                                   const gchar* path);
static void ____lambda117__gtk_menu_item_activate (GtkMenuItem* _sender,
                                            gpointer self);
VALA_EXTERN void desktop_folder_item_view_cut (DesktopFolderItemView* self);
VALA_EXTERN void desktop_folder_item_view_copy (DesktopFolderItemView* self);
VALA_EXTERN void desktop_folder_item_view_trash (DesktopFolderItemView* self);
VALA_EXTERN void desktop_folder_item_manager_trash (DesktopFolderItemManager* self);
VALA_EXTERN void desktop_folder_item_view_delete_dialog (DesktopFolderItemView* self);
static Block24Data* block24_data_ref (Block24Data* _data24_);
static void block24_data_unref (void * _userdata_);
static void __lambda121_ (Block24Data* _data24_,
                   gint response_id);
static void ___lambda121__gtk_dialog_response (GtkDialog* _sender,
                                        gint response_id,
                                        gpointer self);
VALA_EXTERN GtkApplicationWindow* desktop_folder_dragn_drop_dnd_view_get_application_window (DesktopFolderDragnDropDndView* self);
VALA_EXTERN void desktop_folder_item_manager_change_icon (DesktopFolderItemManager* self,
                                              const gchar* filename);
VALA_EXTERN void desktop_folder_item_view_modify (DesktopFolderItemView* self);
VALA_EXTERN void desktop_folder_item_view_get_bounding_box (DesktopFolderItemView* self,
                                                GdkRectangle* result);
VALA_EXTERN gboolean desktop_folder_editable_label_get_editing (DesktopFolderEditableLabel* self);
VALA_EXTERN gint desktop_folder_position_settings_get_x (DesktopFolderPositionSettings* self);
VALA_EXTERN gint desktop_folder_position_settings_get_y (DesktopFolderPositionSettings* self);
VALA_EXTERN GeeList* desktop_folder_folder_manager_get_items_at (DesktopFolderFolderManager* self,
                                                     GdkRectangle* rectangle);
static void desktop_folder_item_view_finalize (GObject * obj);
static GType desktop_folder_item_view_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

VALA_EXTERN const GtkTargetEntry DESKTOP_FOLDER_DRAGN_DROP_drag_targets[2];

static inline gpointer
desktop_folder_item_view_get_instance_private (DesktopFolderItemView* self)
{
	return G_STRUCT_MEMBER_P (self, DesktopFolderItemView_private_offset);
}

/**
     * @constructor
     * @param ItemManager manager the manager of this item view
     */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 80 "../src/widgets/ItemView.vala"
	return self ? g_object_ref (self) : NULL;
#line 624 "ItemView.c"
}

static gboolean
_desktop_folder_item_view_on_enter_gtk_widget_enter_notify_event (GtkWidget* _sender,
                                                                  GdkEventCrossing* event,
                                                                  gpointer self)
{
	gboolean result;
	result = desktop_folder_item_view_on_enter ((DesktopFolderItemView*) self, event);
#line 91 "../src/widgets/ItemView.vala"
	return result;
#line 636 "ItemView.c"
}

static gboolean
_desktop_folder_item_view_on_leave_gtk_widget_leave_notify_event (GtkWidget* _sender,
                                                                  GdkEventCrossing* event,
                                                                  gpointer self)
{
	gboolean result;
	result = desktop_folder_item_view_on_leave ((DesktopFolderItemView*) self, event);
#line 92 "../src/widgets/ItemView.vala"
	return result;
#line 648 "ItemView.c"
}

static gboolean
_desktop_folder_item_view_on_press_gtk_widget_button_press_event (GtkWidget* _sender,
                                                                  GdkEventButton* event,
                                                                  gpointer self)
{
	gboolean result;
	result = desktop_folder_item_view_on_press ((DesktopFolderItemView*) self, event);
#line 93 "../src/widgets/ItemView.vala"
	return result;
#line 660 "ItemView.c"
}

static gboolean
_desktop_folder_item_view_on_release_gtk_widget_button_release_event (GtkWidget* _sender,
                                                                      GdkEventButton* event,
                                                                      gpointer self)
{
	gboolean result;
	result = desktop_folder_item_view_on_release ((DesktopFolderItemView*) self, event);
#line 94 "../src/widgets/ItemView.vala"
	return result;
#line 672 "ItemView.c"
}

static gboolean
_desktop_folder_item_view_on_motion_gtk_widget_motion_notify_event (GtkWidget* _sender,
                                                                    GdkEventMotion* event,
                                                                    gpointer self)
{
	gboolean result;
	result = desktop_folder_item_view_on_motion ((DesktopFolderItemView*) self, event);
#line 95 "../src/widgets/ItemView.vala"
	return result;
#line 684 "ItemView.c"
}

DesktopFolderItemView*
desktop_folder_item_view_construct (GType object_type,
                                    DesktopFolderItemManager* manager)
{
	DesktopFolderItemView * self = NULL;
	DesktopFolderItemManager* _tmp0_;
	GtkStyleContext* _tmp1_;
	GtkStyleContext* _tmp2_;
	GtkStyleContext* _tmp3_;
	GtkBox* _tmp4_;
	GtkBox* _tmp5_;
	GtkBox* _tmp6_;
	gchar* slabel = NULL;
	DesktopFolderItemManager* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	GtkBox* _tmp12_;
#line 79 "../src/widgets/ItemView.vala"
	g_return_val_if_fail (manager != NULL, NULL);
#line 79 "../src/widgets/ItemView.vala"
	self = (DesktopFolderItemView*) g_object_new (object_type, NULL);
#line 80 "../src/widgets/ItemView.vala"
	_tmp0_ = _g_object_ref0 (manager);
#line 80 "../src/widgets/ItemView.vala"
	_g_object_unref0 (self->priv->manager);
#line 80 "../src/widgets/ItemView.vala"
	self->priv->manager = _tmp0_;
#line 83 "../src/widgets/ItemView.vala"
	gtk_widget_set_size_request ((GtkWidget*) self, DESKTOP_FOLDER_ITEM_VIEW_DEFAULT_WIDTH, DESKTOP_FOLDER_ITEM_VIEW_DEFAULT_HEIGHT);
#line 85 "../src/widgets/ItemView.vala"
	_tmp1_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 85 "../src/widgets/ItemView.vala"
	gtk_style_context_add_class (_tmp1_, "df_item");
#line 87 "../src/widgets/ItemView.vala"
	_tmp2_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 87 "../src/widgets/ItemView.vala"
	gtk_style_context_add_class (_tmp2_, "df_fadingwindow");
#line 88 "../src/widgets/ItemView.vala"
	_tmp3_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 88 "../src/widgets/ItemView.vala"
	gtk_style_context_add_class (_tmp3_, "df_fadeout");
#line 91 "../src/widgets/ItemView.vala"
	g_signal_connect_object ((GtkWidget*) self, "enter-notify-event", (GCallback) _desktop_folder_item_view_on_enter_gtk_widget_enter_notify_event, self, 0);
#line 92 "../src/widgets/ItemView.vala"
	g_signal_connect_object ((GtkWidget*) self, "leave-notify-event", (GCallback) _desktop_folder_item_view_on_leave_gtk_widget_leave_notify_event, self, 0);
#line 93 "../src/widgets/ItemView.vala"
	g_signal_connect_object ((GtkWidget*) self, "button-press-event", (GCallback) _desktop_folder_item_view_on_press_gtk_widget_button_press_event, self, 0);
#line 94 "../src/widgets/ItemView.vala"
	g_signal_connect_object ((GtkWidget*) self, "button-release-event", (GCallback) _desktop_folder_item_view_on_release_gtk_widget_button_release_event, self, 0);
#line 95 "../src/widgets/ItemView.vala"
	g_signal_connect_object ((GtkWidget*) self, "motion-notify-event", (GCallback) _desktop_folder_item_view_on_motion_gtk_widget_motion_notify_event, self, 0);
#line 98 "../src/widgets/ItemView.vala"
	_tmp4_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 98 "../src/widgets/ItemView.vala"
	g_object_ref_sink (_tmp4_);
#line 98 "../src/widgets/ItemView.vala"
	_g_object_unref0 (self->priv->container);
#line 98 "../src/widgets/ItemView.vala"
	self->priv->container = _tmp4_;
#line 99 "../src/widgets/ItemView.vala"
	_tmp5_ = self->priv->container;
#line 99 "../src/widgets/ItemView.vala"
	g_object_set ((GtkWidget*) _tmp5_, "margin", 0, NULL);
#line 100 "../src/widgets/ItemView.vala"
	_tmp6_ = self->priv->container;
#line 100 "../src/widgets/ItemView.vala"
	gtk_widget_set_size_request ((GtkWidget*) _tmp6_, DESKTOP_FOLDER_ITEM_VIEW_DEFAULT_WIDTH, DESKTOP_FOLDER_ITEM_VIEW_DEFAULT_HEIGHT);
#line 102 "../src/widgets/ItemView.vala"
	desktop_folder_item_view_refresh_icon (self, NULL);
#line 103 "../src/widgets/ItemView.vala"
	_tmp7_ = self->priv->manager;
#line 103 "../src/widgets/ItemView.vala"
	_tmp8_ = desktop_folder_item_manager_get_file_name (_tmp7_);
#line 103 "../src/widgets/ItemView.vala"
	_tmp9_ = _tmp8_;
#line 103 "../src/widgets/ItemView.vala"
	_tmp10_ = desktop_folder_item_view_get_correct_label (self, _tmp9_);
#line 103 "../src/widgets/ItemView.vala"
	_tmp11_ = _tmp10_;
#line 103 "../src/widgets/ItemView.vala"
	_g_free0 (_tmp9_);
#line 103 "../src/widgets/ItemView.vala"
	slabel = _tmp11_;
#line 104 "../src/widgets/ItemView.vala"
	desktop_folder_item_view_create_label (self, slabel);
#line 106 "../src/widgets/ItemView.vala"
	_tmp12_ = self->priv->container;
#line 106 "../src/widgets/ItemView.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp12_);
#line 79 "../src/widgets/ItemView.vala"
	_g_free0 (slabel);
#line 79 "../src/widgets/ItemView.vala"
	return self;
#line 782 "ItemView.c"
}

DesktopFolderItemView*
desktop_folder_item_view_new (DesktopFolderItemManager* manager)
{
#line 79 "../src/widgets/ItemView.vala"
	return desktop_folder_item_view_construct (DESKTOP_FOLDER_TYPE_ITEM_VIEW, manager);
#line 790 "ItemView.c"
}

/**
     * @name create_headerbar
     * @description create the header bar
     */
static void
___lambda118_ (DesktopFolderItemView* self,
               const gchar* new_name)
{
	DesktopFolderItemManager* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gboolean _tmp4_;
#line 122 "../src/widgets/ItemView.vala"
	g_return_if_fail (new_name != NULL);
#line 123 "../src/widgets/ItemView.vala"
	_tmp0_ = self->priv->manager;
#line 123 "../src/widgets/ItemView.vala"
	_tmp1_ = self->priv->hidden_extension;
#line 123 "../src/widgets/ItemView.vala"
	_tmp2_ = g_strconcat (new_name, _tmp1_, NULL);
#line 123 "../src/widgets/ItemView.vala"
	_tmp3_ = _tmp2_;
#line 123 "../src/widgets/ItemView.vala"
	_tmp4_ = desktop_folder_item_manager_rename (_tmp0_, _tmp3_);
#line 123 "../src/widgets/ItemView.vala"
	_g_free0 (_tmp3_);
#line 123 "../src/widgets/ItemView.vala"
	if (_tmp4_) {
#line 822 "ItemView.c"
		DesktopFolderEditableLabel* _tmp5_;
#line 124 "../src/widgets/ItemView.vala"
		_tmp5_ = self->priv->label;
#line 124 "../src/widgets/ItemView.vala"
		desktop_folder_editable_label_set_text (_tmp5_, new_name);
#line 125 "../src/widgets/ItemView.vala"
		desktop_folder_item_view_check_ellipse (self);
#line 830 "ItemView.c"
	}
}

static void
____lambda118__desktop_folder_editable_label_changed (DesktopFolderEditableLabel* _sender,
                                                      const gchar* new_title,
                                                      gpointer self)
{
#line 122 "../src/widgets/ItemView.vala"
	___lambda118_ ((DesktopFolderItemView*) self, new_title);
#line 841 "ItemView.c"
}

static void
___lambda119_ (DesktopFolderItemView* self)
{
	DesktopFolderItemManager* _tmp0_;
	DesktopFolderFolderManager* _tmp1_;
	DesktopFolderFolderManager* _tmp2_;
	DesktopFolderFolderWindow* _tmp3_;
	DesktopFolderFolderWindow* _tmp4_;
#line 130 "../src/widgets/ItemView.vala"
	_tmp0_ = self->priv->manager;
#line 130 "../src/widgets/ItemView.vala"
	_tmp1_ = desktop_folder_item_manager_get_folder (_tmp0_);
#line 130 "../src/widgets/ItemView.vala"
	_tmp2_ = _tmp1_;
#line 130 "../src/widgets/ItemView.vala"
	_tmp3_ = desktop_folder_folder_manager_get_view (_tmp2_);
#line 130 "../src/widgets/ItemView.vala"
	_tmp4_ = _tmp3_;
#line 130 "../src/widgets/ItemView.vala"
	desktop_folder_folder_window_on_start_editing (_tmp4_);
#line 130 "../src/widgets/ItemView.vala"
	_g_object_unref0 (_tmp4_);
#line 130 "../src/widgets/ItemView.vala"
	_g_object_unref0 (_tmp2_);
#line 868 "ItemView.c"
}

static void
____lambda119__desktop_folder_editable_label_on_start_editing (DesktopFolderEditableLabel* _sender,
                                                               gpointer self)
{
#line 129 "../src/widgets/ItemView.vala"
	___lambda119_ ((DesktopFolderItemView*) self);
#line 877 "ItemView.c"
}

static void
___lambda120_ (DesktopFolderItemView* self)
{
	DesktopFolderItemManager* _tmp0_;
	DesktopFolderFolderManager* _tmp1_;
	DesktopFolderFolderManager* _tmp2_;
	DesktopFolderFolderWindow* _tmp3_;
	DesktopFolderFolderWindow* _tmp4_;
#line 133 "../src/widgets/ItemView.vala"
	_tmp0_ = self->priv->manager;
#line 133 "../src/widgets/ItemView.vala"
	_tmp1_ = desktop_folder_item_manager_get_folder (_tmp0_);
#line 133 "../src/widgets/ItemView.vala"
	_tmp2_ = _tmp1_;
#line 133 "../src/widgets/ItemView.vala"
	_tmp3_ = desktop_folder_folder_manager_get_view (_tmp2_);
#line 133 "../src/widgets/ItemView.vala"
	_tmp4_ = _tmp3_;
#line 133 "../src/widgets/ItemView.vala"
	desktop_folder_folder_window_on_end_editing (_tmp4_);
#line 133 "../src/widgets/ItemView.vala"
	_g_object_unref0 (_tmp4_);
#line 133 "../src/widgets/ItemView.vala"
	_g_object_unref0 (_tmp2_);
#line 904 "ItemView.c"
}

static void
____lambda120__desktop_folder_editable_label_on_stop_editing (DesktopFolderEditableLabel* _sender,
                                                              gpointer self)
{
#line 132 "../src/widgets/ItemView.vala"
	___lambda120_ ((DesktopFolderItemView*) self);
#line 913 "ItemView.c"
}

static void
desktop_folder_item_view_real_create_label (DesktopFolderItemView* self,
                                            const gchar* slabel)
{
	GError* _inner_error0_ = NULL;
#line 114 "../src/widgets/ItemView.vala"
	g_return_if_fail (slabel != NULL);
#line 923 "ItemView.c"
	{
		DesktopFolderEditableLabel* _tmp0_;
		GtkBox* _tmp1_;
		DesktopFolderEditableLabel* _tmp2_;
		DesktopFolderEditableLabel* _tmp3_;
		DesktopFolderEditableLabel* _tmp4_;
		DesktopFolderEditableLabel* _tmp5_;
#line 118 "../src/widgets/ItemView.vala"
		_tmp0_ = desktop_folder_editable_label_new (slabel);
#line 118 "../src/widgets/ItemView.vala"
		g_object_ref_sink (_tmp0_);
#line 118 "../src/widgets/ItemView.vala"
		_g_object_unref0 (self->priv->label);
#line 118 "../src/widgets/ItemView.vala"
		self->priv->label = _tmp0_;
#line 119 "../src/widgets/ItemView.vala"
		_tmp1_ = self->priv->container;
#line 119 "../src/widgets/ItemView.vala"
		_tmp2_ = self->priv->label;
#line 119 "../src/widgets/ItemView.vala"
		gtk_box_pack_end (_tmp1_, (GtkWidget*) _tmp2_, TRUE, TRUE, (guint) 0);
#line 120 "../src/widgets/ItemView.vala"
		desktop_folder_item_view_check_ellipse (self);
#line 122 "../src/widgets/ItemView.vala"
		_tmp3_ = self->priv->label;
#line 122 "../src/widgets/ItemView.vala"
		g_signal_connect_object (_tmp3_, "changed", (GCallback) ____lambda118__desktop_folder_editable_label_changed, self, 0);
#line 129 "../src/widgets/ItemView.vala"
		_tmp4_ = self->priv->label;
#line 129 "../src/widgets/ItemView.vala"
		g_signal_connect_object (_tmp4_, "on-start-editing", (GCallback) ____lambda119__desktop_folder_editable_label_on_start_editing, self, 0);
#line 132 "../src/widgets/ItemView.vala"
		_tmp5_ = self->priv->label;
#line 132 "../src/widgets/ItemView.vala"
		g_signal_connect_object (_tmp5_, "on-stop-editing", (GCallback) ____lambda120__desktop_folder_editable_label_on_stop_editing, self, 0);
#line 959 "ItemView.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		FILE* _tmp6_;
		GError* _tmp7_;
		const gchar* _tmp8_;
		GError* _tmp9_;
		const gchar* _tmp10_;
#line 115 "../src/widgets/ItemView.vala"
		e = _inner_error0_;
#line 115 "../src/widgets/ItemView.vala"
		_inner_error0_ = NULL;
#line 136 "../src/widgets/ItemView.vala"
		_tmp6_ = stderr;
#line 136 "../src/widgets/ItemView.vala"
		_tmp7_ = e;
#line 136 "../src/widgets/ItemView.vala"
		_tmp8_ = _tmp7_->message;
#line 136 "../src/widgets/ItemView.vala"
		fprintf (_tmp6_, "Error: %s\n", _tmp8_);
#line 137 "../src/widgets/ItemView.vala"
		_tmp9_ = e;
#line 137 "../src/widgets/ItemView.vala"
		_tmp10_ = _tmp9_->message;
#line 137 "../src/widgets/ItemView.vala"
		desktop_folder_util_show_error_dialog ("Error", _tmp10_);
#line 115 "../src/widgets/ItemView.vala"
		_g_error_free0 (e);
#line 990 "ItemView.c"
	}
	__finally0:
#line 115 "../src/widgets/ItemView.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 115 "../src/widgets/ItemView.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 115 "../src/widgets/ItemView.vala"
		g_clear_error (&_inner_error0_);
#line 115 "../src/widgets/ItemView.vala"
		return;
#line 1001 "ItemView.c"
	}
}

void
desktop_folder_item_view_create_label (DesktopFolderItemView* self,
                                       const gchar* slabel)
{
	DesktopFolderItemViewClass* _klass_;
#line 114 "../src/widgets/ItemView.vala"
	g_return_if_fail (self != NULL);
#line 114 "../src/widgets/ItemView.vala"
	_klass_ = DESKTOP_FOLDER_ITEM_VIEW_GET_CLASS (self);
#line 114 "../src/widgets/ItemView.vala"
	if (_klass_->create_label) {
#line 114 "../src/widgets/ItemView.vala"
		_klass_->create_label (self, slabel);
#line 1018 "ItemView.c"
	}
}

/**
     * @name rename
     * @description change the label of the item to the new label
     */
void
desktop_folder_item_view_rename (DesktopFolderItemView* self,
                                 const gchar* new_name)
{
	DesktopFolderEditableLabel* _tmp0_;
#line 145 "../src/widgets/ItemView.vala"
	g_return_if_fail (self != NULL);
#line 145 "../src/widgets/ItemView.vala"
	g_return_if_fail (new_name != NULL);
#line 146 "../src/widgets/ItemView.vala"
	_tmp0_ = self->priv->label;
#line 146 "../src/widgets/ItemView.vala"
	desktop_folder_editable_label_set_text (_tmp0_, new_name);
#line 147 "../src/widgets/ItemView.vala"
	desktop_folder_item_view_refresh_icon (self, NULL);
#line 1041 "ItemView.c"
}

/**
     * @name refresh
     * @description refresh the window
     */
void
desktop_folder_item_view_refresh (DesktopFolderItemView* self)
{
	DesktopFolderItemManager* _tmp0_;
	DesktopFolderFolderManager* _tmp1_;
	DesktopFolderFolderManager* _tmp2_;
	DesktopFolderApp* _tmp3_;
	DesktopFolderApp* _tmp4_;
	gboolean _tmp5_;
#line 154 "../src/widgets/ItemView.vala"
	g_return_if_fail (self != NULL);
#line 155 "../src/widgets/ItemView.vala"
	_tmp0_ = self->priv->manager;
#line 155 "../src/widgets/ItemView.vala"
	_tmp1_ = desktop_folder_item_manager_get_folder (_tmp0_);
#line 155 "../src/widgets/ItemView.vala"
	_tmp2_ = _tmp1_;
#line 155 "../src/widgets/ItemView.vala"
	_tmp3_ = desktop_folder_folder_manager_get_application (_tmp2_);
#line 155 "../src/widgets/ItemView.vala"
	_tmp4_ = _tmp3_;
#line 155 "../src/widgets/ItemView.vala"
	_tmp5_ = desktop_folder_app_get_desktop_visibility (_tmp4_);
#line 155 "../src/widgets/ItemView.vala"
	_g_object_unref0 (_tmp4_);
#line 155 "../src/widgets/ItemView.vala"
	_g_object_unref0 (_tmp2_);
#line 155 "../src/widgets/ItemView.vala"
	if (_tmp5_) {
#line 156 "../src/widgets/ItemView.vala"
		desktop_folder_item_view_fade_in (self);
#line 157 "../src/widgets/ItemView.vala"
		gtk_widget_show_all ((GtkWidget*) self);
#line 1081 "ItemView.c"
	}
}

/**
     * @name refresh_icon
     * @description force to refresh the icon imagen shown
     */
void
desktop_folder_item_view_refresh_icon (DesktopFolderItemView* self,
                                       const gchar* forced)
{
	GError* _inner_error0_ = NULL;
#line 165 "../src/widgets/ItemView.vala"
	g_return_if_fail (self != NULL);
#line 1096 "ItemView.c"
	{
		GtkImage* newImage = NULL;
		GtkImage* _tmp7_;
		GtkImage* _tmp10_;
		GtkImage* _tmp11_;
		GtkImage* _tmp12_;
		GtkImage* _tmp13_;
		GtkStyleContext* _tmp14_;
		GtkBox* _tmp15_;
		GtkImage* _tmp16_;
#line 169 "../src/widgets/ItemView.vala"
		if (forced == NULL) {
#line 1109 "ItemView.c"
			GtkImage* _tmp0_;
#line 170 "../src/widgets/ItemView.vala"
			_tmp0_ = desktop_folder_item_view_calculate_icon (self);
#line 170 "../src/widgets/ItemView.vala"
			_g_object_unref0 (newImage);
#line 170 "../src/widgets/ItemView.vala"
			newImage = _tmp0_;
#line 1117 "ItemView.c"
		} else {
			GIcon* gicon = NULL;
			GIcon* _tmp1_;
			DesktopFolderItemManager* _tmp2_;
#line 172 "../src/widgets/ItemView.vala"
			_tmp1_ = g_icon_new_for_string ("folder-open", &_inner_error0_);
#line 172 "../src/widgets/ItemView.vala"
			gicon = _tmp1_;
#line 172 "../src/widgets/ItemView.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 172 "../src/widgets/ItemView.vala"
				_g_object_unref0 (newImage);
#line 1130 "ItemView.c"
				goto __catch0_g_error;
			}
#line 173 "../src/widgets/ItemView.vala"
			_tmp2_ = self->priv->manager;
#line 173 "../src/widgets/ItemView.vala"
			if (desktop_folder_item_manager_is_link (_tmp2_)) {
#line 1137 "ItemView.c"
				GIcon* _tmp3_;
				GtkImage* _tmp4_;
#line 174 "../src/widgets/ItemView.vala"
				_tmp3_ = gicon;
#line 174 "../src/widgets/ItemView.vala"
				_tmp4_ = desktop_folder_item_view_draw_link_mark_gicon (self, _tmp3_);
#line 174 "../src/widgets/ItemView.vala"
				_g_object_unref0 (newImage);
#line 174 "../src/widgets/ItemView.vala"
				newImage = _tmp4_;
#line 1148 "ItemView.c"
			} else {
				GIcon* _tmp5_;
				GtkImage* _tmp6_;
#line 176 "../src/widgets/ItemView.vala"
				_tmp5_ = gicon;
#line 176 "../src/widgets/ItemView.vala"
				_tmp6_ = (GtkImage*) gtk_image_new_from_gicon (_tmp5_, (GtkIconSize) GTK_ICON_SIZE_DIALOG);
#line 176 "../src/widgets/ItemView.vala"
				g_object_ref_sink (_tmp6_);
#line 176 "../src/widgets/ItemView.vala"
				_g_object_unref0 (newImage);
#line 176 "../src/widgets/ItemView.vala"
				newImage = _tmp6_;
#line 1162 "ItemView.c"
			}
#line 169 "../src/widgets/ItemView.vala"
			_g_object_unref0 (gicon);
#line 1166 "ItemView.c"
		}
#line 180 "../src/widgets/ItemView.vala"
		_tmp7_ = self->priv->icon;
#line 180 "../src/widgets/ItemView.vala"
		if (_tmp7_ != NULL) {
#line 1172 "ItemView.c"
			GtkBox* _tmp8_;
			GtkImage* _tmp9_;
#line 181 "../src/widgets/ItemView.vala"
			_tmp8_ = self->priv->container;
#line 181 "../src/widgets/ItemView.vala"
			_tmp9_ = self->priv->icon;
#line 181 "../src/widgets/ItemView.vala"
			gtk_container_remove ((GtkContainer*) _tmp8_, (GtkWidget*) _tmp9_);
#line 1181 "ItemView.c"
		}
#line 184 "../src/widgets/ItemView.vala"
		_tmp10_ = newImage;
#line 184 "../src/widgets/ItemView.vala"
		_tmp11_ = _g_object_ref0 (_tmp10_);
#line 184 "../src/widgets/ItemView.vala"
		_g_object_unref0 (self->priv->icon);
#line 184 "../src/widgets/ItemView.vala"
		self->priv->icon = _tmp11_;
#line 185 "../src/widgets/ItemView.vala"
		_tmp12_ = self->priv->icon;
#line 185 "../src/widgets/ItemView.vala"
		gtk_widget_set_size_request ((GtkWidget*) _tmp12_, DESKTOP_FOLDER_ITEM_VIEW_ICON_WIDTH, DESKTOP_FOLDER_ITEM_VIEW_ICON_WIDTH);
#line 186 "../src/widgets/ItemView.vala"
		_tmp13_ = self->priv->icon;
#line 186 "../src/widgets/ItemView.vala"
		_tmp14_ = gtk_widget_get_style_context ((GtkWidget*) _tmp13_);
#line 186 "../src/widgets/ItemView.vala"
		gtk_style_context_add_class (_tmp14_, "df_icon");
#line 187 "../src/widgets/ItemView.vala"
		_tmp15_ = self->priv->container;
#line 187 "../src/widgets/ItemView.vala"
		_tmp16_ = self->priv->icon;
#line 187 "../src/widgets/ItemView.vala"
		gtk_box_pack_start (_tmp15_, (GtkWidget*) _tmp16_, TRUE, TRUE, (guint) 0);
#line 188 "../src/widgets/ItemView.vala"
		desktop_folder_item_view_refresh (self);
#line 166 "../src/widgets/ItemView.vala"
		_g_object_unref0 (newImage);
#line 1211 "ItemView.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		FILE* _tmp17_;
		GError* _tmp18_;
		const gchar* _tmp19_;
		GError* _tmp20_;
		const gchar* _tmp21_;
#line 166 "../src/widgets/ItemView.vala"
		e = _inner_error0_;
#line 166 "../src/widgets/ItemView.vala"
		_inner_error0_ = NULL;
#line 190 "../src/widgets/ItemView.vala"
		_tmp17_ = stderr;
#line 190 "../src/widgets/ItemView.vala"
		_tmp18_ = e;
#line 190 "../src/widgets/ItemView.vala"
		_tmp19_ = _tmp18_->message;
#line 190 "../src/widgets/ItemView.vala"
		fprintf (_tmp17_, "Error: %s\n", _tmp19_);
#line 191 "../src/widgets/ItemView.vala"
		_tmp20_ = e;
#line 191 "../src/widgets/ItemView.vala"
		_tmp21_ = _tmp20_->message;
#line 191 "../src/widgets/ItemView.vala"
		desktop_folder_util_show_error_dialog ("Error", _tmp21_);
#line 166 "../src/widgets/ItemView.vala"
		_g_error_free0 (e);
#line 1242 "ItemView.c"
	}
	__finally0:
#line 166 "../src/widgets/ItemView.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 166 "../src/widgets/ItemView.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 166 "../src/widgets/ItemView.vala"
		g_clear_error (&_inner_error0_);
#line 166 "../src/widgets/ItemView.vala"
		return;
#line 1253 "ItemView.c"
	}
}

/**
     * @name force_opened_folder_icon
     * @description put the folder-open icon over the item
     */
void
desktop_folder_item_view_force_opened_folder_icon (DesktopFolderItemView* self)
{
#line 199 "../src/widgets/ItemView.vala"
	g_return_if_fail (self != NULL);
#line 200 "../src/widgets/ItemView.vala"
	desktop_folder_item_view_refresh_icon (self, "folder-open");
#line 1268 "ItemView.c"
}

/**
     * @return the image icon
     */
GtkImage*
desktop_folder_item_view_get_image (DesktopFolderItemView* self)
{
	GtkImage* _tmp0_;
	GtkImage* _tmp1_;
	GtkImage* result;
#line 206 "../src/widgets/ItemView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 207 "../src/widgets/ItemView.vala"
	_tmp0_ = self->priv->icon;
#line 207 "../src/widgets/ItemView.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 207 "../src/widgets/ItemView.vala"
	result = _tmp1_;
#line 207 "../src/widgets/ItemView.vala"
	return result;
#line 1290 "ItemView.c"
}

/**
     * @name calculate_icon
     * @description calculate the icon image to show
     * @return Gtk.Image the image to be shown
     */
static GtkImage*
desktop_folder_item_view_calculate_icon (DesktopFolderItemView* self)
{
	GError* _inner_error0_ = NULL;
	GtkImage* result;
#line 215 "../src/widgets/ItemView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1305 "ItemView.c"
	{
		GtkImage* icon = NULL;
		GFileInfo* fileInfo = NULL;
		DesktopFolderItemManager* _tmp0_;
		GFile* _tmp1_;
		GFile* _tmp2_;
		GFileInfo* _tmp3_;
		GFileInfo* _tmp4_;
		gboolean _tmp5_ = FALSE;
		DesktopFolderItemManager* _tmp6_;
		DesktopFolderItemSettings* _tmp7_;
		DesktopFolderItemSettings* _tmp8_;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		gboolean _tmp11_;
#line 218 "../src/widgets/ItemView.vala"
		_tmp0_ = self->priv->manager;
#line 218 "../src/widgets/ItemView.vala"
		_tmp1_ = desktop_folder_dragn_drop_dnd_view_get_file ((DesktopFolderDragnDropDndView*) _tmp0_);
#line 218 "../src/widgets/ItemView.vala"
		_tmp2_ = _tmp1_;
#line 218 "../src/widgets/ItemView.vala"
		_tmp3_ = g_file_query_info (_tmp2_, "standard::icon", G_FILE_QUERY_INFO_NONE, NULL, &_inner_error0_);
#line 218 "../src/widgets/ItemView.vala"
		_tmp4_ = _tmp3_;
#line 218 "../src/widgets/ItemView.vala"
		_g_object_unref0 (_tmp2_);
#line 218 "../src/widgets/ItemView.vala"
		fileInfo = _tmp4_;
#line 218 "../src/widgets/ItemView.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 218 "../src/widgets/ItemView.vala"
			_g_object_unref0 (icon);
#line 1339 "ItemView.c"
			goto __catch0_g_error;
		}
#line 219 "../src/widgets/ItemView.vala"
		_tmp6_ = self->priv->manager;
#line 219 "../src/widgets/ItemView.vala"
		_tmp7_ = desktop_folder_item_manager_get_settings (_tmp6_);
#line 219 "../src/widgets/ItemView.vala"
		_tmp8_ = _tmp7_;
#line 219 "../src/widgets/ItemView.vala"
		_tmp9_ = desktop_folder_item_settings_get_icon (_tmp8_);
#line 219 "../src/widgets/ItemView.vala"
		_tmp10_ = _tmp9_;
#line 219 "../src/widgets/ItemView.vala"
		_tmp11_ = _tmp10_ != NULL;
#line 219 "../src/widgets/ItemView.vala"
		_g_object_unref0 (_tmp8_);
#line 219 "../src/widgets/ItemView.vala"
		if (_tmp11_) {
#line 1358 "ItemView.c"
			DesktopFolderItemManager* _tmp12_;
			DesktopFolderItemSettings* _tmp13_;
			DesktopFolderItemSettings* _tmp14_;
			const gchar* _tmp15_;
			const gchar* _tmp16_;
			gint _tmp17_;
			gint _tmp18_;
#line 219 "../src/widgets/ItemView.vala"
			_tmp12_ = self->priv->manager;
#line 219 "../src/widgets/ItemView.vala"
			_tmp13_ = desktop_folder_item_manager_get_settings (_tmp12_);
#line 219 "../src/widgets/ItemView.vala"
			_tmp14_ = _tmp13_;
#line 219 "../src/widgets/ItemView.vala"
			_tmp15_ = desktop_folder_item_settings_get_icon (_tmp14_);
#line 219 "../src/widgets/ItemView.vala"
			_tmp16_ = _tmp15_;
#line 219 "../src/widgets/ItemView.vala"
			_tmp17_ = strlen (_tmp16_);
#line 219 "../src/widgets/ItemView.vala"
			_tmp18_ = _tmp17_;
#line 219 "../src/widgets/ItemView.vala"
			_tmp5_ = _tmp18_ > 0;
#line 219 "../src/widgets/ItemView.vala"
			_g_object_unref0 (_tmp14_);
#line 1384 "ItemView.c"
		} else {
#line 219 "../src/widgets/ItemView.vala"
			_tmp5_ = FALSE;
#line 1388 "ItemView.c"
		}
#line 219 "../src/widgets/ItemView.vala"
		if (_tmp5_) {
#line 1392 "ItemView.c"
			gint scale = 0;
			GdkPixbuf* custom = NULL;
			DesktopFolderItemManager* _tmp19_;
			DesktopFolderItemSettings* _tmp20_;
			DesktopFolderItemSettings* _tmp21_;
			const gchar* _tmp22_;
			const gchar* _tmp23_;
			GdkPixbuf* _tmp24_;
			GdkPixbuf* _tmp25_;
			DesktopFolderItemManager* _tmp26_;
#line 221 "../src/widgets/ItemView.vala"
			scale = DESKTOP_FOLDER_ICON_SIZE;
#line 222 "../src/widgets/ItemView.vala"
			_tmp19_ = self->priv->manager;
#line 222 "../src/widgets/ItemView.vala"
			_tmp20_ = desktop_folder_item_manager_get_settings (_tmp19_);
#line 222 "../src/widgets/ItemView.vala"
			_tmp21_ = _tmp20_;
#line 222 "../src/widgets/ItemView.vala"
			_tmp22_ = desktop_folder_item_settings_get_icon (_tmp21_);
#line 222 "../src/widgets/ItemView.vala"
			_tmp23_ = _tmp22_;
#line 222 "../src/widgets/ItemView.vala"
			_tmp24_ = gdk_pixbuf_new_from_file_at_scale (_tmp23_, scale, scale, TRUE, &_inner_error0_);
#line 222 "../src/widgets/ItemView.vala"
			_tmp25_ = _tmp24_;
#line 222 "../src/widgets/ItemView.vala"
			_g_object_unref0 (_tmp21_);
#line 222 "../src/widgets/ItemView.vala"
			custom = _tmp25_;
#line 222 "../src/widgets/ItemView.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 222 "../src/widgets/ItemView.vala"
				_g_object_unref0 (fileInfo);
#line 222 "../src/widgets/ItemView.vala"
				_g_object_unref0 (icon);
#line 1429 "ItemView.c"
				goto __catch0_g_error;
			}
#line 224 "../src/widgets/ItemView.vala"
			_tmp26_ = self->priv->manager;
#line 224 "../src/widgets/ItemView.vala"
			if (desktop_folder_item_manager_is_link (_tmp26_)) {
#line 1436 "ItemView.c"
				GdkPixbuf* _tmp27_;
				GtkImage* _tmp28_;
#line 225 "../src/widgets/ItemView.vala"
				_tmp27_ = custom;
#line 225 "../src/widgets/ItemView.vala"
				_tmp28_ = desktop_folder_item_view_draw_link_mark_pixbuf (self, _tmp27_);
#line 225 "../src/widgets/ItemView.vala"
				_g_object_unref0 (icon);
#line 225 "../src/widgets/ItemView.vala"
				icon = _tmp28_;
#line 1447 "ItemView.c"
			} else {
				GdkPixbuf* _tmp29_;
				GtkImage* _tmp30_;
#line 227 "../src/widgets/ItemView.vala"
				_tmp29_ = custom;
#line 227 "../src/widgets/ItemView.vala"
				_tmp30_ = (GtkImage*) gtk_image_new_from_pixbuf (_tmp29_);
#line 227 "../src/widgets/ItemView.vala"
				g_object_ref_sink (_tmp30_);
#line 227 "../src/widgets/ItemView.vala"
				_g_object_unref0 (icon);
#line 227 "../src/widgets/ItemView.vala"
				icon = _tmp30_;
#line 1461 "ItemView.c"
			}
#line 219 "../src/widgets/ItemView.vala"
			_g_object_unref0 (custom);
#line 1465 "ItemView.c"
		} else {
			DesktopFolderItemManager* _tmp31_;
#line 231 "../src/widgets/ItemView.vala"
			_tmp31_ = self->priv->manager;
#line 231 "../src/widgets/ItemView.vala"
			if (!desktop_folder_item_manager_check_exist_cached (_tmp31_)) {
#line 1472 "ItemView.c"
				GThemedIcon* themed = NULL;
				GThemedIcon* _tmp32_;
				GtkIconInfo* info = NULL;
				GtkIconTheme* _tmp33_;
				GThemedIcon* _tmp34_;
				GtkIconInfo* _tmp35_;
				GdkPixbuf* pixbuf = NULL;
				GtkIconInfo* _tmp36_;
				GdkPixbuf* _tmp37_;
				GdkPixbuf* _tmp38_;
				gint _tmp39_;
				gint _tmp40_;
				GdkPixbuf* _tmp43_;
				GtkImage* _tmp44_;
#line 233 "../src/widgets/ItemView.vala"
				_tmp32_ = (GThemedIcon*) g_themed_icon_new_with_default_fallbacks ("text-x-generic");
#line 233 "../src/widgets/ItemView.vala"
				themed = _tmp32_;
#line 234 "../src/widgets/ItemView.vala"
				_tmp33_ = gtk_icon_theme_get_default ();
#line 234 "../src/widgets/ItemView.vala"
				_tmp34_ = themed;
#line 234 "../src/widgets/ItemView.vala"
				_tmp35_ = gtk_icon_theme_lookup_by_gicon (_tmp33_, (GIcon*) _tmp34_, DESKTOP_FOLDER_ITEM_VIEW_ICON_WIDTH, 0);
#line 234 "../src/widgets/ItemView.vala"
				info = _tmp35_;
#line 235 "../src/widgets/ItemView.vala"
				_tmp36_ = info;
#line 235 "../src/widgets/ItemView.vala"
				_tmp37_ = gtk_icon_info_load_icon (_tmp36_, &_inner_error0_);
#line 235 "../src/widgets/ItemView.vala"
				pixbuf = _tmp37_;
#line 235 "../src/widgets/ItemView.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 235 "../src/widgets/ItemView.vala"
					_g_object_unref0 (info);
#line 235 "../src/widgets/ItemView.vala"
					_g_object_unref0 (themed);
#line 235 "../src/widgets/ItemView.vala"
					_g_object_unref0 (fileInfo);
#line 235 "../src/widgets/ItemView.vala"
					_g_object_unref0 (icon);
#line 1515 "ItemView.c"
					goto __catch0_g_error;
				}
#line 236 "../src/widgets/ItemView.vala"
				_tmp38_ = pixbuf;
#line 236 "../src/widgets/ItemView.vala"
				_tmp39_ = gdk_pixbuf_get_height (_tmp38_);
#line 236 "../src/widgets/ItemView.vala"
				_tmp40_ = _tmp39_;
#line 236 "../src/widgets/ItemView.vala"
				if (_tmp40_ != DESKTOP_FOLDER_ITEM_VIEW_ICON_WIDTH) {
#line 1526 "ItemView.c"
					GdkPixbuf* _tmp41_;
					GdkPixbuf* _tmp42_;
#line 238 "../src/widgets/ItemView.vala"
					_tmp41_ = pixbuf;
#line 238 "../src/widgets/ItemView.vala"
					_tmp42_ = gdk_pixbuf_scale_simple (_tmp41_, DESKTOP_FOLDER_ITEM_VIEW_ICON_WIDTH, DESKTOP_FOLDER_ITEM_VIEW_ICON_WIDTH, GDK_INTERP_BILINEAR);
#line 238 "../src/widgets/ItemView.vala"
					_g_object_unref0 (pixbuf);
#line 238 "../src/widgets/ItemView.vala"
					pixbuf = _tmp42_;
#line 1537 "ItemView.c"
				}
#line 241 "../src/widgets/ItemView.vala"
				_tmp43_ = pixbuf;
#line 241 "../src/widgets/ItemView.vala"
				_tmp44_ = desktop_folder_item_view_draw_not_exist_mark_pixbuf (self, _tmp43_);
#line 241 "../src/widgets/ItemView.vala"
				_g_object_unref0 (icon);
#line 241 "../src/widgets/ItemView.vala"
				icon = _tmp44_;
#line 231 "../src/widgets/ItemView.vala"
				_g_object_unref0 (pixbuf);
#line 231 "../src/widgets/ItemView.vala"
				_g_object_unref0 (info);
#line 231 "../src/widgets/ItemView.vala"
				_g_object_unref0 (themed);
#line 1553 "ItemView.c"
			} else {
				DesktopFolderItemManager* _tmp45_;
#line 243 "../src/widgets/ItemView.vala"
				_tmp45_ = self->priv->manager;
#line 243 "../src/widgets/ItemView.vala"
				if (desktop_folder_item_manager_is_desktop_file (_tmp45_)) {
#line 1560 "ItemView.c"
					GDesktopAppInfo* desktopApp = NULL;
					DesktopFolderItemManager* _tmp46_;
					gchar* _tmp47_;
					gchar* _tmp48_;
					GDesktopAppInfo* _tmp49_;
					GDesktopAppInfo* _tmp50_;
					GIcon* gicon = NULL;
					GDesktopAppInfo* _tmp51_;
					GIcon* _tmp52_;
					GIcon* _tmp53_;
					DesktopFolderItemManager* _tmp54_;
#line 244 "../src/widgets/ItemView.vala"
					_tmp46_ = self->priv->manager;
#line 244 "../src/widgets/ItemView.vala"
					_tmp47_ = desktop_folder_item_manager_get_absolute_path (_tmp46_);
#line 244 "../src/widgets/ItemView.vala"
					_tmp48_ = _tmp47_;
#line 244 "../src/widgets/ItemView.vala"
					_tmp49_ = g_desktop_app_info_new_from_filename (_tmp48_);
#line 244 "../src/widgets/ItemView.vala"
					_tmp50_ = _tmp49_;
#line 244 "../src/widgets/ItemView.vala"
					_g_free0 (_tmp48_);
#line 244 "../src/widgets/ItemView.vala"
					desktopApp = _tmp50_;
#line 245 "../src/widgets/ItemView.vala"
					_tmp51_ = desktopApp;
#line 245 "../src/widgets/ItemView.vala"
					_tmp52_ = g_app_info_get_icon ((GAppInfo*) _tmp51_);
#line 245 "../src/widgets/ItemView.vala"
					_tmp53_ = _g_object_ref0 (_tmp52_);
#line 245 "../src/widgets/ItemView.vala"
					gicon = _tmp53_;
#line 246 "../src/widgets/ItemView.vala"
					_tmp54_ = self->priv->manager;
#line 246 "../src/widgets/ItemView.vala"
					if (desktop_folder_item_manager_is_link (_tmp54_)) {
#line 1598 "ItemView.c"
						GIcon* _tmp55_;
						GtkImage* _tmp56_;
#line 247 "../src/widgets/ItemView.vala"
						_tmp55_ = gicon;
#line 247 "../src/widgets/ItemView.vala"
						_tmp56_ = desktop_folder_item_view_draw_link_mark_gicon (self, _tmp55_);
#line 247 "../src/widgets/ItemView.vala"
						_g_object_unref0 (icon);
#line 247 "../src/widgets/ItemView.vala"
						icon = _tmp56_;
#line 1609 "ItemView.c"
					} else {
						GThemedIcon* themed = NULL;
						GIcon* _tmp57_;
						gchar* _tmp58_;
						gchar* _tmp59_;
						GThemedIcon* _tmp60_;
						GThemedIcon* _tmp61_;
						GtkIconInfo* info = NULL;
						GtkIconTheme* _tmp62_;
						GThemedIcon* _tmp63_;
						GtkIconInfo* _tmp64_;
						GdkPixbuf* pixbuf = NULL;
						GtkIconInfo* _tmp65_;
						GdkPixbuf* _tmp77_;
						gint _tmp78_;
						gint _tmp79_;
#line 249 "../src/widgets/ItemView.vala"
						_tmp57_ = gicon;
#line 249 "../src/widgets/ItemView.vala"
						_tmp58_ = g_icon_to_string (_tmp57_);
#line 249 "../src/widgets/ItemView.vala"
						_tmp59_ = _tmp58_;
#line 249 "../src/widgets/ItemView.vala"
						_tmp60_ = (GThemedIcon*) g_themed_icon_new_with_default_fallbacks (_tmp59_);
#line 249 "../src/widgets/ItemView.vala"
						_tmp61_ = _tmp60_;
#line 249 "../src/widgets/ItemView.vala"
						_g_free0 (_tmp59_);
#line 249 "../src/widgets/ItemView.vala"
						themed = _tmp61_;
#line 250 "../src/widgets/ItemView.vala"
						_tmp62_ = gtk_icon_theme_get_default ();
#line 250 "../src/widgets/ItemView.vala"
						_tmp63_ = themed;
#line 250 "../src/widgets/ItemView.vala"
						_tmp64_ = gtk_icon_theme_lookup_by_gicon (_tmp62_, (GIcon*) _tmp63_, DESKTOP_FOLDER_ITEM_VIEW_ICON_WIDTH, 0);
#line 250 "../src/widgets/ItemView.vala"
						info = _tmp64_;
#line 251 "../src/widgets/ItemView.vala"
						pixbuf = NULL;
#line 252 "../src/widgets/ItemView.vala"
						_tmp65_ = info;
#line 252 "../src/widgets/ItemView.vala"
						if (_tmp65_ == NULL) {
#line 1654 "ItemView.c"
							GdkPixbuf* _tmp66_ = NULL;
							GIcon* _tmp67_;
							gchar* _tmp68_;
							gchar* _tmp69_;
							GdkPixbuf* _tmp70_;
							GdkPixbuf* _tmp71_;
							GdkPixbuf* _tmp72_;
#line 254 "../src/widgets/ItemView.vala"
							_tmp67_ = gicon;
#line 254 "../src/widgets/ItemView.vala"
							_tmp68_ = g_icon_to_string (_tmp67_);
#line 254 "../src/widgets/ItemView.vala"
							_tmp69_ = _tmp68_;
#line 254 "../src/widgets/ItemView.vala"
							_tmp70_ = gdk_pixbuf_new_from_file_at_scale (_tmp69_, DESKTOP_FOLDER_ITEM_VIEW_ICON_WIDTH, DESKTOP_FOLDER_ITEM_VIEW_ICON_WIDTH, TRUE, &_inner_error0_);
#line 254 "../src/widgets/ItemView.vala"
							_tmp71_ = _tmp70_;
#line 254 "../src/widgets/ItemView.vala"
							_g_free0 (_tmp69_);
#line 254 "../src/widgets/ItemView.vala"
							_tmp66_ = _tmp71_;
#line 254 "../src/widgets/ItemView.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 254 "../src/widgets/ItemView.vala"
								_g_object_unref0 (pixbuf);
#line 254 "../src/widgets/ItemView.vala"
								_g_object_unref0 (info);
#line 254 "../src/widgets/ItemView.vala"
								_g_object_unref0 (themed);
#line 254 "../src/widgets/ItemView.vala"
								_g_object_unref0 (gicon);
#line 254 "../src/widgets/ItemView.vala"
								_g_object_unref0 (desktopApp);
#line 254 "../src/widgets/ItemView.vala"
								_g_object_unref0 (fileInfo);
#line 254 "../src/widgets/ItemView.vala"
								_g_object_unref0 (icon);
#line 1692 "ItemView.c"
								goto __catch0_g_error;
							}
#line 254 "../src/widgets/ItemView.vala"
							_tmp72_ = _tmp66_;
#line 254 "../src/widgets/ItemView.vala"
							_tmp66_ = NULL;
#line 254 "../src/widgets/ItemView.vala"
							_g_object_unref0 (pixbuf);
#line 254 "../src/widgets/ItemView.vala"
							pixbuf = _tmp72_;
#line 252 "../src/widgets/ItemView.vala"
							_g_object_unref0 (_tmp66_);
#line 1705 "ItemView.c"
						} else {
							GdkPixbuf* _tmp73_ = NULL;
							GtkIconInfo* _tmp74_;
							GdkPixbuf* _tmp75_;
							GdkPixbuf* _tmp76_;
#line 256 "../src/widgets/ItemView.vala"
							_tmp74_ = info;
#line 256 "../src/widgets/ItemView.vala"
							_tmp75_ = gtk_icon_info_load_icon (_tmp74_, &_inner_error0_);
#line 256 "../src/widgets/ItemView.vala"
							_tmp73_ = _tmp75_;
#line 256 "../src/widgets/ItemView.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 256 "../src/widgets/ItemView.vala"
								_g_object_unref0 (pixbuf);
#line 256 "../src/widgets/ItemView.vala"
								_g_object_unref0 (info);
#line 256 "../src/widgets/ItemView.vala"
								_g_object_unref0 (themed);
#line 256 "../src/widgets/ItemView.vala"
								_g_object_unref0 (gicon);
#line 256 "../src/widgets/ItemView.vala"
								_g_object_unref0 (desktopApp);
#line 256 "../src/widgets/ItemView.vala"
								_g_object_unref0 (fileInfo);
#line 256 "../src/widgets/ItemView.vala"
								_g_object_unref0 (icon);
#line 1733 "ItemView.c"
								goto __catch0_g_error;
							}
#line 256 "../src/widgets/ItemView.vala"
							_tmp76_ = _tmp73_;
#line 256 "../src/widgets/ItemView.vala"
							_tmp73_ = NULL;
#line 256 "../src/widgets/ItemView.vala"
							_g_object_unref0 (pixbuf);
#line 256 "../src/widgets/ItemView.vala"
							pixbuf = _tmp76_;
#line 252 "../src/widgets/ItemView.vala"
							_g_object_unref0 (_tmp73_);
#line 1746 "ItemView.c"
						}
#line 259 "../src/widgets/ItemView.vala"
						_tmp77_ = pixbuf;
#line 259 "../src/widgets/ItemView.vala"
						_tmp78_ = gdk_pixbuf_get_height (_tmp77_);
#line 259 "../src/widgets/ItemView.vala"
						_tmp79_ = _tmp78_;
#line 259 "../src/widgets/ItemView.vala"
						if (_tmp79_ != DESKTOP_FOLDER_ITEM_VIEW_ICON_WIDTH) {
#line 1756 "ItemView.c"
							GdkPixbuf* _tmp80_;
							GdkPixbuf* _tmp81_;
							GdkPixbuf* _tmp82_;
							GtkImage* _tmp83_;
#line 261 "../src/widgets/ItemView.vala"
							_tmp80_ = pixbuf;
#line 261 "../src/widgets/ItemView.vala"
							_tmp81_ = gdk_pixbuf_scale_simple (_tmp80_, DESKTOP_FOLDER_ITEM_VIEW_ICON_WIDTH, DESKTOP_FOLDER_ITEM_VIEW_ICON_WIDTH, GDK_INTERP_BILINEAR);
#line 261 "../src/widgets/ItemView.vala"
							_g_object_unref0 (pixbuf);
#line 261 "../src/widgets/ItemView.vala"
							pixbuf = _tmp81_;
#line 262 "../src/widgets/ItemView.vala"
							_tmp82_ = pixbuf;
#line 262 "../src/widgets/ItemView.vala"
							_tmp83_ = (GtkImage*) gtk_image_new_from_pixbuf (_tmp82_);
#line 262 "../src/widgets/ItemView.vala"
							g_object_ref_sink (_tmp83_);
#line 262 "../src/widgets/ItemView.vala"
							_g_object_unref0 (icon);
#line 262 "../src/widgets/ItemView.vala"
							icon = _tmp83_;
#line 1779 "ItemView.c"
						} else {
							GIcon* _tmp84_;
							GtkImage* _tmp85_;
#line 264 "../src/widgets/ItemView.vala"
							_tmp84_ = gicon;
#line 264 "../src/widgets/ItemView.vala"
							_tmp85_ = (GtkImage*) gtk_image_new_from_gicon (_tmp84_, (GtkIconSize) GTK_ICON_SIZE_DIALOG);
#line 264 "../src/widgets/ItemView.vala"
							g_object_ref_sink (_tmp85_);
#line 264 "../src/widgets/ItemView.vala"
							_g_object_unref0 (icon);
#line 264 "../src/widgets/ItemView.vala"
							icon = _tmp85_;
#line 1793 "ItemView.c"
						}
#line 246 "../src/widgets/ItemView.vala"
						_g_object_unref0 (pixbuf);
#line 246 "../src/widgets/ItemView.vala"
						_g_object_unref0 (info);
#line 246 "../src/widgets/ItemView.vala"
						_g_object_unref0 (themed);
#line 1801 "ItemView.c"
					}
#line 243 "../src/widgets/ItemView.vala"
					_g_object_unref0 (gicon);
#line 243 "../src/widgets/ItemView.vala"
					_g_object_unref0 (desktopApp);
#line 1807 "ItemView.c"
				} else {
					GFileInfo* ctypeInfo = NULL;
					DesktopFolderItemManager* _tmp86_;
					GFile* _tmp87_;
					GFile* _tmp88_;
					GFileInfo* _tmp89_;
					GFileInfo* _tmp90_;
					gchar* contentType = NULL;
					GFileInfo* _tmp91_;
					const gchar* _tmp92_;
					gchar* _tmp93_;
					gchar* mimeType = NULL;
					const gchar* _tmp94_;
					gchar* _tmp95_;
					gboolean isImage = FALSE;
					const gchar* _tmp96_;
					gboolean _tmp97_ = FALSE;
					const gchar* _tmp98_;
#line 268 "../src/widgets/ItemView.vala"
					_tmp86_ = self->priv->manager;
#line 268 "../src/widgets/ItemView.vala"
					_tmp87_ = desktop_folder_dragn_drop_dnd_view_get_file ((DesktopFolderDragnDropDndView*) _tmp86_);
#line 268 "../src/widgets/ItemView.vala"
					_tmp88_ = _tmp87_;
#line 268 "../src/widgets/ItemView.vala"
					_tmp89_ = g_file_query_info (_tmp88_, "standard::content-type", G_FILE_QUERY_INFO_NONE, NULL, &_inner_error0_);
#line 268 "../src/widgets/ItemView.vala"
					_tmp90_ = _tmp89_;
#line 268 "../src/widgets/ItemView.vala"
					_g_object_unref0 (_tmp88_);
#line 268 "../src/widgets/ItemView.vala"
					ctypeInfo = _tmp90_;
#line 268 "../src/widgets/ItemView.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 268 "../src/widgets/ItemView.vala"
						_g_object_unref0 (fileInfo);
#line 268 "../src/widgets/ItemView.vala"
						_g_object_unref0 (icon);
#line 1846 "ItemView.c"
						goto __catch0_g_error;
					}
#line 269 "../src/widgets/ItemView.vala"
					_tmp91_ = ctypeInfo;
#line 269 "../src/widgets/ItemView.vala"
					_tmp92_ = g_file_info_get_content_type (_tmp91_);
#line 269 "../src/widgets/ItemView.vala"
					_tmp93_ = g_strdup (_tmp92_);
#line 269 "../src/widgets/ItemView.vala"
					contentType = _tmp93_;
#line 270 "../src/widgets/ItemView.vala"
					_tmp94_ = contentType;
#line 270 "../src/widgets/ItemView.vala"
					_tmp95_ = g_content_type_get_mime_type (_tmp94_);
#line 270 "../src/widgets/ItemView.vala"
					mimeType = _tmp95_;
#line 271 "../src/widgets/ItemView.vala"
					_tmp96_ = mimeType;
#line 271 "../src/widgets/ItemView.vala"
					isImage = g_content_type_is_a (_tmp96_, "image/*");
#line 272 "../src/widgets/ItemView.vala"
					_tmp98_ = mimeType;
#line 272 "../src/widgets/ItemView.vala"
					if (_tmp98_ != NULL) {
#line 272 "../src/widgets/ItemView.vala"
						_tmp97_ = isImage;
#line 1873 "ItemView.c"
					} else {
#line 272 "../src/widgets/ItemView.vala"
						_tmp97_ = FALSE;
#line 1877 "ItemView.c"
					}
#line 272 "../src/widgets/ItemView.vala"
					if (_tmp97_) {
#line 1881 "ItemView.c"
						gint scale = 0;
						GdkPixbuf* custom = NULL;
						DesktopFolderItemManager* _tmp99_;
						GFile* _tmp100_;
						GFile* _tmp101_;
						gchar* _tmp102_;
						gchar* _tmp103_;
						GdkPixbuf* _tmp104_;
						GdkPixbuf* _tmp105_;
						GdkPixbuf* _tmp106_;
						GdkPixbuf* _tmp107_;
						DesktopFolderItemManager* _tmp108_;
#line 274 "../src/widgets/ItemView.vala"
						scale = DESKTOP_FOLDER_ICON_SIZE;
#line 275 "../src/widgets/ItemView.vala"
						_tmp99_ = self->priv->manager;
#line 275 "../src/widgets/ItemView.vala"
						_tmp100_ = desktop_folder_dragn_drop_dnd_view_get_file ((DesktopFolderDragnDropDndView*) _tmp99_);
#line 275 "../src/widgets/ItemView.vala"
						_tmp101_ = _tmp100_;
#line 275 "../src/widgets/ItemView.vala"
						_tmp102_ = g_file_get_path (_tmp101_);
#line 275 "../src/widgets/ItemView.vala"
						_tmp103_ = _tmp102_;
#line 275 "../src/widgets/ItemView.vala"
						_tmp104_ = gdk_pixbuf_new_from_file (_tmp103_, &_inner_error0_);
#line 275 "../src/widgets/ItemView.vala"
						_tmp105_ = _tmp104_;
#line 275 "../src/widgets/ItemView.vala"
						_g_free0 (_tmp103_);
#line 275 "../src/widgets/ItemView.vala"
						_g_object_unref0 (_tmp101_);
#line 275 "../src/widgets/ItemView.vala"
						custom = _tmp105_;
#line 275 "../src/widgets/ItemView.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 275 "../src/widgets/ItemView.vala"
							_g_free0 (mimeType);
#line 275 "../src/widgets/ItemView.vala"
							_g_free0 (contentType);
#line 275 "../src/widgets/ItemView.vala"
							_g_object_unref0 (ctypeInfo);
#line 275 "../src/widgets/ItemView.vala"
							_g_object_unref0 (fileInfo);
#line 275 "../src/widgets/ItemView.vala"
							_g_object_unref0 (icon);
#line 1928 "ItemView.c"
							goto __catch0_g_error;
						}
#line 276 "../src/widgets/ItemView.vala"
						_tmp106_ = custom;
#line 276 "../src/widgets/ItemView.vala"
						_tmp107_ = gdk_pixbuf_scale_simple (_tmp106_, scale, scale, GDK_INTERP_BILINEAR);
#line 276 "../src/widgets/ItemView.vala"
						_g_object_unref0 (custom);
#line 276 "../src/widgets/ItemView.vala"
						custom = _tmp107_;
#line 277 "../src/widgets/ItemView.vala"
						_tmp108_ = self->priv->manager;
#line 277 "../src/widgets/ItemView.vala"
						if (desktop_folder_item_manager_is_link (_tmp108_)) {
#line 1943 "ItemView.c"
							GdkPixbuf* _tmp109_;
							GtkImage* _tmp110_;
#line 278 "../src/widgets/ItemView.vala"
							_tmp109_ = custom;
#line 278 "../src/widgets/ItemView.vala"
							_tmp110_ = desktop_folder_item_view_draw_link_mark_pixbuf (self, _tmp109_);
#line 278 "../src/widgets/ItemView.vala"
							_g_object_unref0 (icon);
#line 278 "../src/widgets/ItemView.vala"
							icon = _tmp110_;
#line 1954 "ItemView.c"
						} else {
							GdkPixbuf* _tmp111_;
							GtkImage* _tmp112_;
#line 280 "../src/widgets/ItemView.vala"
							_tmp111_ = custom;
#line 280 "../src/widgets/ItemView.vala"
							_tmp112_ = (GtkImage*) gtk_image_new_from_pixbuf (_tmp111_);
#line 280 "../src/widgets/ItemView.vala"
							g_object_ref_sink (_tmp112_);
#line 280 "../src/widgets/ItemView.vala"
							_g_object_unref0 (icon);
#line 280 "../src/widgets/ItemView.vala"
							icon = _tmp112_;
#line 1968 "ItemView.c"
						}
#line 272 "../src/widgets/ItemView.vala"
						_g_object_unref0 (custom);
#line 1972 "ItemView.c"
					} else {
						GIcon* gicon = NULL;
						GFileInfo* _tmp113_;
						GIcon* _tmp114_;
						GIcon* _tmp115_;
						DesktopFolderItemManager* _tmp116_;
#line 284 "../src/widgets/ItemView.vala"
						_tmp113_ = fileInfo;
#line 284 "../src/widgets/ItemView.vala"
						_tmp114_ = g_file_info_get_icon (_tmp113_);
#line 284 "../src/widgets/ItemView.vala"
						_tmp115_ = _g_object_ref0 (_tmp114_);
#line 284 "../src/widgets/ItemView.vala"
						gicon = _tmp115_;
#line 285 "../src/widgets/ItemView.vala"
						_tmp116_ = self->priv->manager;
#line 285 "../src/widgets/ItemView.vala"
						if (desktop_folder_item_manager_is_link (_tmp116_)) {
#line 1991 "ItemView.c"
							GIcon* _tmp117_;
							GtkImage* _tmp118_;
#line 286 "../src/widgets/ItemView.vala"
							_tmp117_ = gicon;
#line 286 "../src/widgets/ItemView.vala"
							_tmp118_ = desktop_folder_item_view_draw_link_mark_gicon (self, _tmp117_);
#line 286 "../src/widgets/ItemView.vala"
							_g_object_unref0 (icon);
#line 286 "../src/widgets/ItemView.vala"
							icon = _tmp118_;
#line 2002 "ItemView.c"
						} else {
							GIcon* _tmp119_;
							GtkImage* _tmp120_;
#line 288 "../src/widgets/ItemView.vala"
							_tmp119_ = gicon;
#line 288 "../src/widgets/ItemView.vala"
							_tmp120_ = (GtkImage*) gtk_image_new_from_gicon (_tmp119_, (GtkIconSize) GTK_ICON_SIZE_DIALOG);
#line 288 "../src/widgets/ItemView.vala"
							g_object_ref_sink (_tmp120_);
#line 288 "../src/widgets/ItemView.vala"
							_g_object_unref0 (icon);
#line 288 "../src/widgets/ItemView.vala"
							icon = _tmp120_;
#line 2016 "ItemView.c"
						}
#line 272 "../src/widgets/ItemView.vala"
						_g_object_unref0 (gicon);
#line 2020 "ItemView.c"
					}
#line 243 "../src/widgets/ItemView.vala"
					_g_free0 (mimeType);
#line 243 "../src/widgets/ItemView.vala"
					_g_free0 (contentType);
#line 243 "../src/widgets/ItemView.vala"
					_g_object_unref0 (ctypeInfo);
#line 2028 "ItemView.c"
				}
			}
		}
#line 293 "../src/widgets/ItemView.vala"
		result = icon;
#line 293 "../src/widgets/ItemView.vala"
		_g_object_unref0 (fileInfo);
#line 293 "../src/widgets/ItemView.vala"
		return result;
#line 2038 "ItemView.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
#line 216 "../src/widgets/ItemView.vala"
		e = _inner_error0_;
#line 216 "../src/widgets/ItemView.vala"
		_inner_error0_ = NULL;
#line 2048 "ItemView.c"
		{
			FILE* _tmp121_;
			GError* _tmp122_;
			const gchar* _tmp123_;
			GtkImage* icon = NULL;
			GtkImage* _tmp124_;
#line 296 "../src/widgets/ItemView.vala"
			_tmp121_ = stderr;
#line 296 "../src/widgets/ItemView.vala"
			_tmp122_ = e;
#line 296 "../src/widgets/ItemView.vala"
			_tmp123_ = _tmp122_->message;
#line 296 "../src/widgets/ItemView.vala"
			fprintf (_tmp121_, "Error: %s\n", _tmp123_);
#line 298 "../src/widgets/ItemView.vala"
			_tmp124_ = (GtkImage*) gtk_image_new_from_icon_name ("image-x-generic", (GtkIconSize) GTK_ICON_SIZE_DIALOG);
#line 298 "../src/widgets/ItemView.vala"
			g_object_ref_sink (_tmp124_);
#line 298 "../src/widgets/ItemView.vala"
			_g_object_unref0 (icon);
#line 298 "../src/widgets/ItemView.vala"
			icon = _tmp124_;
#line 299 "../src/widgets/ItemView.vala"
			result = icon;
#line 299 "../src/widgets/ItemView.vala"
			_g_error_free0 (e);
#line 299 "../src/widgets/ItemView.vala"
			return result;
#line 2077 "ItemView.c"
		}
		goto __finally1;
		__catch1_g_error:
		{
			GError* ee = NULL;
			FILE* _tmp125_;
			GError* _tmp126_;
			const gchar* _tmp127_;
			GError* _tmp128_;
			const gchar* _tmp129_;
#line 295 "../src/widgets/ItemView.vala"
			ee = _inner_error0_;
#line 295 "../src/widgets/ItemView.vala"
			_inner_error0_ = NULL;
#line 301 "../src/widgets/ItemView.vala"
			_tmp125_ = stderr;
#line 301 "../src/widgets/ItemView.vala"
			_tmp126_ = ee;
#line 301 "../src/widgets/ItemView.vala"
			_tmp127_ = _tmp126_->message;
#line 301 "../src/widgets/ItemView.vala"
			fprintf (_tmp125_, "Error: %s\n", _tmp127_);
#line 302 "../src/widgets/ItemView.vala"
			_tmp128_ = ee;
#line 302 "../src/widgets/ItemView.vala"
			_tmp129_ = _tmp128_->message;
#line 302 "../src/widgets/ItemView.vala"
			desktop_folder_util_show_error_dialog ("Error", _tmp129_);
#line 295 "../src/widgets/ItemView.vala"
			_g_error_free0 (ee);
#line 2108 "ItemView.c"
		}
		__finally1:
#line 295 "../src/widgets/ItemView.vala"
		_g_error_free0 (e);
#line 295 "../src/widgets/ItemView.vala"
		g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 295 "../src/widgets/ItemView.vala"
		g_clear_error (&_inner_error0_);
#line 295 "../src/widgets/ItemView.vala"
		return NULL;
#line 2119 "ItemView.c"
	}
	__finally0:
#line 216 "../src/widgets/ItemView.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 216 "../src/widgets/ItemView.vala"
	g_clear_error (&_inner_error0_);
#line 216 "../src/widgets/ItemView.vala"
	return NULL;
#line 2128 "ItemView.c"
}

/**
     * @name draw_not_exist_mark_pixbuf
     * @description draw a CROSS mark to indicate that the file doesn't exist
     * @param pixbuf {Gdk.Pixbuf} the pixbuf to modify
     * @result {Gtk.Image} the image produced
     */
static GtkImage*
desktop_folder_item_view_draw_not_exist_mark_pixbuf (DesktopFolderItemView* self,
                                                     GdkPixbuf* pixbuf)
{
	GError* _inner_error0_ = NULL;
	GtkImage* result;
#line 313 "../src/widgets/ItemView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 313 "../src/widgets/ItemView.vala"
	g_return_val_if_fail (pixbuf != NULL, NULL);
#line 2147 "ItemView.c"
	{
		cairo_surface_t* surface = NULL;
		cairo_surface_t* _tmp0_;
		cairo_t* context = NULL;
		cairo_t* _tmp1_;
		GdkPixbuf* pixbuf2 = NULL;
		GdkPixbuf* _tmp2_;
		GtkImage* icon = NULL;
		GtkImage* _tmp3_;
#line 315 "../src/widgets/ItemView.vala"
		_tmp0_ = gdk_cairo_surface_create_from_pixbuf (pixbuf, 1, NULL);
#line 315 "../src/widgets/ItemView.vala"
		surface = _tmp0_;
#line 316 "../src/widgets/ItemView.vala"
		_tmp1_ = cairo_create (surface);
#line 316 "../src/widgets/ItemView.vala"
		context = _tmp1_;
#line 318 "../src/widgets/ItemView.vala"
		cairo_set_source_rgba (context, (gdouble) 1, (gdouble) 0, (gdouble) 0, (gdouble) 1);
#line 319 "../src/widgets/ItemView.vala"
		cairo_move_to (context, (gdouble) 0, (gdouble) 0);
#line 320 "../src/widgets/ItemView.vala"
		cairo_line_to (context, (gdouble) DESKTOP_FOLDER_ICON_SIZE, (gdouble) DESKTOP_FOLDER_ICON_SIZE);
#line 321 "../src/widgets/ItemView.vala"
		cairo_move_to (context, (gdouble) DESKTOP_FOLDER_ICON_SIZE, (gdouble) 0);
#line 322 "../src/widgets/ItemView.vala"
		cairo_line_to (context, (gdouble) 0, (gdouble) DESKTOP_FOLDER_ICON_SIZE);
#line 323 "../src/widgets/ItemView.vala"
		cairo_stroke (context);
#line 325 "../src/widgets/ItemView.vala"
		_tmp2_ = gdk_pixbuf_get_from_surface (surface, 0, 0, DESKTOP_FOLDER_ICON_SIZE, DESKTOP_FOLDER_ICON_SIZE);
#line 325 "../src/widgets/ItemView.vala"
		pixbuf2 = _tmp2_;
#line 326 "../src/widgets/ItemView.vala"
		_tmp3_ = (GtkImage*) gtk_image_new_from_pixbuf (pixbuf2);
#line 326 "../src/widgets/ItemView.vala"
		g_object_ref_sink (_tmp3_);
#line 326 "../src/widgets/ItemView.vala"
		icon = _tmp3_;
#line 327 "../src/widgets/ItemView.vala"
		result = icon;
#line 327 "../src/widgets/ItemView.vala"
		_g_object_unref0 (pixbuf2);
#line 327 "../src/widgets/ItemView.vala"
		_cairo_destroy0 (context);
#line 327 "../src/widgets/ItemView.vala"
		_cairo_surface_destroy0 (surface);
#line 327 "../src/widgets/ItemView.vala"
		return result;
#line 2197 "ItemView.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		FILE* _tmp4_;
		GError* _tmp5_;
		const gchar* _tmp6_;
		GError* _tmp7_;
		const gchar* _tmp8_;
#line 314 "../src/widgets/ItemView.vala"
		e = _inner_error0_;
#line 314 "../src/widgets/ItemView.vala"
		_inner_error0_ = NULL;
#line 329 "../src/widgets/ItemView.vala"
		_tmp4_ = stderr;
#line 329 "../src/widgets/ItemView.vala"
		_tmp5_ = e;
#line 329 "../src/widgets/ItemView.vala"
		_tmp6_ = _tmp5_->message;
#line 329 "../src/widgets/ItemView.vala"
		fprintf (_tmp4_, "Error: %s\n", _tmp6_);
#line 330 "../src/widgets/ItemView.vala"
		_tmp7_ = e;
#line 330 "../src/widgets/ItemView.vala"
		_tmp8_ = _tmp7_->message;
#line 330 "../src/widgets/ItemView.vala"
		desktop_folder_util_show_error_dialog ("Error", _tmp8_);
#line 314 "../src/widgets/ItemView.vala"
		_g_error_free0 (e);
#line 2228 "ItemView.c"
	}
	__finally0:
#line 314 "../src/widgets/ItemView.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 314 "../src/widgets/ItemView.vala"
	g_clear_error (&_inner_error0_);
#line 314 "../src/widgets/ItemView.vala"
	return NULL;
#line 2237 "ItemView.c"
}

/**
     * @name draw_link_mark_gicon
     * @description draw a link mark over the image of an icon
     * @param gicon {GLib.Icon} the icon we want to modify and add the mark
     * @result {Gtk.Image} the image produced
     */
static GtkImage*
desktop_folder_item_view_draw_link_mark_gicon (DesktopFolderItemView* self,
                                               GIcon* gicon)
{
	gpointer _tmp16_;
	GtkImage* _tmp17_;
	GError* _inner_error0_ = NULL;
	GtkImage* result;
#line 340 "../src/widgets/ItemView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 340 "../src/widgets/ItemView.vala"
	g_return_val_if_fail (gicon != NULL, NULL);
#line 2258 "ItemView.c"
	{
		GtkIconTheme* theme = NULL;
		GtkIconTheme* _tmp0_;
		GtkIconTheme* _tmp1_;
		GtkIconInfo* iconInfo = NULL;
		GtkIconInfo* _tmp2_;
		GdkPixbuf* pixbuf = NULL;
		GdkPixbuf* _tmp3_;
		GdkPixbuf* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		GdkPixbuf* _tmp9_;
		GtkImage* _tmp10_;
#line 342 "../src/widgets/ItemView.vala"
		_tmp0_ = gtk_icon_theme_get_default ();
#line 342 "../src/widgets/ItemView.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 342 "../src/widgets/ItemView.vala"
		theme = _tmp1_;
#line 343 "../src/widgets/ItemView.vala"
		_tmp2_ = gtk_icon_theme_lookup_by_gicon (theme, gicon, DESKTOP_FOLDER_ICON_SIZE, 0);
#line 343 "../src/widgets/ItemView.vala"
		iconInfo = _tmp2_;
#line 344 "../src/widgets/ItemView.vala"
		_tmp3_ = gtk_icon_info_load_icon (iconInfo, &_inner_error0_);
#line 344 "../src/widgets/ItemView.vala"
		pixbuf = _tmp3_;
#line 344 "../src/widgets/ItemView.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 344 "../src/widgets/ItemView.vala"
			_g_object_unref0 (iconInfo);
#line 344 "../src/widgets/ItemView.vala"
			_g_object_unref0 (theme);
#line 2292 "ItemView.c"
			goto __catch0_g_error;
		}
#line 346 "../src/widgets/ItemView.vala"
		_tmp4_ = pixbuf;
#line 346 "../src/widgets/ItemView.vala"
		_tmp5_ = gdk_pixbuf_get_height (_tmp4_);
#line 346 "../src/widgets/ItemView.vala"
		_tmp6_ = _tmp5_;
#line 346 "../src/widgets/ItemView.vala"
		if (_tmp6_ != DESKTOP_FOLDER_ITEM_VIEW_ICON_WIDTH) {
#line 2303 "ItemView.c"
			GdkPixbuf* _tmp7_;
			GdkPixbuf* _tmp8_;
#line 348 "../src/widgets/ItemView.vala"
			_tmp7_ = pixbuf;
#line 348 "../src/widgets/ItemView.vala"
			_tmp8_ = gdk_pixbuf_scale_simple (_tmp7_, DESKTOP_FOLDER_ITEM_VIEW_ICON_WIDTH, DESKTOP_FOLDER_ITEM_VIEW_ICON_WIDTH, GDK_INTERP_BILINEAR);
#line 348 "../src/widgets/ItemView.vala"
			_g_object_unref0 (pixbuf);
#line 348 "../src/widgets/ItemView.vala"
			pixbuf = _tmp8_;
#line 2314 "ItemView.c"
		}
#line 351 "../src/widgets/ItemView.vala"
		_tmp9_ = pixbuf;
#line 351 "../src/widgets/ItemView.vala"
		_tmp10_ = desktop_folder_item_view_draw_link_mark_pixbuf (self, _tmp9_);
#line 351 "../src/widgets/ItemView.vala"
		result = _tmp10_;
#line 351 "../src/widgets/ItemView.vala"
		_g_object_unref0 (pixbuf);
#line 351 "../src/widgets/ItemView.vala"
		_g_object_unref0 (iconInfo);
#line 351 "../src/widgets/ItemView.vala"
		_g_object_unref0 (theme);
#line 351 "../src/widgets/ItemView.vala"
		return result;
#line 2330 "ItemView.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		FILE* _tmp11_;
		GError* _tmp12_;
		const gchar* _tmp13_;
		GError* _tmp14_;
		const gchar* _tmp15_;
#line 341 "../src/widgets/ItemView.vala"
		e = _inner_error0_;
#line 341 "../src/widgets/ItemView.vala"
		_inner_error0_ = NULL;
#line 353 "../src/widgets/ItemView.vala"
		_tmp11_ = stderr;
#line 353 "../src/widgets/ItemView.vala"
		_tmp12_ = e;
#line 353 "../src/widgets/ItemView.vala"
		_tmp13_ = _tmp12_->message;
#line 353 "../src/widgets/ItemView.vala"
		fprintf (_tmp11_, "Error: %s\n", _tmp13_);
#line 354 "../src/widgets/ItemView.vala"
		_tmp14_ = e;
#line 354 "../src/widgets/ItemView.vala"
		_tmp15_ = _tmp14_->message;
#line 354 "../src/widgets/ItemView.vala"
		desktop_folder_util_show_error_dialog ("Error", _tmp15_);
#line 341 "../src/widgets/ItemView.vala"
		_g_error_free0 (e);
#line 2361 "ItemView.c"
	}
	__finally0:
#line 341 "../src/widgets/ItemView.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 341 "../src/widgets/ItemView.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 341 "../src/widgets/ItemView.vala"
		g_clear_error (&_inner_error0_);
#line 341 "../src/widgets/ItemView.vala"
		return NULL;
#line 2372 "ItemView.c"
	}
#line 356 "../src/widgets/ItemView.vala"
	_tmp16_ = NULL;
#line 356 "../src/widgets/ItemView.vala"
	_tmp17_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp16_, gtk_image_get_type ()) ? ((GtkImage*) _tmp16_) : NULL);
#line 356 "../src/widgets/ItemView.vala"
	result = _tmp17_;
#line 356 "../src/widgets/ItemView.vala"
	return result;
#line 2382 "ItemView.c"
}

/**
     * @name draw_link_mark_pixbuf
     * @description draw a link mark over a pixbuf
     * @param pixbuf {Gdk.Pixbuf} the pixbuf to modify
     * @result {Gtk.Image} the image produced
     */
static GtkImage*
desktop_folder_item_view_draw_link_mark_pixbuf (DesktopFolderItemView* self,
                                                GdkPixbuf* pixbuf)
{
	GError* _inner_error0_ = NULL;
	GtkImage* result;
#line 365 "../src/widgets/ItemView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 365 "../src/widgets/ItemView.vala"
	g_return_val_if_fail (pixbuf != NULL, NULL);
#line 2401 "ItemView.c"
	{
		cairo_surface_t* surface = NULL;
		cairo_surface_t* _tmp0_;
		cairo_t* context = NULL;
		cairo_t* _tmp1_;
		gint scale = 0;
		cairo_surface_t* links = NULL;
		GdkPixbuf* _tmp2_;
		cairo_surface_t* _tmp3_;
		GdkPixbuf* pixbuf2 = NULL;
		GdkPixbuf* _tmp4_;
		GtkImage* icon = NULL;
		GtkImage* _tmp5_;
#line 367 "../src/widgets/ItemView.vala"
		_tmp0_ = gdk_cairo_surface_create_from_pixbuf (pixbuf, 1, NULL);
#line 367 "../src/widgets/ItemView.vala"
		surface = _tmp0_;
#line 368 "../src/widgets/ItemView.vala"
		_tmp1_ = cairo_create (surface);
#line 368 "../src/widgets/ItemView.vala"
		context = _tmp1_;
#line 370 "../src/widgets/ItemView.vala"
		scale = DESKTOP_FOLDER_ICON_SIZE / 3;
#line 371 "../src/widgets/ItemView.vala"
		_tmp2_ = desktop_folder_item_view_LINK_PIXBUF;
#line 371 "../src/widgets/ItemView.vala"
		_tmp3_ = gdk_cairo_surface_create_from_pixbuf (_tmp2_, 1, NULL);
#line 371 "../src/widgets/ItemView.vala"
		links = _tmp3_;
#line 372 "../src/widgets/ItemView.vala"
		cairo_set_source_surface (context, links, (gdouble) (DESKTOP_FOLDER_ICON_SIZE - scale), (gdouble) (DESKTOP_FOLDER_ICON_SIZE - scale));
#line 373 "../src/widgets/ItemView.vala"
		cairo_paint (context);
#line 375 "../src/widgets/ItemView.vala"
		_tmp4_ = gdk_pixbuf_get_from_surface (surface, 0, 0, DESKTOP_FOLDER_ICON_SIZE, DESKTOP_FOLDER_ICON_SIZE);
#line 375 "../src/widgets/ItemView.vala"
		pixbuf2 = _tmp4_;
#line 376 "../src/widgets/ItemView.vala"
		_tmp5_ = (GtkImage*) gtk_image_new_from_pixbuf (pixbuf2);
#line 376 "../src/widgets/ItemView.vala"
		g_object_ref_sink (_tmp5_);
#line 376 "../src/widgets/ItemView.vala"
		icon = _tmp5_;
#line 377 "../src/widgets/ItemView.vala"
		result = icon;
#line 377 "../src/widgets/ItemView.vala"
		_g_object_unref0 (pixbuf2);
#line 377 "../src/widgets/ItemView.vala"
		_cairo_surface_destroy0 (links);
#line 377 "../src/widgets/ItemView.vala"
		_cairo_destroy0 (context);
#line 377 "../src/widgets/ItemView.vala"
		_cairo_surface_destroy0 (surface);
#line 377 "../src/widgets/ItemView.vala"
		return result;
#line 2457 "ItemView.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		FILE* _tmp6_;
		GError* _tmp7_;
		const gchar* _tmp8_;
		GError* _tmp9_;
		const gchar* _tmp10_;
#line 366 "../src/widgets/ItemView.vala"
		e = _inner_error0_;
#line 366 "../src/widgets/ItemView.vala"
		_inner_error0_ = NULL;
#line 379 "../src/widgets/ItemView.vala"
		_tmp6_ = stderr;
#line 379 "../src/widgets/ItemView.vala"
		_tmp7_ = e;
#line 379 "../src/widgets/ItemView.vala"
		_tmp8_ = _tmp7_->message;
#line 379 "../src/widgets/ItemView.vala"
		fprintf (_tmp6_, "Error: %s\n", _tmp8_);
#line 380 "../src/widgets/ItemView.vala"
		_tmp9_ = e;
#line 380 "../src/widgets/ItemView.vala"
		_tmp10_ = _tmp9_->message;
#line 380 "../src/widgets/ItemView.vala"
		desktop_folder_util_show_error_dialog ("Error", _tmp10_);
#line 366 "../src/widgets/ItemView.vala"
		_g_error_free0 (e);
#line 2488 "ItemView.c"
	}
	__finally0:
#line 366 "../src/widgets/ItemView.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 366 "../src/widgets/ItemView.vala"
	g_clear_error (&_inner_error0_);
#line 366 "../src/widgets/ItemView.vala"
	return NULL;
#line 2497 "ItemView.c"
}

/**
     * @name get_correct_label
     * @description return the correct label to be shown
     */
static gint
string_index_of (const gchar* self,
                 const gchar* needle,
                 gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result;
#line 1149 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1149 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, 0);
#line 1150 "glib-2.0.vapi"
	_tmp0_ = strstr (((gchar*) self) + start_index, (gchar*) needle);
#line 1150 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1152 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1152 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 2525 "ItemView.c"
		gchar* _tmp2_;
#line 1153 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1153 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1153 "glib-2.0.vapi"
		return result;
#line 2533 "ItemView.c"
	} else {
#line 1155 "glib-2.0.vapi"
		result = -1;
#line 1155 "glib-2.0.vapi"
		return result;
#line 2539 "ItemView.c"
	}
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1466 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1466 "glib-2.0.vapi"
	end = _tmp0_;
#line 1467 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1467 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1468 "glib-2.0.vapi"
		result = maxlen;
#line 1468 "glib-2.0.vapi"
		return result;
#line 2563 "ItemView.c"
	} else {
		gchar* _tmp2_;
#line 1470 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1470 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1470 "glib-2.0.vapi"
		return result;
#line 2572 "ItemView.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1477 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1479 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1479 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 2591 "ItemView.c"
	} else {
#line 1479 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 2595 "ItemView.c"
	}
#line 1479 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1481 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 2601 "ItemView.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1483 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1483 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1483 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 2611 "ItemView.c"
	}
#line 1486 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1487 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1488 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 2619 "ItemView.c"
	} else {
#line 1490 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 2623 "ItemView.c"
	}
#line 1492 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1493 "glib-2.0.vapi"
		len = string_length - offset;
#line 2629 "ItemView.c"
	}
#line 1495 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1496 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1496 "glib-2.0.vapi"
	result = _tmp3_;
#line 1496 "glib-2.0.vapi"
	return result;
#line 2639 "ItemView.c"
}

static gchar*
desktop_folder_item_view_get_correct_label (DesktopFolderItemView* self,
                                            const gchar* file_name)
{
	gchar* result;
#line 388 "../src/widgets/ItemView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 388 "../src/widgets/ItemView.vala"
	g_return_val_if_fail (file_name != NULL, NULL);
#line 389 "../src/widgets/ItemView.vala"
	if (self->priv->hide_extension) {
#line 2653 "ItemView.c"
		gint index = 0;
		gchar* _tmp2_;
		gchar* _tmp3_;
#line 390 "../src/widgets/ItemView.vala"
		index = string_index_of (file_name, ".", 0);
#line 391 "../src/widgets/ItemView.vala"
		if (index > 0) {
#line 2661 "ItemView.c"
			gchar* _tmp0_;
			gchar* _tmp1_;
#line 392 "../src/widgets/ItemView.vala"
			_tmp0_ = string_substring (file_name, (glong) index, (glong) -1);
#line 392 "../src/widgets/ItemView.vala"
			_g_free0 (self->priv->hidden_extension);
#line 392 "../src/widgets/ItemView.vala"
			self->priv->hidden_extension = _tmp0_;
#line 393 "../src/widgets/ItemView.vala"
			_tmp1_ = string_substring (file_name, (glong) 0, (glong) index);
#line 393 "../src/widgets/ItemView.vala"
			result = _tmp1_;
#line 393 "../src/widgets/ItemView.vala"
			return result;
#line 2676 "ItemView.c"
		}
#line 395 "../src/widgets/ItemView.vala"
		_tmp2_ = g_strdup ("");
#line 395 "../src/widgets/ItemView.vala"
		_g_free0 (self->priv->hidden_extension);
#line 395 "../src/widgets/ItemView.vala"
		self->priv->hidden_extension = _tmp2_;
#line 396 "../src/widgets/ItemView.vala"
		_tmp3_ = g_strdup (file_name);
#line 396 "../src/widgets/ItemView.vala"
		result = _tmp3_;
#line 396 "../src/widgets/ItemView.vala"
		return result;
#line 2690 "ItemView.c"
	} else {
		gint index = 0;
		gchar* _tmp6_;
		gchar* _tmp7_;
#line 398 "../src/widgets/ItemView.vala"
		index = string_index_of (file_name, ".desktop", 0);
#line 399 "../src/widgets/ItemView.vala"
		if (index > 0) {
#line 2699 "ItemView.c"
			gchar* _tmp4_;
			gchar* _tmp5_;
#line 401 "../src/widgets/ItemView.vala"
			self->priv->hide_extension = TRUE;
#line 402 "../src/widgets/ItemView.vala"
			_tmp4_ = string_substring (file_name, (glong) index, (glong) -1);
#line 402 "../src/widgets/ItemView.vala"
			_g_free0 (self->priv->hidden_extension);
#line 402 "../src/widgets/ItemView.vala"
			self->priv->hidden_extension = _tmp4_;
#line 403 "../src/widgets/ItemView.vala"
			_tmp5_ = string_substring (file_name, (glong) 0, (glong) index);
#line 403 "../src/widgets/ItemView.vala"
			result = _tmp5_;
#line 403 "../src/widgets/ItemView.vala"
			return result;
#line 2716 "ItemView.c"
		}
#line 405 "../src/widgets/ItemView.vala"
		_tmp6_ = g_strdup ("");
#line 405 "../src/widgets/ItemView.vala"
		_g_free0 (self->priv->hidden_extension);
#line 405 "../src/widgets/ItemView.vala"
		self->priv->hidden_extension = _tmp6_;
#line 406 "../src/widgets/ItemView.vala"
		_tmp7_ = g_strdup (file_name);
#line 406 "../src/widgets/ItemView.vala"
		result = _tmp7_;
#line 406 "../src/widgets/ItemView.vala"
		return result;
#line 2730 "ItemView.c"
	}
}

/**
     * @name check_ellipse
     * @description check if the ellipse should be shown
     * @param string name the name to be shown in order to calculate if the ellipse will be shown
     */
static void
desktop_folder_item_view_check_ellipse (DesktopFolderItemView* self)
{
	DesktopFolderEditableLabel* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
#line 415 "../src/widgets/ItemView.vala"
	g_return_if_fail (self != NULL);
#line 417 "../src/widgets/ItemView.vala"
	_tmp0_ = self->priv->label;
#line 417 "../src/widgets/ItemView.vala"
	_tmp1_ = desktop_folder_editable_label_get_text (_tmp0_);
#line 417 "../src/widgets/ItemView.vala"
	_tmp2_ = _tmp1_;
#line 417 "../src/widgets/ItemView.vala"
	_tmp3_ = strlen (_tmp2_);
#line 417 "../src/widgets/ItemView.vala"
	_tmp4_ = _tmp3_;
#line 417 "../src/widgets/ItemView.vala"
	if (_tmp4_ > DESKTOP_FOLDER_ITEM_VIEW_MAX_CHARACTERS) {
#line 2761 "ItemView.c"
		DesktopFolderEditableLabel* _tmp5_;
		DesktopFolderEditableLabel* _tmp6_;
#line 418 "../src/widgets/ItemView.vala"
		_tmp5_ = self->priv->label;
#line 418 "../src/widgets/ItemView.vala"
		desktop_folder_editable_label_set_lines (_tmp5_, 2);
#line 419 "../src/widgets/ItemView.vala"
		_tmp6_ = self->priv->label;
#line 419 "../src/widgets/ItemView.vala"
		desktop_folder_editable_label_set_ellipsize (_tmp6_, PANGO_ELLIPSIZE_END);
#line 2772 "ItemView.c"
	} else {
		DesktopFolderEditableLabel* _tmp7_;
		DesktopFolderEditableLabel* _tmp8_;
#line 421 "../src/widgets/ItemView.vala"
		_tmp7_ = self->priv->label;
#line 421 "../src/widgets/ItemView.vala"
		desktop_folder_editable_label_set_lines (_tmp7_, 1);
#line 422 "../src/widgets/ItemView.vala"
		_tmp8_ = self->priv->label;
#line 422 "../src/widgets/ItemView.vala"
		desktop_folder_editable_label_set_ellipsize (_tmp8_, PANGO_ELLIPSIZE_NONE);
#line 2784 "ItemView.c"
	}
}

/**
     * @name on_enter
     * @description on_enter signal to highlight the icon
     * @param eventCrossing EventCrossing @see on_enter signal
     * @return bool @see the on_enter signal
     */
static gboolean
desktop_folder_item_view_on_enter (DesktopFolderItemView* self,
                                   GdkEventCrossing* eventCrossing)
{
	GtkStyleContext* _tmp0_;
	gboolean single_click = FALSE;
	DesktopFolderItemManager* _tmp1_;
	DesktopFolderFolderManager* _tmp2_;
	DesktopFolderFolderManager* _tmp3_;
	DesktopFolderApp* _tmp4_;
	DesktopFolderApp* _tmp5_;
	gboolean _tmp6_;
	gboolean _tmp7_ = FALSE;
	gboolean result;
#line 432 "../src/widgets/ItemView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 432 "../src/widgets/ItemView.vala"
	g_return_val_if_fail (eventCrossing != NULL, FALSE);
#line 433 "../src/widgets/ItemView.vala"
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 433 "../src/widgets/ItemView.vala"
	gtk_style_context_add_class (_tmp0_, "df_item_over");
#line 435 "../src/widgets/ItemView.vala"
	_tmp1_ = self->priv->manager;
#line 435 "../src/widgets/ItemView.vala"
	_tmp2_ = desktop_folder_item_manager_get_folder (_tmp1_);
#line 435 "../src/widgets/ItemView.vala"
	_tmp3_ = _tmp2_;
#line 435 "../src/widgets/ItemView.vala"
	_tmp4_ = desktop_folder_folder_manager_get_application (_tmp3_);
#line 435 "../src/widgets/ItemView.vala"
	_tmp5_ = _tmp4_;
#line 435 "../src/widgets/ItemView.vala"
	_tmp6_ = desktop_folder_app_get_single_click (_tmp5_);
#line 435 "../src/widgets/ItemView.vala"
	_g_object_unref0 (_tmp5_);
#line 435 "../src/widgets/ItemView.vala"
	_g_object_unref0 (_tmp3_);
#line 435 "../src/widgets/ItemView.vala"
	single_click = _tmp6_;
#line 437 "../src/widgets/ItemView.vala"
	if (single_click) {
#line 437 "../src/widgets/ItemView.vala"
		_tmp7_ = !self->priv->flagModified;
#line 2838 "ItemView.c"
	} else {
#line 437 "../src/widgets/ItemView.vala"
		_tmp7_ = FALSE;
#line 2842 "ItemView.c"
	}
#line 437 "../src/widgets/ItemView.vala"
	if (_tmp7_) {
#line 2846 "ItemView.c"
		GdkWindow* _tmp8_;
		GdkDisplay* _tmp9_;
		GdkCursor* _tmp10_;
		GdkCursor* _tmp11_;
#line 438 "../src/widgets/ItemView.vala"
		_tmp8_ = gtk_widget_get_window ((GtkWidget*) self);
#line 438 "../src/widgets/ItemView.vala"
		_tmp9_ = gdk_display_get_default ();
#line 438 "../src/widgets/ItemView.vala"
		_tmp10_ = gdk_cursor_new_from_name (_tmp9_, "pointer");
#line 438 "../src/widgets/ItemView.vala"
		_tmp11_ = _tmp10_;
#line 438 "../src/widgets/ItemView.vala"
		gdk_window_set_cursor (_tmp8_, _tmp11_);
#line 438 "../src/widgets/ItemView.vala"
		_g_object_unref0 (_tmp11_);
#line 2863 "ItemView.c"
	}
#line 441 "../src/widgets/ItemView.vala"
	result = TRUE;
#line 441 "../src/widgets/ItemView.vala"
	return result;
#line 2869 "ItemView.c"
}

/**
     * @name cancel_movement_and_start_drag_action
     * @description cancel the current icon movement and start a drag action instead
     */
static void
desktop_folder_item_view_cancel_movement_and_start_drag_action (DesktopFolderItemView* self,
                                                                GdkEvent* event)
{
	GtkTargetList* _tmp0_;
	GtkTargetList* _tmp1_;
	GdkDragContext* _tmp2_;
	GdkDragContext* _tmp3_;
	GeeList* selecteds = NULL;
	DesktopFolderItemManager* _tmp4_;
	DesktopFolderFolderManager* _tmp5_;
	DesktopFolderFolderManager* _tmp6_;
	GeeList* _tmp7_;
	GeeList* _tmp8_;
#line 448 "../src/widgets/ItemView.vala"
	g_return_if_fail (self != NULL);
#line 448 "../src/widgets/ItemView.vala"
	g_return_if_fail (event != NULL);
#line 449 "../src/widgets/ItemView.vala"
	self->priv->flagModified = FALSE;
#line 451 "../src/widgets/ItemView.vala"
	_tmp0_ = gtk_target_list_new (DESKTOP_FOLDER_DRAGN_DROP_drag_targets, G_N_ELEMENTS (DESKTOP_FOLDER_DRAGN_DROP_drag_targets));
#line 451 "../src/widgets/ItemView.vala"
	_tmp1_ = _tmp0_;
#line 451 "../src/widgets/ItemView.vala"
	_tmp2_ = gtk_drag_begin_with_coordinates ((GtkWidget*) self, _tmp1_, DESKTOP_FOLDER_DRAGN_DROP_file_drag_actions, GDK_BUTTON_PRIMARY, event, -1, -1);
#line 451 "../src/widgets/ItemView.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 451 "../src/widgets/ItemView.vala"
	_g_object_unref0 (self->priv->drag_context);
#line 451 "../src/widgets/ItemView.vala"
	self->priv->drag_context = _tmp3_;
#line 451 "../src/widgets/ItemView.vala"
	_gtk_target_list_unref0 (_tmp1_);
#line 456 "../src/widgets/ItemView.vala"
	self->priv->flag_dragdrop_started = TRUE;
#line 461 "../src/widgets/ItemView.vala"
	_tmp4_ = self->priv->manager;
#line 461 "../src/widgets/ItemView.vala"
	_tmp5_ = desktop_folder_item_manager_get_folder (_tmp4_);
#line 461 "../src/widgets/ItemView.vala"
	_tmp6_ = _tmp5_;
#line 461 "../src/widgets/ItemView.vala"
	_tmp7_ = desktop_folder_folder_manager_get_selected_items (_tmp6_);
#line 461 "../src/widgets/ItemView.vala"
	_tmp8_ = _tmp7_;
#line 461 "../src/widgets/ItemView.vala"
	_g_object_unref0 (_tmp6_);
#line 461 "../src/widgets/ItemView.vala"
	selecteds = _tmp8_;
#line 2926 "ItemView.c"
	{
		gint i = 0;
#line 462 "../src/widgets/ItemView.vala"
		i = 0;
#line 2931 "ItemView.c"
		{
			gboolean _tmp9_ = FALSE;
#line 462 "../src/widgets/ItemView.vala"
			_tmp9_ = TRUE;
#line 462 "../src/widgets/ItemView.vala"
			while (TRUE) {
#line 2938 "ItemView.c"
				GeeList* _tmp11_;
				gint _tmp12_;
				gint _tmp13_;
				DesktopFolderItemView* selected = NULL;
				GeeList* _tmp14_;
				gpointer _tmp15_;
				DesktopFolderItemView* _tmp16_;
				DesktopFolderItemView* _tmp17_;
				GdkPoint _tmp18_;
				DesktopFolderItemSettings* settings = NULL;
				DesktopFolderItemView* _tmp19_;
				DesktopFolderItemManager* _tmp20_;
				DesktopFolderItemSettings* _tmp21_;
				DesktopFolderItemSettings* _tmp22_;
				DesktopFolderItemView* _tmp23_;
				GdkPoint _tmp24_;
				DesktopFolderItemSettings* _tmp25_;
				DesktopFolderItemView* _tmp26_;
				GdkPoint _tmp27_;
				DesktopFolderItemView* _tmp28_;
				DesktopFolderItemManager* _tmp29_;
				DesktopFolderItemSettings* _tmp30_;
				DesktopFolderItemView* _tmp31_;
				DesktopFolderItemManager* _tmp32_;
				DesktopFolderFolderManager* _tmp33_;
				DesktopFolderFolderManager* _tmp34_;
				DesktopFolderFolderWindow* _tmp35_;
				DesktopFolderFolderWindow* _tmp36_;
#line 462 "../src/widgets/ItemView.vala"
				if (!_tmp9_) {
#line 2969 "ItemView.c"
					gint _tmp10_;
#line 462 "../src/widgets/ItemView.vala"
					_tmp10_ = i;
#line 462 "../src/widgets/ItemView.vala"
					i = _tmp10_ + 1;
#line 2975 "ItemView.c"
				}
#line 462 "../src/widgets/ItemView.vala"
				_tmp9_ = FALSE;
#line 462 "../src/widgets/ItemView.vala"
				_tmp11_ = selecteds;
#line 462 "../src/widgets/ItemView.vala"
				_tmp12_ = gee_collection_get_size ((GeeCollection*) _tmp11_);
#line 462 "../src/widgets/ItemView.vala"
				_tmp13_ = _tmp12_;
#line 462 "../src/widgets/ItemView.vala"
				if (!(i < _tmp13_)) {
#line 462 "../src/widgets/ItemView.vala"
					break;
#line 2989 "ItemView.c"
				}
#line 463 "../src/widgets/ItemView.vala"
				_tmp14_ = selecteds;
#line 463 "../src/widgets/ItemView.vala"
				_tmp15_ = gee_list_get (_tmp14_, i);
#line 463 "../src/widgets/ItemView.vala"
				selected = (DesktopFolderItemView*) _tmp15_;
#line 464 "../src/widgets/ItemView.vala"
				_tmp16_ = selected;
#line 464 "../src/widgets/ItemView.vala"
				_tmp17_ = selected;
#line 464 "../src/widgets/ItemView.vala"
				_tmp18_ = _tmp17_->priv->start_drag_point;
#line 464 "../src/widgets/ItemView.vala"
				desktop_folder_util_gtk_animation_animate_move ((GtkWidget*) _tmp16_, &_tmp18_, (gdouble) 500, DESKTOP_FOLDER_UTIL_FX_ANIMATION_MODE_EASE_OUT_BACK);
#line 465 "../src/widgets/ItemView.vala"
				_tmp19_ = selected;
#line 465 "../src/widgets/ItemView.vala"
				_tmp20_ = _tmp19_->priv->manager;
#line 465 "../src/widgets/ItemView.vala"
				_tmp21_ = desktop_folder_item_manager_get_settings (_tmp20_);
#line 465 "../src/widgets/ItemView.vala"
				settings = _tmp21_;
#line 466 "../src/widgets/ItemView.vala"
				_tmp22_ = settings;
#line 466 "../src/widgets/ItemView.vala"
				_tmp23_ = selected;
#line 466 "../src/widgets/ItemView.vala"
				_tmp24_ = _tmp23_->priv->start_drag_point;
#line 466 "../src/widgets/ItemView.vala"
				desktop_folder_item_settings_set_x (_tmp22_, _tmp24_.x);
#line 467 "../src/widgets/ItemView.vala"
				_tmp25_ = settings;
#line 467 "../src/widgets/ItemView.vala"
				_tmp26_ = selected;
#line 467 "../src/widgets/ItemView.vala"
				_tmp27_ = _tmp26_->priv->start_drag_point;
#line 467 "../src/widgets/ItemView.vala"
				desktop_folder_item_settings_set_y (_tmp25_, _tmp27_.y);
#line 468 "../src/widgets/ItemView.vala"
				_tmp28_ = selected;
#line 468 "../src/widgets/ItemView.vala"
				_tmp29_ = _tmp28_->priv->manager;
#line 468 "../src/widgets/ItemView.vala"
				_tmp30_ = settings;
#line 468 "../src/widgets/ItemView.vala"
				desktop_folder_item_manager_save_settings (_tmp29_, _tmp30_);
#line 469 "../src/widgets/ItemView.vala"
				_tmp31_ = selected;
#line 469 "../src/widgets/ItemView.vala"
				_tmp32_ = _tmp31_->priv->manager;
#line 469 "../src/widgets/ItemView.vala"
				_tmp33_ = desktop_folder_item_manager_get_folder (_tmp32_);
#line 469 "../src/widgets/ItemView.vala"
				_tmp34_ = _tmp33_;
#line 469 "../src/widgets/ItemView.vala"
				_tmp35_ = desktop_folder_folder_manager_get_view (_tmp34_);
#line 469 "../src/widgets/ItemView.vala"
				_tmp36_ = _tmp35_;
#line 469 "../src/widgets/ItemView.vala"
				desktop_folder_folder_window_on_item_moving (_tmp36_, FALSE);
#line 469 "../src/widgets/ItemView.vala"
				_g_object_unref0 (_tmp36_);
#line 469 "../src/widgets/ItemView.vala"
				_g_object_unref0 (_tmp34_);
#line 462 "../src/widgets/ItemView.vala"
				_g_object_unref0 (settings);
#line 462 "../src/widgets/ItemView.vala"
				_g_object_unref0 (selected);
#line 3059 "ItemView.c"
			}
		}
	}
#line 448 "../src/widgets/ItemView.vala"
	_g_object_unref0 (selecteds);
#line 3065 "ItemView.c"
}

/**
     * @name on_leave
     * @description on_leave signal to remove highlight of the icon
     * @param eventCrossing EventCrossing @see on_enter signal
     * @return bool @see the on_leave signal
     */
gboolean
desktop_folder_item_view_on_leave (DesktopFolderItemView* self,
                                   GdkEventCrossing* eventCrossing)
{
	GtkStyleContext* _tmp0_;
	gboolean result;
#line 480 "../src/widgets/ItemView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 483 "../src/widgets/ItemView.vala"
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 483 "../src/widgets/ItemView.vala"
	gtk_style_context_remove_class (_tmp0_, "df_item_over");
#line 486 "../src/widgets/ItemView.vala"
	if (self->priv->flagMoved) {
#line 3088 "ItemView.c"
		gboolean _tmp1_ = FALSE;
		DesktopFolderItemManager* _tmp2_;
		DesktopFolderFolderManager* _tmp3_;
		DesktopFolderFolderManager* _tmp4_;
		DesktopFolderFolderWindow* _tmp5_;
		DesktopFolderFolderWindow* _tmp6_;
		gboolean _tmp7_;
		GtkAllocation allocation = {0};
		GtkAllocation _tmp8_ = {0};
		DesktopFolderFolderWindow* window = NULL;
		DesktopFolderItemManager* _tmp9_;
		DesktopFolderFolderManager* _tmp10_;
		DesktopFolderFolderManager* _tmp11_;
		DesktopFolderFolderWindow* _tmp12_;
		DesktopFolderFolderWindow* _tmp13_;
		gint window_width = 0;
		gint window_height = 0;
		DesktopFolderFolderWindow* _tmp14_;
		gint _tmp15_ = 0;
		gint _tmp16_ = 0;
		gboolean _tmp17_ = FALSE;
		gboolean _tmp18_ = FALSE;
#line 487 "../src/widgets/ItemView.vala"
		_tmp2_ = self->priv->manager;
#line 487 "../src/widgets/ItemView.vala"
		_tmp3_ = desktop_folder_item_manager_get_folder (_tmp2_);
#line 487 "../src/widgets/ItemView.vala"
		_tmp4_ = _tmp3_;
#line 487 "../src/widgets/ItemView.vala"
		_tmp5_ = desktop_folder_folder_manager_get_view (_tmp4_);
#line 487 "../src/widgets/ItemView.vala"
		_tmp6_ = _tmp5_;
#line 487 "../src/widgets/ItemView.vala"
		_tmp7_ = DESKTOP_FOLDER_IS_DESKTOP_WINDOW (_tmp6_);
#line 487 "../src/widgets/ItemView.vala"
		_g_object_unref0 (_tmp6_);
#line 487 "../src/widgets/ItemView.vala"
		_g_object_unref0 (_tmp4_);
#line 487 "../src/widgets/ItemView.vala"
		if (_tmp7_) {
#line 487 "../src/widgets/ItemView.vala"
			_tmp1_ = eventCrossing->y < ((gdouble) 0);
#line 3131 "ItemView.c"
		} else {
#line 487 "../src/widgets/ItemView.vala"
			_tmp1_ = FALSE;
#line 3135 "ItemView.c"
		}
#line 487 "../src/widgets/ItemView.vala"
		if (_tmp1_) {
#line 488 "../src/widgets/ItemView.vala"
			result = TRUE;
#line 488 "../src/widgets/ItemView.vala"
			return result;
#line 3143 "ItemView.c"
		}
#line 492 "../src/widgets/ItemView.vala"
		gtk_widget_get_allocation ((GtkWidget*) self, &_tmp8_);
#line 492 "../src/widgets/ItemView.vala"
		allocation = _tmp8_;
#line 493 "../src/widgets/ItemView.vala"
		_tmp9_ = self->priv->manager;
#line 493 "../src/widgets/ItemView.vala"
		_tmp10_ = desktop_folder_item_manager_get_folder (_tmp9_);
#line 493 "../src/widgets/ItemView.vala"
		_tmp11_ = _tmp10_;
#line 493 "../src/widgets/ItemView.vala"
		_tmp12_ = desktop_folder_folder_manager_get_view (_tmp11_);
#line 493 "../src/widgets/ItemView.vala"
		_tmp13_ = _tmp12_;
#line 493 "../src/widgets/ItemView.vala"
		_g_object_unref0 (_tmp11_);
#line 493 "../src/widgets/ItemView.vala"
		window = _tmp13_;
#line 496 "../src/widgets/ItemView.vala"
		_tmp14_ = window;
#line 496 "../src/widgets/ItemView.vala"
		gtk_window_get_size ((GtkWindow*) _tmp14_, &_tmp15_, &_tmp16_);
#line 496 "../src/widgets/ItemView.vala"
		window_width = _tmp15_;
#line 496 "../src/widgets/ItemView.vala"
		window_height = _tmp16_;
#line 497 "../src/widgets/ItemView.vala"
		if (eventCrossing->detail == GDK_NOTIFY_NONLINEAR) {
#line 497 "../src/widgets/ItemView.vala"
			_tmp18_ = TRUE;
#line 3175 "ItemView.c"
		} else {
#line 498 "../src/widgets/ItemView.vala"
			_tmp18_ = eventCrossing->detail == GDK_NOTIFY_NONLINEAR_VIRTUAL;
#line 3179 "ItemView.c"
		}
#line 497 "../src/widgets/ItemView.vala"
		if (_tmp18_) {
#line 497 "../src/widgets/ItemView.vala"
			_tmp17_ = TRUE;
#line 3185 "ItemView.c"
		} else {
			gboolean _tmp19_ = FALSE;
			DesktopFolderItemManager* _tmp20_;
			DesktopFolderFolderManager* _tmp21_;
			DesktopFolderFolderManager* _tmp22_;
			DesktopFolderFolderWindow* _tmp23_;
			DesktopFolderFolderWindow* _tmp24_;
			gboolean _tmp25_;
#line 499 "../src/widgets/ItemView.vala"
			_tmp20_ = self->priv->manager;
#line 499 "../src/widgets/ItemView.vala"
			_tmp21_ = desktop_folder_item_manager_get_folder (_tmp20_);
#line 499 "../src/widgets/ItemView.vala"
			_tmp22_ = _tmp21_;
#line 499 "../src/widgets/ItemView.vala"
			_tmp23_ = desktop_folder_folder_manager_get_view (_tmp22_);
#line 499 "../src/widgets/ItemView.vala"
			_tmp24_ = _tmp23_;
#line 499 "../src/widgets/ItemView.vala"
			_tmp25_ = !DESKTOP_FOLDER_IS_DESKTOP_WINDOW (_tmp24_);
#line 499 "../src/widgets/ItemView.vala"
			_g_object_unref0 (_tmp24_);
#line 499 "../src/widgets/ItemView.vala"
			_g_object_unref0 (_tmp22_);
#line 499 "../src/widgets/ItemView.vala"
			if (_tmp25_) {
#line 3212 "ItemView.c"
				gboolean _tmp26_ = FALSE;
				gboolean _tmp27_ = FALSE;
				gboolean _tmp28_ = FALSE;
				GtkAllocation _tmp29_;
#line 503 "../src/widgets/ItemView.vala"
				_tmp29_ = allocation;
#line 503 "../src/widgets/ItemView.vala"
				if (_tmp29_.x < 0) {
#line 503 "../src/widgets/ItemView.vala"
					_tmp28_ = TRUE;
#line 3223 "ItemView.c"
				} else {
					GtkAllocation _tmp30_;
#line 504 "../src/widgets/ItemView.vala"
					_tmp30_ = allocation;
#line 504 "../src/widgets/ItemView.vala"
					_tmp28_ = _tmp30_.y < 0;
#line 3230 "ItemView.c"
				}
#line 503 "../src/widgets/ItemView.vala"
				if (_tmp28_) {
#line 503 "../src/widgets/ItemView.vala"
					_tmp27_ = TRUE;
#line 3236 "ItemView.c"
				} else {
					GtkAllocation _tmp31_;
#line 505 "../src/widgets/ItemView.vala"
					_tmp31_ = allocation;
#line 505 "../src/widgets/ItemView.vala"
					_tmp27_ = _tmp31_.x > (window_width - DESKTOP_FOLDER_ICON_DEFAULT_WIDTH);
#line 3243 "ItemView.c"
				}
#line 502 "../src/widgets/ItemView.vala"
				if (_tmp27_) {
#line 503 "../src/widgets/ItemView.vala"
					_tmp26_ = TRUE;
#line 3249 "ItemView.c"
				} else {
					GtkAllocation _tmp32_;
#line 506 "../src/widgets/ItemView.vala"
					_tmp32_ = allocation;
#line 506 "../src/widgets/ItemView.vala"
					_tmp26_ = _tmp32_.y > (window_height - DESKTOP_FOLDER_ICON_DEFAULT_WIDTH);
#line 3256 "ItemView.c"
				}
#line 502 "../src/widgets/ItemView.vala"
				_tmp19_ = _tmp26_;
#line 3260 "ItemView.c"
			} else {
#line 500 "../src/widgets/ItemView.vala"
				_tmp19_ = FALSE;
#line 3264 "ItemView.c"
			}
#line 499 "../src/widgets/ItemView.vala"
			_tmp17_ = _tmp19_;
#line 3268 "ItemView.c"
		}
#line 497 "../src/widgets/ItemView.vala"
		if (_tmp17_) {
#line 510 "../src/widgets/ItemView.vala"
			desktop_folder_item_view_cancel_movement_and_start_drag_action (self, (GdkEvent*) eventCrossing);
#line 3274 "ItemView.c"
		}
#line 486 "../src/widgets/ItemView.vala"
		_g_object_unref0 (window);
#line 3278 "ItemView.c"
	} else {
#line 513 "../src/widgets/ItemView.vala"
		if (self->priv->flagModified) {
#line 3282 "ItemView.c"
			DesktopFolderItemManager* _tmp33_;
#line 514 "../src/widgets/ItemView.vala"
			_tmp33_ = self->priv->manager;
#line 514 "../src/widgets/ItemView.vala"
			desktop_folder_item_manager_save_current_position (_tmp33_);
#line 515 "../src/widgets/ItemView.vala"
			self->priv->flagModified = FALSE;
#line 3290 "ItemView.c"
		}
	}
#line 517 "../src/widgets/ItemView.vala"
	result = TRUE;
#line 517 "../src/widgets/ItemView.vala"
	return result;
#line 3297 "ItemView.c"
}

/**
     * @name start_editing
     * @description action of rename the item selected by the user
     * @param string new_name the new name for this item
     */
void
desktop_folder_item_view_start_editing (DesktopFolderItemView* self)
{
	DesktopFolderEditableLabel* _tmp0_;
#line 525 "../src/widgets/ItemView.vala"
	g_return_if_fail (self != NULL);
#line 527 "../src/widgets/ItemView.vala"
	_tmp0_ = self->priv->label;
#line 527 "../src/widgets/ItemView.vala"
	desktop_folder_editable_label_start_editing (_tmp0_);
#line 3315 "ItemView.c"
}

/**
     * @name select
     * @description the user select the icon
     */
void
desktop_folder_item_view_select_only (DesktopFolderItemView* self)
{
	GtkWindow* window = NULL;
	GtkWidget* _tmp0_;
	GtkWindow* _tmp1_;
	DesktopFolderItemManager* _tmp2_;
	GtkStyleContext* _tmp3_;
#line 544 "../src/widgets/ItemView.vala"
	g_return_if_fail (self != NULL);
#line 545 "../src/widgets/ItemView.vala"
	_tmp0_ = gtk_widget_get_toplevel ((GtkWidget*) self);
#line 545 "../src/widgets/ItemView.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_window_get_type (), GtkWindow));
#line 545 "../src/widgets/ItemView.vala"
	window = _tmp1_;
#line 546 "../src/widgets/ItemView.vala"
	desktop_folder_folder_window_unselect_all (G_TYPE_CHECK_INSTANCE_CAST (window, DESKTOP_FOLDER_TYPE_FOLDER_WINDOW, DesktopFolderFolderWindow));
#line 547 "../src/widgets/ItemView.vala"
	_tmp2_ = self->priv->manager;
#line 547 "../src/widgets/ItemView.vala"
	desktop_folder_item_manager_select_only (_tmp2_);
#line 548 "../src/widgets/ItemView.vala"
	_tmp3_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 548 "../src/widgets/ItemView.vala"
	gtk_style_context_add_class (_tmp3_, "df_selected");
#line 544 "../src/widgets/ItemView.vala"
	_g_object_unref0 (window);
#line 3350 "ItemView.c"
}

void
desktop_folder_item_view_select_add (DesktopFolderItemView* self)
{
	DesktopFolderItemManager* _tmp0_;
	GtkStyleContext* _tmp1_;
#line 552 "../src/widgets/ItemView.vala"
	g_return_if_fail (self != NULL);
#line 553 "../src/widgets/ItemView.vala"
	_tmp0_ = self->priv->manager;
#line 553 "../src/widgets/ItemView.vala"
	desktop_folder_item_manager_select_add (_tmp0_);
#line 554 "../src/widgets/ItemView.vala"
	_tmp1_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 554 "../src/widgets/ItemView.vala"
	gtk_style_context_add_class (_tmp1_, "df_selected");
#line 3368 "ItemView.c"
}

/**
     * @name unselect
     * @description unselect the icon
     */
void
desktop_folder_item_view_unselect (DesktopFolderItemView* self)
{
	DesktopFolderItemManager* _tmp0_;
	GtkStyleContext* _tmp1_;
#line 561 "../src/widgets/ItemView.vala"
	g_return_if_fail (self != NULL);
#line 562 "../src/widgets/ItemView.vala"
	_tmp0_ = self->priv->manager;
#line 562 "../src/widgets/ItemView.vala"
	desktop_folder_item_manager_unselect (_tmp0_);
#line 563 "../src/widgets/ItemView.vala"
	_tmp1_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 563 "../src/widgets/ItemView.vala"
	gtk_style_context_remove_class (_tmp1_, "df_selected");
#line 3390 "ItemView.c"
}

/**
     * @name is_selected
     * @description check whether the item is selected or not
     * @return bool true->is selected
     */
gboolean
desktop_folder_item_view_is_selected (DesktopFolderItemView* self)
{
	DesktopFolderItemManager* _tmp0_;
	gboolean result;
#line 571 "../src/widgets/ItemView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 572 "../src/widgets/ItemView.vala"
	_tmp0_ = self->priv->manager;
#line 572 "../src/widgets/ItemView.vala"
	result = desktop_folder_item_manager_is_selected (_tmp0_);
#line 572 "../src/widgets/ItemView.vala"
	return result;
#line 3411 "ItemView.c"
}

/**
     * @name fade_in
     * @description fade the view in. does not call show
     */
void
desktop_folder_item_view_fade_in (DesktopFolderItemView* self)
{
	GtkStyleContext* _tmp0_;
	GtkStyleContext* _tmp1_;
#line 579 "../src/widgets/ItemView.vala"
	g_return_if_fail (self != NULL);
#line 580 "../src/widgets/ItemView.vala"
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 580 "../src/widgets/ItemView.vala"
	gtk_style_context_remove_class (_tmp0_, "df_fadeout");
#line 581 "../src/widgets/ItemView.vala"
	_tmp1_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 581 "../src/widgets/ItemView.vala"
	gtk_style_context_add_class (_tmp1_, "df_fadein");
#line 3433 "ItemView.c"
}

/**
     * @name fade_out
     * @description fade the view out. does not call hide
     */
void
desktop_folder_item_view_fade_out (DesktopFolderItemView* self)
{
	GtkStyleContext* _tmp0_;
	GtkStyleContext* _tmp1_;
#line 588 "../src/widgets/ItemView.vala"
	g_return_if_fail (self != NULL);
#line 589 "../src/widgets/ItemView.vala"
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 589 "../src/widgets/ItemView.vala"
	gtk_style_context_remove_class (_tmp0_, "df_fadein");
#line 590 "../src/widgets/ItemView.vala"
	_tmp1_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 590 "../src/widgets/ItemView.vala"
	gtk_style_context_add_class (_tmp1_, "df_fadeout");
#line 3455 "ItemView.c"
}

/**
     * @name on_release
     * @description the release button event
     * @param EventButton event the event produced
     * @return bool @see on_release signal
     */
static gboolean
desktop_folder_item_view_on_release (DesktopFolderItemView* self,
                                     GdkEventButton* event)
{
	GdkModifierType mods = 0U;
	gboolean control_pressed = FALSE;
	GdkWindow* _tmp0_;
	GdkDisplay* _tmp1_;
	GdkCursor* _tmp2_;
	GdkCursor* _tmp3_;
	DesktopFolderItemManager* _tmp4_;
	DesktopFolderFolderManager* _tmp5_;
	DesktopFolderFolderManager* _tmp6_;
	DesktopFolderFolderWindow* _tmp7_;
	DesktopFolderFolderWindow* _tmp8_;
	gboolean result;
#line 599 "../src/widgets/ItemView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 599 "../src/widgets/ItemView.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 616 "../src/widgets/ItemView.vala"
	mods = event->state & gtk_accelerator_get_default_mod_mask ();
#line 617 "../src/widgets/ItemView.vala"
	control_pressed = (mods & GDK_CONTROL_MASK) != 0;
#line 619 "../src/widgets/ItemView.vala"
	self->priv->flag_dragdrop_started = FALSE;
#line 622 "../src/widgets/ItemView.vala"
	_tmp0_ = gtk_widget_get_window ((GtkWidget*) self);
#line 622 "../src/widgets/ItemView.vala"
	_tmp1_ = gdk_display_get_default ();
#line 622 "../src/widgets/ItemView.vala"
	_tmp2_ = gdk_cursor_new_from_name (_tmp1_, "default");
#line 622 "../src/widgets/ItemView.vala"
	_tmp3_ = _tmp2_;
#line 622 "../src/widgets/ItemView.vala"
	gdk_window_set_cursor (_tmp0_, _tmp3_);
#line 622 "../src/widgets/ItemView.vala"
	_g_object_unref0 (_tmp3_);
#line 625 "../src/widgets/ItemView.vala"
	_tmp4_ = self->priv->manager;
#line 625 "../src/widgets/ItemView.vala"
	_tmp5_ = desktop_folder_item_manager_get_folder (_tmp4_);
#line 625 "../src/widgets/ItemView.vala"
	_tmp6_ = _tmp5_;
#line 625 "../src/widgets/ItemView.vala"
	_tmp7_ = desktop_folder_folder_manager_get_view (_tmp6_);
#line 625 "../src/widgets/ItemView.vala"
	_tmp8_ = _tmp7_;
#line 625 "../src/widgets/ItemView.vala"
	desktop_folder_folder_window_on_item_moving (_tmp8_, FALSE);
#line 625 "../src/widgets/ItemView.vala"
	_g_object_unref0 (_tmp8_);
#line 625 "../src/widgets/ItemView.vala"
	_g_object_unref0 (_tmp6_);
#line 627 "../src/widgets/ItemView.vala"
	if (!self->priv->flagMoved) {
#line 3520 "ItemView.c"
		gboolean single_click = FALSE;
		DesktopFolderItemManager* _tmp9_;
		DesktopFolderFolderManager* _tmp10_;
		DesktopFolderFolderManager* _tmp11_;
		DesktopFolderApp* _tmp12_;
		DesktopFolderApp* _tmp13_;
		gboolean _tmp14_;
		gboolean _tmp15_ = FALSE;
		gboolean _tmp16_ = FALSE;
		gboolean _tmp17_ = FALSE;
#line 628 "../src/widgets/ItemView.vala"
		_tmp9_ = self->priv->manager;
#line 628 "../src/widgets/ItemView.vala"
		_tmp10_ = desktop_folder_item_manager_get_folder (_tmp9_);
#line 628 "../src/widgets/ItemView.vala"
		_tmp11_ = _tmp10_;
#line 628 "../src/widgets/ItemView.vala"
		_tmp12_ = desktop_folder_folder_manager_get_application (_tmp11_);
#line 628 "../src/widgets/ItemView.vala"
		_tmp13_ = _tmp12_;
#line 628 "../src/widgets/ItemView.vala"
		_tmp14_ = desktop_folder_app_get_single_click (_tmp13_);
#line 628 "../src/widgets/ItemView.vala"
		_g_object_unref0 (_tmp13_);
#line 628 "../src/widgets/ItemView.vala"
		_g_object_unref0 (_tmp11_);
#line 628 "../src/widgets/ItemView.vala"
		single_click = _tmp14_;
#line 630 "../src/widgets/ItemView.vala"
		if (single_click) {
#line 630 "../src/widgets/ItemView.vala"
			_tmp17_ = !control_pressed;
#line 3553 "ItemView.c"
		} else {
#line 630 "../src/widgets/ItemView.vala"
			_tmp17_ = FALSE;
#line 3557 "ItemView.c"
		}
#line 630 "../src/widgets/ItemView.vala"
		if (_tmp17_) {
#line 630 "../src/widgets/ItemView.vala"
			_tmp16_ = event->type == GDK_BUTTON_RELEASE;
#line 3563 "ItemView.c"
		} else {
#line 630 "../src/widgets/ItemView.vala"
			_tmp16_ = FALSE;
#line 3567 "ItemView.c"
		}
#line 630 "../src/widgets/ItemView.vala"
		if (_tmp16_) {
#line 630 "../src/widgets/ItemView.vala"
			_tmp15_ = event->button == ((guint) GDK_BUTTON_PRIMARY);
#line 3573 "ItemView.c"
		} else {
#line 630 "../src/widgets/ItemView.vala"
			_tmp15_ = FALSE;
#line 3577 "ItemView.c"
		}
#line 630 "../src/widgets/ItemView.vala"
		if (_tmp15_) {
#line 631 "../src/widgets/ItemView.vala"
			desktop_folder_item_view_on_double_click (self);
#line 3583 "ItemView.c"
		}
	} else {
		GtkAllocation allocation = {0};
		GtkAllocation _tmp18_ = {0};
		gint x = 0;
		GtkAllocation _tmp19_;
		gint y = 0;
		GtkAllocation _tmp20_;
		DesktopFolderFolderArrangement* arrangement = NULL;
		DesktopFolderItemManager* _tmp21_;
		DesktopFolderFolderManager* _tmp22_;
		DesktopFolderFolderManager* _tmp23_;
		DesktopFolderFolderArrangement* _tmp24_;
		DesktopFolderFolderArrangement* _tmp25_;
		gint sensitivity = 0;
		DesktopFolderFolderArrangement* _tmp26_;
		gint padding = 0;
		DesktopFolderItemManager* _tmp27_;
		DesktopFolderFolderManager* _tmp28_;
		DesktopFolderFolderManager* _tmp29_;
		DesktopFolderFolderSettings* _tmp30_;
		DesktopFolderFolderSettings* _tmp31_;
		gint _tmp32_;
		gint _tmp33_;
		gint _tmp34_;
		DesktopFolderItemManager* _tmp35_;
		DesktopFolderFolderManager* _tmp36_;
		DesktopFolderFolderManager* _tmp37_;
		DesktopFolderFolderArrangement* _tmp38_;
		DesktopFolderFolderArrangement* _tmp39_;
		gboolean _tmp40_;
		GtkWindow* window = NULL;
		GtkWidget* _tmp41_;
		GtkWindow* _tmp42_;
		GtkWindow* _tmp43_;
		gint diff_x = 0;
		GtkAllocation _tmp44_;
		gint diff_y = 0;
		GtkAllocation _tmp45_;
		DesktopFolderItemManager* _tmp46_;
		DesktopFolderFolderManager* _tmp47_;
		DesktopFolderFolderManager* _tmp48_;
		DesktopFolderFolderArrangement* _tmp49_;
		DesktopFolderFolderArrangement* _tmp50_;
		DesktopFolderItemSettings* my_settings = NULL;
		DesktopFolderItemManager* _tmp51_;
		DesktopFolderItemSettings* _tmp52_;
		DesktopFolderItemSettings* _tmp53_;
		DesktopFolderItemSettings* _tmp54_;
		DesktopFolderItemManager* _tmp55_;
		DesktopFolderItemSettings* _tmp56_;
		GeeList* selecteds = NULL;
		DesktopFolderItemManager* _tmp57_;
		DesktopFolderFolderManager* _tmp58_;
		DesktopFolderFolderManager* _tmp59_;
		GeeList* _tmp60_;
		GeeList* _tmp61_;
#line 634 "../src/widgets/ItemView.vala"
		self->priv->flagMoved = FALSE;
#line 636 "../src/widgets/ItemView.vala"
		gtk_widget_get_allocation ((GtkWidget*) self, &_tmp18_);
#line 636 "../src/widgets/ItemView.vala"
		allocation = _tmp18_;
#line 639 "../src/widgets/ItemView.vala"
		_tmp19_ = allocation;
#line 639 "../src/widgets/ItemView.vala"
		x = _tmp19_.x;
#line 640 "../src/widgets/ItemView.vala"
		_tmp20_ = allocation;
#line 640 "../src/widgets/ItemView.vala"
		y = _tmp20_.y;
#line 642 "../src/widgets/ItemView.vala"
		_tmp21_ = self->priv->manager;
#line 642 "../src/widgets/ItemView.vala"
		_tmp22_ = desktop_folder_item_manager_get_folder (_tmp21_);
#line 642 "../src/widgets/ItemView.vala"
		_tmp23_ = _tmp22_;
#line 642 "../src/widgets/ItemView.vala"
		_tmp24_ = desktop_folder_folder_manager_get_arrangement (_tmp23_);
#line 642 "../src/widgets/ItemView.vala"
		_tmp25_ = _tmp24_;
#line 642 "../src/widgets/ItemView.vala"
		_g_object_unref0 (_tmp23_);
#line 642 "../src/widgets/ItemView.vala"
		arrangement = _tmp25_;
#line 643 "../src/widgets/ItemView.vala"
		_tmp26_ = arrangement;
#line 643 "../src/widgets/ItemView.vala"
		sensitivity = desktop_folder_folder_arrangement_get_sensitivity (_tmp26_);
#line 644 "../src/widgets/ItemView.vala"
		_tmp27_ = self->priv->manager;
#line 644 "../src/widgets/ItemView.vala"
		_tmp28_ = desktop_folder_item_manager_get_folder (_tmp27_);
#line 644 "../src/widgets/ItemView.vala"
		_tmp29_ = _tmp28_;
#line 644 "../src/widgets/ItemView.vala"
		_tmp30_ = desktop_folder_folder_manager_get_settings (_tmp29_);
#line 644 "../src/widgets/ItemView.vala"
		_tmp31_ = _tmp30_;
#line 644 "../src/widgets/ItemView.vala"
		_tmp32_ = desktop_folder_folder_settings_get_arrangement_padding (_tmp31_);
#line 644 "../src/widgets/ItemView.vala"
		_tmp33_ = _tmp32_;
#line 644 "../src/widgets/ItemView.vala"
		_tmp34_ = _tmp33_;
#line 644 "../src/widgets/ItemView.vala"
		_g_object_unref0 (_tmp31_);
#line 644 "../src/widgets/ItemView.vala"
		_g_object_unref0 (_tmp29_);
#line 644 "../src/widgets/ItemView.vala"
		padding = _tmp34_;
#line 645 "../src/widgets/ItemView.vala"
		x = desktop_folder_item_view_RoundToNearestMultiple (MAX (MIN (x, self->priv->maxx), 0), sensitivity + padding);
#line 646 "../src/widgets/ItemView.vala"
		y = desktop_folder_item_view_RoundToNearestMultiple (MAX (MIN (y, self->priv->maxy), 0), sensitivity + padding);
#line 648 "../src/widgets/ItemView.vala"
		_tmp35_ = self->priv->manager;
#line 648 "../src/widgets/ItemView.vala"
		_tmp36_ = desktop_folder_item_manager_get_folder (_tmp35_);
#line 648 "../src/widgets/ItemView.vala"
		_tmp37_ = _tmp36_;
#line 648 "../src/widgets/ItemView.vala"
		_tmp38_ = desktop_folder_folder_manager_get_arrangement (_tmp37_);
#line 648 "../src/widgets/ItemView.vala"
		_tmp39_ = _tmp38_;
#line 648 "../src/widgets/ItemView.vala"
		_tmp40_ = desktop_folder_folder_arrangement_have_margin (_tmp39_);
#line 648 "../src/widgets/ItemView.vala"
		_g_object_unref0 (_tmp39_);
#line 648 "../src/widgets/ItemView.vala"
		_g_object_unref0 (_tmp37_);
#line 648 "../src/widgets/ItemView.vala"
		if (_tmp40_) {
#line 649 "../src/widgets/ItemView.vala"
			x = x + desktop_folder_folder_arrangement_DEFAULT_EXTERNAL_MARGIN;
#line 3719 "ItemView.c"
		}
#line 652 "../src/widgets/ItemView.vala"
		_tmp41_ = gtk_widget_get_toplevel ((GtkWidget*) self);
#line 652 "../src/widgets/ItemView.vala"
		_tmp42_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp41_, gtk_window_get_type (), GtkWindow));
#line 652 "../src/widgets/ItemView.vala"
		window = _tmp42_;
#line 653 "../src/widgets/ItemView.vala"
		_tmp43_ = window;
#line 653 "../src/widgets/ItemView.vala"
		desktop_folder_folder_window_move_item (G_TYPE_CHECK_INSTANCE_CAST (_tmp43_, DESKTOP_FOLDER_TYPE_FOLDER_WINDOW, DesktopFolderFolderWindow), self, x, y);
#line 655 "../src/widgets/ItemView.vala"
		_tmp44_ = allocation;
#line 655 "../src/widgets/ItemView.vala"
		diff_x = _tmp44_.x - x;
#line 656 "../src/widgets/ItemView.vala"
		_tmp45_ = allocation;
#line 656 "../src/widgets/ItemView.vala"
		diff_y = _tmp45_.y - y;
#line 660 "../src/widgets/ItemView.vala"
		_tmp46_ = self->priv->manager;
#line 660 "../src/widgets/ItemView.vala"
		_tmp47_ = desktop_folder_item_manager_get_folder (_tmp46_);
#line 660 "../src/widgets/ItemView.vala"
		_tmp48_ = _tmp47_;
#line 660 "../src/widgets/ItemView.vala"
		_tmp49_ = desktop_folder_folder_manager_get_arrangement (_tmp48_);
#line 660 "../src/widgets/ItemView.vala"
		_tmp50_ = _tmp49_;
#line 660 "../src/widgets/ItemView.vala"
		desktop_folder_folder_arrangement_end_drag (_tmp50_);
#line 660 "../src/widgets/ItemView.vala"
		_g_object_unref0 (_tmp50_);
#line 660 "../src/widgets/ItemView.vala"
		_g_object_unref0 (_tmp48_);
#line 661 "../src/widgets/ItemView.vala"
		_tmp51_ = self->priv->manager;
#line 661 "../src/widgets/ItemView.vala"
		_tmp52_ = desktop_folder_item_manager_get_settings (_tmp51_);
#line 661 "../src/widgets/ItemView.vala"
		my_settings = _tmp52_;
#line 662 "../src/widgets/ItemView.vala"
		_tmp53_ = my_settings;
#line 662 "../src/widgets/ItemView.vala"
		desktop_folder_item_settings_set_x (_tmp53_, x);
#line 663 "../src/widgets/ItemView.vala"
		_tmp54_ = my_settings;
#line 663 "../src/widgets/ItemView.vala"
		desktop_folder_item_settings_set_y (_tmp54_, y);
#line 664 "../src/widgets/ItemView.vala"
		_tmp55_ = self->priv->manager;
#line 664 "../src/widgets/ItemView.vala"
		_tmp56_ = my_settings;
#line 664 "../src/widgets/ItemView.vala"
		desktop_folder_item_manager_save_settings (_tmp55_, _tmp56_);
#line 667 "../src/widgets/ItemView.vala"
		_tmp57_ = self->priv->manager;
#line 667 "../src/widgets/ItemView.vala"
		_tmp58_ = desktop_folder_item_manager_get_folder (_tmp57_);
#line 667 "../src/widgets/ItemView.vala"
		_tmp59_ = _tmp58_;
#line 667 "../src/widgets/ItemView.vala"
		_tmp60_ = desktop_folder_folder_manager_get_selected_items (_tmp59_);
#line 667 "../src/widgets/ItemView.vala"
		_tmp61_ = _tmp60_;
#line 667 "../src/widgets/ItemView.vala"
		_g_object_unref0 (_tmp59_);
#line 667 "../src/widgets/ItemView.vala"
		selecteds = _tmp61_;
#line 3789 "ItemView.c"
		{
			gint i = 0;
#line 668 "../src/widgets/ItemView.vala"
			i = 0;
#line 3794 "ItemView.c"
			{
				gboolean _tmp62_ = FALSE;
#line 668 "../src/widgets/ItemView.vala"
				_tmp62_ = TRUE;
#line 668 "../src/widgets/ItemView.vala"
				while (TRUE) {
#line 3801 "ItemView.c"
					GeeList* _tmp64_;
					gint _tmp65_;
					gint _tmp66_;
					DesktopFolderItemView* selected = NULL;
					GeeList* _tmp67_;
					gpointer _tmp68_;
					DesktopFolderItemView* _tmp69_;
#line 668 "../src/widgets/ItemView.vala"
					if (!_tmp62_) {
#line 3811 "ItemView.c"
						gint _tmp63_;
#line 668 "../src/widgets/ItemView.vala"
						_tmp63_ = i;
#line 668 "../src/widgets/ItemView.vala"
						i = _tmp63_ + 1;
#line 3817 "ItemView.c"
					}
#line 668 "../src/widgets/ItemView.vala"
					_tmp62_ = FALSE;
#line 668 "../src/widgets/ItemView.vala"
					_tmp64_ = selecteds;
#line 668 "../src/widgets/ItemView.vala"
					_tmp65_ = gee_collection_get_size ((GeeCollection*) _tmp64_);
#line 668 "../src/widgets/ItemView.vala"
					_tmp66_ = _tmp65_;
#line 668 "../src/widgets/ItemView.vala"
					if (!(i < _tmp66_)) {
#line 668 "../src/widgets/ItemView.vala"
						break;
#line 3831 "ItemView.c"
					}
#line 669 "../src/widgets/ItemView.vala"
					_tmp67_ = selecteds;
#line 669 "../src/widgets/ItemView.vala"
					_tmp68_ = gee_list_get (_tmp67_, i);
#line 669 "../src/widgets/ItemView.vala"
					selected = (DesktopFolderItemView*) _tmp68_;
#line 670 "../src/widgets/ItemView.vala"
					_tmp69_ = selected;
#line 670 "../src/widgets/ItemView.vala"
					if (_tmp69_ != self) {
#line 3843 "ItemView.c"
						GtkAllocation allocation_selected = {0};
						DesktopFolderItemView* _tmp70_;
						GtkAllocation _tmp71_ = {0};
						gint sel_x = 0;
						GtkAllocation _tmp72_;
						gint sel_y = 0;
						GtkAllocation _tmp73_;
						GtkWindow* _tmp74_;
						DesktopFolderItemView* _tmp75_;
						DesktopFolderItemManager* _tmp76_;
						DesktopFolderFolderManager* _tmp77_;
						DesktopFolderFolderManager* _tmp78_;
						DesktopFolderFolderArrangement* _tmp79_;
						DesktopFolderFolderArrangement* _tmp80_;
						DesktopFolderItemView* _tmp81_;
						DesktopFolderItemManager* _tmp82_;
						DesktopFolderFolderManager* _tmp83_;
						DesktopFolderFolderManager* _tmp84_;
						DesktopFolderFolderArrangement* _tmp85_;
						DesktopFolderFolderArrangement* _tmp86_;
						DesktopFolderItemManager* _tmp87_;
						DesktopFolderFolderManager* _tmp88_;
						DesktopFolderFolderManager* _tmp89_;
						DesktopFolderFolderArrangement* _tmp90_;
						DesktopFolderFolderArrangement* _tmp91_;
						DesktopFolderItemSettings* sel_settings = NULL;
						DesktopFolderItemView* _tmp92_;
						DesktopFolderItemManager* _tmp93_;
						DesktopFolderItemSettings* _tmp94_;
						DesktopFolderItemSettings* _tmp95_;
						DesktopFolderItemSettings* _tmp96_;
						DesktopFolderItemView* _tmp97_;
						DesktopFolderItemManager* _tmp98_;
						DesktopFolderItemSettings* _tmp99_;
#line 672 "../src/widgets/ItemView.vala"
						_tmp70_ = selected;
#line 672 "../src/widgets/ItemView.vala"
						gtk_widget_get_allocation ((GtkWidget*) _tmp70_, &_tmp71_);
#line 672 "../src/widgets/ItemView.vala"
						allocation_selected = _tmp71_;
#line 673 "../src/widgets/ItemView.vala"
						_tmp72_ = allocation_selected;
#line 673 "../src/widgets/ItemView.vala"
						sel_x = _tmp72_.x - diff_x;
#line 674 "../src/widgets/ItemView.vala"
						_tmp73_ = allocation_selected;
#line 674 "../src/widgets/ItemView.vala"
						sel_y = _tmp73_.y - diff_y;
#line 675 "../src/widgets/ItemView.vala"
						_tmp74_ = window;
#line 675 "../src/widgets/ItemView.vala"
						_tmp75_ = selected;
#line 675 "../src/widgets/ItemView.vala"
						desktop_folder_folder_window_move_item (G_TYPE_CHECK_INSTANCE_CAST (_tmp74_, DESKTOP_FOLDER_TYPE_FOLDER_WINDOW, DesktopFolderFolderWindow), _tmp75_, sel_x, sel_y);
#line 678 "../src/widgets/ItemView.vala"
						_tmp76_ = self->priv->manager;
#line 678 "../src/widgets/ItemView.vala"
						_tmp77_ = desktop_folder_item_manager_get_folder (_tmp76_);
#line 678 "../src/widgets/ItemView.vala"
						_tmp78_ = _tmp77_;
#line 678 "../src/widgets/ItemView.vala"
						_tmp79_ = desktop_folder_folder_manager_get_arrangement (_tmp78_);
#line 678 "../src/widgets/ItemView.vala"
						_tmp80_ = _tmp79_;
#line 678 "../src/widgets/ItemView.vala"
						_tmp81_ = selected;
#line 678 "../src/widgets/ItemView.vala"
						desktop_folder_folder_arrangement_start_drag (_tmp80_, _tmp81_);
#line 678 "../src/widgets/ItemView.vala"
						_g_object_unref0 (_tmp80_);
#line 678 "../src/widgets/ItemView.vala"
						_g_object_unref0 (_tmp78_);
#line 679 "../src/widgets/ItemView.vala"
						_tmp82_ = self->priv->manager;
#line 679 "../src/widgets/ItemView.vala"
						_tmp83_ = desktop_folder_item_manager_get_folder (_tmp82_);
#line 679 "../src/widgets/ItemView.vala"
						_tmp84_ = _tmp83_;
#line 679 "../src/widgets/ItemView.vala"
						_tmp85_ = desktop_folder_folder_manager_get_arrangement (_tmp84_);
#line 679 "../src/widgets/ItemView.vala"
						_tmp86_ = _tmp85_;
#line 679 "../src/widgets/ItemView.vala"
						desktop_folder_folder_arrangement_motion_drag (_tmp86_, sel_x + DESKTOP_FOLDER_ITEM_VIEW_PADDING_X, sel_y);
#line 679 "../src/widgets/ItemView.vala"
						_g_object_unref0 (_tmp86_);
#line 679 "../src/widgets/ItemView.vala"
						_g_object_unref0 (_tmp84_);
#line 680 "../src/widgets/ItemView.vala"
						_tmp87_ = self->priv->manager;
#line 680 "../src/widgets/ItemView.vala"
						_tmp88_ = desktop_folder_item_manager_get_folder (_tmp87_);
#line 680 "../src/widgets/ItemView.vala"
						_tmp89_ = _tmp88_;
#line 680 "../src/widgets/ItemView.vala"
						_tmp90_ = desktop_folder_folder_manager_get_arrangement (_tmp89_);
#line 680 "../src/widgets/ItemView.vala"
						_tmp91_ = _tmp90_;
#line 680 "../src/widgets/ItemView.vala"
						desktop_folder_folder_arrangement_end_drag (_tmp91_);
#line 680 "../src/widgets/ItemView.vala"
						_g_object_unref0 (_tmp91_);
#line 680 "../src/widgets/ItemView.vala"
						_g_object_unref0 (_tmp89_);
#line 682 "../src/widgets/ItemView.vala"
						_tmp92_ = selected;
#line 682 "../src/widgets/ItemView.vala"
						_tmp93_ = _tmp92_->priv->manager;
#line 682 "../src/widgets/ItemView.vala"
						_tmp94_ = desktop_folder_item_manager_get_settings (_tmp93_);
#line 682 "../src/widgets/ItemView.vala"
						sel_settings = _tmp94_;
#line 683 "../src/widgets/ItemView.vala"
						_tmp95_ = sel_settings;
#line 683 "../src/widgets/ItemView.vala"
						desktop_folder_item_settings_set_x (_tmp95_, sel_x);
#line 684 "../src/widgets/ItemView.vala"
						_tmp96_ = sel_settings;
#line 684 "../src/widgets/ItemView.vala"
						desktop_folder_item_settings_set_y (_tmp96_, sel_y);
#line 685 "../src/widgets/ItemView.vala"
						_tmp97_ = selected;
#line 685 "../src/widgets/ItemView.vala"
						_tmp98_ = _tmp97_->priv->manager;
#line 685 "../src/widgets/ItemView.vala"
						_tmp99_ = sel_settings;
#line 685 "../src/widgets/ItemView.vala"
						desktop_folder_item_manager_save_settings (_tmp98_, _tmp99_);
#line 670 "../src/widgets/ItemView.vala"
						_g_object_unref0 (sel_settings);
#line 3974 "ItemView.c"
					}
#line 668 "../src/widgets/ItemView.vala"
					_g_object_unref0 (selected);
#line 3978 "ItemView.c"
				}
			}
		}
#line 627 "../src/widgets/ItemView.vala"
		_g_object_unref0 (selecteds);
#line 627 "../src/widgets/ItemView.vala"
		_g_object_unref0 (my_settings);
#line 627 "../src/widgets/ItemView.vala"
		_g_object_unref0 (window);
#line 627 "../src/widgets/ItemView.vala"
		_g_object_unref0 (arrangement);
#line 3990 "ItemView.c"
	}
#line 692 "../src/widgets/ItemView.vala"
	result = FALSE;
#line 692 "../src/widgets/ItemView.vala"
	return result;
#line 3996 "ItemView.c"
}

/**
     * @name get_manager
     * @description return the manager of this view
     * @return {ItemManager} the manager
     */
DesktopFolderItemManager*
desktop_folder_item_view_get_manager (DesktopFolderItemView* self)
{
	DesktopFolderItemManager* _tmp0_;
	DesktopFolderItemManager* _tmp1_;
	DesktopFolderItemManager* result;
#line 700 "../src/widgets/ItemView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 701 "../src/widgets/ItemView.vala"
	_tmp0_ = self->priv->manager;
#line 701 "../src/widgets/ItemView.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 701 "../src/widgets/ItemView.vala"
	result = _tmp1_;
#line 701 "../src/widgets/ItemView.vala"
	return result;
#line 4020 "ItemView.c"
}

/**
     * @name is_dragdrop_started
     * @description return whether the item has started a drag drop event
     * @return true -> yes, it was started, false otherwise
     */
gboolean
desktop_folder_item_view_is_dragdrop_started (DesktopFolderItemView* self)
{
	gboolean result;
#line 709 "../src/widgets/ItemView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 710 "../src/widgets/ItemView.vala"
	result = self->priv->flag_dragdrop_started;
#line 710 "../src/widgets/ItemView.vala"
	return result;
#line 4038 "ItemView.c"
}

/**
     * @name on_drag_end
     * @description drag end event
     */
void
desktop_folder_item_view_on_drag_end (DesktopFolderItemView* self)
{
#line 717 "../src/widgets/ItemView.vala"
	g_return_if_fail (self != NULL);
#line 718 "../src/widgets/ItemView.vala"
	self->priv->flag_dragdrop_started = FALSE;
#line 4052 "ItemView.c"
}

/**
     * @name on_press
     * @description the mouse press event captured
     * @param EventButton event the event produced
     * @return bool @see on_press signal
     */
static gboolean
desktop_folder_item_view_on_press (DesktopFolderItemView* self,
                                   GdkEventButton* event)
{
	DesktopFolderItemManager* _tmp0_;
	DesktopFolderFolderManager* _tmp1_;
	DesktopFolderFolderManager* _tmp2_;
	DesktopFolderFolderWindow* _tmp3_;
	DesktopFolderFolderWindow* _tmp4_;
	GdkWindow* _tmp5_;
	GdkDisplay* _tmp6_;
	GdkCursor* _tmp7_;
	GdkCursor* _tmp8_;
	GdkModifierType mods = 0U;
	gboolean control_pressed = FALSE;
	gboolean shift_pressed = FALSE;
	gboolean can_drag = FALSE;
	DesktopFolderItemManager* _tmp9_;
	DesktopFolderFolderManager* _tmp10_;
	DesktopFolderFolderManager* _tmp11_;
	DesktopFolderFolderArrangement* _tmp12_;
	DesktopFolderFolderArrangement* _tmp13_;
	gboolean _tmp14_;
	gboolean locked = FALSE;
	DesktopFolderItemManager* _tmp15_;
	DesktopFolderFolderManager* _tmp16_;
	DesktopFolderFolderManager* _tmp17_;
	gboolean _tmp18_;
	gboolean _tmp19_ = FALSE;
	gboolean _tmp20_ = FALSE;
	gboolean _tmp21_ = FALSE;
	gboolean _tmp24_ = FALSE;
	gboolean _tmp25_ = FALSE;
	gboolean _tmp27_ = FALSE;
	gboolean result;
#line 730 "../src/widgets/ItemView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 730 "../src/widgets/ItemView.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 732 "../src/widgets/ItemView.vala"
	_tmp0_ = self->priv->manager;
#line 732 "../src/widgets/ItemView.vala"
	_tmp1_ = desktop_folder_item_manager_get_folder (_tmp0_);
#line 732 "../src/widgets/ItemView.vala"
	_tmp2_ = _tmp1_;
#line 732 "../src/widgets/ItemView.vala"
	_tmp3_ = desktop_folder_folder_manager_get_view (_tmp2_);
#line 732 "../src/widgets/ItemView.vala"
	_tmp4_ = _tmp3_;
#line 732 "../src/widgets/ItemView.vala"
	gtk_window_present ((GtkWindow*) _tmp4_);
#line 732 "../src/widgets/ItemView.vala"
	_g_object_unref0 (_tmp4_);
#line 732 "../src/widgets/ItemView.vala"
	_g_object_unref0 (_tmp2_);
#line 734 "../src/widgets/ItemView.vala"
	_tmp5_ = gtk_widget_get_window ((GtkWidget*) self);
#line 734 "../src/widgets/ItemView.vala"
	_tmp6_ = gdk_display_get_default ();
#line 734 "../src/widgets/ItemView.vala"
	_tmp7_ = gdk_cursor_new_from_name (_tmp6_, "grabbing");
#line 734 "../src/widgets/ItemView.vala"
	_tmp8_ = _tmp7_;
#line 734 "../src/widgets/ItemView.vala"
	gdk_window_set_cursor (_tmp5_, _tmp8_);
#line 734 "../src/widgets/ItemView.vala"
	_g_object_unref0 (_tmp8_);
#line 737 "../src/widgets/ItemView.vala"
	mods = event->state & gtk_accelerator_get_default_mod_mask ();
#line 738 "../src/widgets/ItemView.vala"
	control_pressed = (mods & GDK_CONTROL_MASK) != 0;
#line 739 "../src/widgets/ItemView.vala"
	shift_pressed = (mods & GDK_SHIFT_MASK) != 0;
#line 740 "../src/widgets/ItemView.vala"
	_tmp9_ = self->priv->manager;
#line 740 "../src/widgets/ItemView.vala"
	_tmp10_ = desktop_folder_item_manager_get_folder (_tmp9_);
#line 740 "../src/widgets/ItemView.vala"
	_tmp11_ = _tmp10_;
#line 740 "../src/widgets/ItemView.vala"
	_tmp12_ = desktop_folder_folder_manager_get_arrangement (_tmp11_);
#line 740 "../src/widgets/ItemView.vala"
	_tmp13_ = _tmp12_;
#line 740 "../src/widgets/ItemView.vala"
	_tmp14_ = desktop_folder_folder_arrangement_can_drag (_tmp13_);
#line 740 "../src/widgets/ItemView.vala"
	_g_object_unref0 (_tmp13_);
#line 740 "../src/widgets/ItemView.vala"
	_g_object_unref0 (_tmp11_);
#line 740 "../src/widgets/ItemView.vala"
	can_drag = _tmp14_;
#line 741 "../src/widgets/ItemView.vala"
	_tmp15_ = self->priv->manager;
#line 741 "../src/widgets/ItemView.vala"
	_tmp16_ = desktop_folder_item_manager_get_folder (_tmp15_);
#line 741 "../src/widgets/ItemView.vala"
	_tmp17_ = _tmp16_;
#line 741 "../src/widgets/ItemView.vala"
	_tmp18_ = desktop_folder_folder_manager_are_items_locked (_tmp17_);
#line 741 "../src/widgets/ItemView.vala"
	_g_object_unref0 (_tmp17_);
#line 741 "../src/widgets/ItemView.vala"
	locked = _tmp18_;
#line 743 "../src/widgets/ItemView.vala"
	if (event->type == GDK_BUTTON_PRESS) {
#line 744 "../src/widgets/ItemView.vala"
		_tmp21_ = event->button == ((guint) GDK_BUTTON_PRIMARY);
#line 4168 "ItemView.c"
	} else {
#line 743 "../src/widgets/ItemView.vala"
		_tmp21_ = FALSE;
#line 4172 "ItemView.c"
	}
#line 743 "../src/widgets/ItemView.vala"
	if (_tmp21_) {
#line 4176 "ItemView.c"
		gboolean _tmp22_ = FALSE;
		gboolean _tmp23_ = FALSE;
#line 745 "../src/widgets/ItemView.vala"
		if (control_pressed) {
#line 745 "../src/widgets/ItemView.vala"
			_tmp23_ = TRUE;
#line 4183 "ItemView.c"
		} else {
#line 745 "../src/widgets/ItemView.vala"
			_tmp23_ = !can_drag;
#line 4187 "ItemView.c"
		}
#line 745 "../src/widgets/ItemView.vala"
		if (_tmp23_) {
#line 745 "../src/widgets/ItemView.vala"
			_tmp22_ = TRUE;
#line 4193 "ItemView.c"
		} else {
#line 745 "../src/widgets/ItemView.vala"
			_tmp22_ = locked;
#line 4197 "ItemView.c"
		}
#line 745 "../src/widgets/ItemView.vala"
		_tmp20_ = _tmp22_;
#line 4201 "ItemView.c"
	} else {
#line 743 "../src/widgets/ItemView.vala"
		_tmp20_ = FALSE;
#line 4205 "ItemView.c"
	}
#line 743 "../src/widgets/ItemView.vala"
	if (_tmp20_) {
#line 746 "../src/widgets/ItemView.vala"
		_tmp19_ = desktop_folder_item_view_is_selected (self);
#line 4211 "ItemView.c"
	} else {
#line 743 "../src/widgets/ItemView.vala"
		_tmp19_ = FALSE;
#line 4215 "ItemView.c"
	}
#line 743 "../src/widgets/ItemView.vala"
	if (_tmp19_) {
#line 747 "../src/widgets/ItemView.vala"
		self->priv->flag_dragdrop_started = TRUE;
#line 748 "../src/widgets/ItemView.vala"
		result = FALSE;
#line 748 "../src/widgets/ItemView.vala"
		return result;
#line 4225 "ItemView.c"
	}
#line 751 "../src/widgets/ItemView.vala"
	if (event->type == GDK_BUTTON_PRESS) {
#line 752 "../src/widgets/ItemView.vala"
		_tmp25_ = event->button == ((guint) GDK_BUTTON_PRIMARY);
#line 4231 "ItemView.c"
	} else {
#line 751 "../src/widgets/ItemView.vala"
		_tmp25_ = FALSE;
#line 4235 "ItemView.c"
	}
#line 751 "../src/widgets/ItemView.vala"
	if (_tmp25_) {
#line 4239 "ItemView.c"
		gboolean _tmp26_ = FALSE;
#line 753 "../src/widgets/ItemView.vala"
		if (control_pressed) {
#line 753 "../src/widgets/ItemView.vala"
			_tmp26_ = TRUE;
#line 4245 "ItemView.c"
		} else {
#line 753 "../src/widgets/ItemView.vala"
			_tmp26_ = shift_pressed;
#line 4249 "ItemView.c"
		}
#line 753 "../src/widgets/ItemView.vala"
		_tmp24_ = _tmp26_;
#line 4253 "ItemView.c"
	} else {
#line 751 "../src/widgets/ItemView.vala"
		_tmp24_ = FALSE;
#line 4257 "ItemView.c"
	}
#line 751 "../src/widgets/ItemView.vala"
	if (_tmp24_) {
#line 755 "../src/widgets/ItemView.vala"
		if (!desktop_folder_item_view_is_selected (self)) {
#line 756 "../src/widgets/ItemView.vala"
			desktop_folder_item_view_select_add (self);
#line 4265 "ItemView.c"
		} else {
#line 758 "../src/widgets/ItemView.vala"
			desktop_folder_item_view_unselect (self);
#line 4269 "ItemView.c"
		}
#line 760 "../src/widgets/ItemView.vala"
		result = FALSE;
#line 760 "../src/widgets/ItemView.vala"
		return result;
#line 4275 "ItemView.c"
	}
#line 765 "../src/widgets/ItemView.vala"
	if (event->type == GDK_BUTTON_PRESS) {
#line 765 "../src/widgets/ItemView.vala"
		_tmp27_ = event->button == ((guint) GDK_BUTTON_PRIMARY);
#line 4281 "ItemView.c"
	} else {
#line 765 "../src/widgets/ItemView.vala"
		_tmp27_ = FALSE;
#line 4285 "ItemView.c"
	}
#line 765 "../src/widgets/ItemView.vala"
	if (_tmp27_) {
#line 4289 "ItemView.c"
		gboolean _tmp28_ = FALSE;
		DesktopFolderItemManager* _tmp29_;
		DesktopFolderFolderManager* _tmp30_;
		DesktopFolderFolderManager* _tmp31_;
		gboolean _tmp32_;
#line 767 "../src/widgets/ItemView.vala"
		if (!desktop_folder_item_view_is_selected (self)) {
#line 768 "../src/widgets/ItemView.vala"
			desktop_folder_item_view_select_only (self);
#line 4299 "ItemView.c"
		}
#line 770 "../src/widgets/ItemView.vala"
		self->priv->flagMoved = FALSE;
#line 772 "../src/widgets/ItemView.vala"
		_tmp29_ = self->priv->manager;
#line 772 "../src/widgets/ItemView.vala"
		_tmp30_ = desktop_folder_item_manager_get_folder (_tmp29_);
#line 772 "../src/widgets/ItemView.vala"
		_tmp31_ = _tmp30_;
#line 772 "../src/widgets/ItemView.vala"
		_tmp32_ = !desktop_folder_folder_manager_are_items_locked (_tmp31_);
#line 772 "../src/widgets/ItemView.vala"
		_g_object_unref0 (_tmp31_);
#line 772 "../src/widgets/ItemView.vala"
		if (_tmp32_) {
#line 4315 "ItemView.c"
			DesktopFolderItemManager* _tmp33_;
			DesktopFolderFolderManager* _tmp34_;
			DesktopFolderFolderManager* _tmp35_;
			DesktopFolderFolderArrangement* _tmp36_;
			DesktopFolderFolderArrangement* _tmp37_;
#line 773 "../src/widgets/ItemView.vala"
			_tmp33_ = self->priv->manager;
#line 773 "../src/widgets/ItemView.vala"
			_tmp34_ = desktop_folder_item_manager_get_folder (_tmp33_);
#line 773 "../src/widgets/ItemView.vala"
			_tmp35_ = _tmp34_;
#line 773 "../src/widgets/ItemView.vala"
			_tmp36_ = desktop_folder_folder_manager_get_arrangement (_tmp35_);
#line 773 "../src/widgets/ItemView.vala"
			_tmp37_ = _tmp36_;
#line 773 "../src/widgets/ItemView.vala"
			_tmp28_ = desktop_folder_folder_arrangement_can_drag (_tmp37_);
#line 773 "../src/widgets/ItemView.vala"
			_g_object_unref0 (_tmp37_);
#line 773 "../src/widgets/ItemView.vala"
			_g_object_unref0 (_tmp35_);
#line 4337 "ItemView.c"
		} else {
#line 772 "../src/widgets/ItemView.vala"
			_tmp28_ = FALSE;
#line 4341 "ItemView.c"
		}
#line 772 "../src/widgets/ItemView.vala"
		if (_tmp28_) {
#line 4345 "ItemView.c"
			GeeList* selecteds = NULL;
			DesktopFolderItemManager* _tmp38_;
			DesktopFolderFolderManager* _tmp39_;
			DesktopFolderFolderManager* _tmp40_;
			GeeList* _tmp41_;
			GeeList* _tmp42_;
			GtkWidget* p = NULL;
			GtkContainer* _tmp64_;
			GtkContainer* _tmp65_;
			GtkWidget* _tmp66_;
			GtkWidget* _tmp67_;
			GdkWindow* _tmp68_;
			gint _tmp69_ = 0;
			gint _tmp70_ = 0;
			GdkWindow* _tmp71_;
			DesktopFolderEditableLabel* _tmp72_;
			GtkLabel* _tmp73_;
			GtkLabel* _tmp74_;
			GdkWindow* _tmp75_;
			DesktopFolderItemManager* _tmp81_;
			DesktopFolderFolderManager* _tmp82_;
			DesktopFolderFolderManager* _tmp83_;
			DesktopFolderFolderArrangement* _tmp84_;
			DesktopFolderFolderArrangement* _tmp85_;
			GtkAllocation pAllocation = {0};
			GtkWidget* _tmp86_;
			GtkAllocation _tmp87_ = {0};
			GtkAllocation thisAllocation = {0};
			GtkAllocation _tmp88_ = {0};
			GtkAllocation _tmp89_;
			GtkAllocation _tmp90_;
			DesktopFolderItemManager* _tmp91_;
			DesktopFolderFolderManager* _tmp92_;
			DesktopFolderFolderManager* _tmp93_;
			DesktopFolderFolderArrangement* _tmp94_;
			DesktopFolderFolderArrangement* _tmp95_;
			GtkAllocation _tmp96_;
			GtkAllocation _tmp97_;
			DesktopFolderItemManager* _tmp98_;
			DesktopFolderFolderManager* _tmp99_;
			DesktopFolderFolderManager* _tmp100_;
			DesktopFolderFolderArrangement* _tmp101_;
			DesktopFolderFolderArrangement* _tmp102_;
#line 774 "../src/widgets/ItemView.vala"
			_tmp38_ = self->priv->manager;
#line 774 "../src/widgets/ItemView.vala"
			_tmp39_ = desktop_folder_item_manager_get_folder (_tmp38_);
#line 774 "../src/widgets/ItemView.vala"
			_tmp40_ = _tmp39_;
#line 774 "../src/widgets/ItemView.vala"
			_tmp41_ = desktop_folder_folder_manager_get_selected_items (_tmp40_);
#line 774 "../src/widgets/ItemView.vala"
			_tmp42_ = _tmp41_;
#line 774 "../src/widgets/ItemView.vala"
			_g_object_unref0 (_tmp40_);
#line 774 "../src/widgets/ItemView.vala"
			selecteds = _tmp42_;
#line 4403 "ItemView.c"
			{
				gint i = 0;
#line 775 "../src/widgets/ItemView.vala"
				i = 0;
#line 4408 "ItemView.c"
				{
					gboolean _tmp43_ = FALSE;
#line 775 "../src/widgets/ItemView.vala"
					_tmp43_ = TRUE;
#line 775 "../src/widgets/ItemView.vala"
					while (TRUE) {
#line 4415 "ItemView.c"
						GeeList* _tmp45_;
						gint _tmp46_;
						gint _tmp47_;
						DesktopFolderItemView* selected = NULL;
						GeeList* _tmp48_;
						gpointer _tmp49_;
						DesktopFolderItemView* _tmp50_;
						DesktopFolderItemView* _tmp51_;
						DesktopFolderItemManager* _tmp52_;
						DesktopFolderItemSettings* _tmp53_;
						DesktopFolderItemSettings* _tmp54_;
						gint _tmp55_;
						gint _tmp56_;
						DesktopFolderItemView* _tmp57_;
						DesktopFolderItemView* _tmp58_;
						DesktopFolderItemManager* _tmp59_;
						DesktopFolderItemSettings* _tmp60_;
						DesktopFolderItemSettings* _tmp61_;
						gint _tmp62_;
						gint _tmp63_;
#line 775 "../src/widgets/ItemView.vala"
						if (!_tmp43_) {
#line 4438 "ItemView.c"
							gint _tmp44_;
#line 775 "../src/widgets/ItemView.vala"
							_tmp44_ = i;
#line 775 "../src/widgets/ItemView.vala"
							i = _tmp44_ + 1;
#line 4444 "ItemView.c"
						}
#line 775 "../src/widgets/ItemView.vala"
						_tmp43_ = FALSE;
#line 775 "../src/widgets/ItemView.vala"
						_tmp45_ = selecteds;
#line 775 "../src/widgets/ItemView.vala"
						_tmp46_ = gee_collection_get_size ((GeeCollection*) _tmp45_);
#line 775 "../src/widgets/ItemView.vala"
						_tmp47_ = _tmp46_;
#line 775 "../src/widgets/ItemView.vala"
						if (!(i < _tmp47_)) {
#line 775 "../src/widgets/ItemView.vala"
							break;
#line 4458 "ItemView.c"
						}
#line 776 "../src/widgets/ItemView.vala"
						_tmp48_ = selecteds;
#line 776 "../src/widgets/ItemView.vala"
						_tmp49_ = gee_list_get (_tmp48_, i);
#line 776 "../src/widgets/ItemView.vala"
						selected = (DesktopFolderItemView*) _tmp49_;
#line 777 "../src/widgets/ItemView.vala"
						_tmp50_ = selected;
#line 777 "../src/widgets/ItemView.vala"
						_tmp51_ = selected;
#line 777 "../src/widgets/ItemView.vala"
						_tmp52_ = _tmp51_->priv->manager;
#line 777 "../src/widgets/ItemView.vala"
						_tmp53_ = desktop_folder_item_manager_get_settings (_tmp52_);
#line 777 "../src/widgets/ItemView.vala"
						_tmp54_ = _tmp53_;
#line 777 "../src/widgets/ItemView.vala"
						_tmp55_ = desktop_folder_item_settings_get_x (_tmp54_);
#line 777 "../src/widgets/ItemView.vala"
						_tmp56_ = _tmp55_;
#line 777 "../src/widgets/ItemView.vala"
						_tmp50_->priv->start_drag_point.x = _tmp56_;
#line 777 "../src/widgets/ItemView.vala"
						_g_object_unref0 (_tmp54_);
#line 778 "../src/widgets/ItemView.vala"
						_tmp57_ = selected;
#line 778 "../src/widgets/ItemView.vala"
						_tmp58_ = selected;
#line 778 "../src/widgets/ItemView.vala"
						_tmp59_ = _tmp58_->priv->manager;
#line 778 "../src/widgets/ItemView.vala"
						_tmp60_ = desktop_folder_item_manager_get_settings (_tmp59_);
#line 778 "../src/widgets/ItemView.vala"
						_tmp61_ = _tmp60_;
#line 778 "../src/widgets/ItemView.vala"
						_tmp62_ = desktop_folder_item_settings_get_y (_tmp61_);
#line 778 "../src/widgets/ItemView.vala"
						_tmp63_ = _tmp62_;
#line 778 "../src/widgets/ItemView.vala"
						_tmp57_->priv->start_drag_point.y = _tmp63_;
#line 778 "../src/widgets/ItemView.vala"
						_g_object_unref0 (_tmp61_);
#line 775 "../src/widgets/ItemView.vala"
						_g_object_unref0 (selected);
#line 4504 "ItemView.c"
					}
				}
			}
#line 782 "../src/widgets/ItemView.vala"
			_tmp64_ = gtk_widget_get_parent ((GtkWidget*) self);
#line 782 "../src/widgets/ItemView.vala"
			_tmp65_ = _tmp64_;
#line 782 "../src/widgets/ItemView.vala"
			_tmp66_ = _g_object_ref0 ((GtkWidget*) _tmp65_);
#line 782 "../src/widgets/ItemView.vala"
			p = _tmp66_;
#line 784 "../src/widgets/ItemView.vala"
			_tmp67_ = p;
#line 784 "../src/widgets/ItemView.vala"
			_tmp68_ = gtk_widget_get_window (_tmp67_);
#line 784 "../src/widgets/ItemView.vala"
			gdk_window_get_position (_tmp68_, &_tmp69_, &_tmp70_);
#line 784 "../src/widgets/ItemView.vala"
			self->priv->offsetx = _tmp69_;
#line 784 "../src/widgets/ItemView.vala"
			self->priv->offsety = _tmp70_;
#line 787 "../src/widgets/ItemView.vala"
			self->priv->offsetx = self->priv->offsetx + ((((gint) event->x) + DESKTOP_FOLDER_ITEM_VIEW_PADDING_X) + DESKTOP_FOLDER_ITEM_VIEW_PADDING_X);
#line 788 "../src/widgets/ItemView.vala"
			self->priv->offsety = self->priv->offsety + (((gint) event->y) + DESKTOP_FOLDER_ITEM_VIEW_PADDING_Y);
#line 792 "../src/widgets/ItemView.vala"
			_tmp71_ = event->window;
#line 792 "../src/widgets/ItemView.vala"
			_tmp72_ = self->priv->label;
#line 792 "../src/widgets/ItemView.vala"
			_tmp73_ = desktop_folder_editable_label_get_title_label (_tmp72_);
#line 792 "../src/widgets/ItemView.vala"
			_tmp74_ = _tmp73_;
#line 792 "../src/widgets/ItemView.vala"
			_tmp75_ = gtk_widget_get_window ((GtkWidget*) _tmp74_);
#line 792 "../src/widgets/ItemView.vala"
			if (_tmp71_ == _tmp75_) {
#line 4542 "ItemView.c"
				gint my_x = 0;
				gint my_y = 0;
				DesktopFolderEditableLabel* _tmp76_;
				GtkLabel* _tmp77_;
				GtkLabel* _tmp78_;
				gint _tmp79_ = 0;
				gint _tmp80_ = 0;
#line 793 "../src/widgets/ItemView.vala"
				my_x = 0;
#line 794 "../src/widgets/ItemView.vala"
				my_y = 0;
#line 795 "../src/widgets/ItemView.vala"
				_tmp76_ = self->priv->label;
#line 795 "../src/widgets/ItemView.vala"
				_tmp77_ = desktop_folder_editable_label_get_title_label (_tmp76_);
#line 795 "../src/widgets/ItemView.vala"
				_tmp78_ = _tmp77_;
#line 795 "../src/widgets/ItemView.vala"
				gtk_widget_translate_coordinates ((GtkWidget*) self, (GtkWidget*) _tmp78_, (gint) event->x, (gint) event->y, &_tmp79_, &_tmp80_);
#line 795 "../src/widgets/ItemView.vala"
				my_x = _tmp79_;
#line 795 "../src/widgets/ItemView.vala"
				my_y = _tmp80_;
#line 796 "../src/widgets/ItemView.vala"
				self->priv->offsety = self->priv->offsety - my_y;
#line 4568 "ItemView.c"
			}
#line 801 "../src/widgets/ItemView.vala"
			_tmp81_ = self->priv->manager;
#line 801 "../src/widgets/ItemView.vala"
			_tmp82_ = desktop_folder_item_manager_get_folder (_tmp81_);
#line 801 "../src/widgets/ItemView.vala"
			_tmp83_ = _tmp82_;
#line 801 "../src/widgets/ItemView.vala"
			_tmp84_ = desktop_folder_folder_manager_get_arrangement (_tmp83_);
#line 801 "../src/widgets/ItemView.vala"
			_tmp85_ = _tmp84_;
#line 801 "../src/widgets/ItemView.vala"
			desktop_folder_folder_arrangement_start_drag (_tmp85_, self);
#line 801 "../src/widgets/ItemView.vala"
			_g_object_unref0 (_tmp85_);
#line 801 "../src/widgets/ItemView.vala"
			_g_object_unref0 (_tmp83_);
#line 807 "../src/widgets/ItemView.vala"
			_tmp86_ = p;
#line 807 "../src/widgets/ItemView.vala"
			gtk_widget_get_allocation (_tmp86_, &_tmp87_);
#line 807 "../src/widgets/ItemView.vala"
			pAllocation = _tmp87_;
#line 809 "../src/widgets/ItemView.vala"
			gtk_widget_get_allocation ((GtkWidget*) self, &_tmp88_);
#line 809 "../src/widgets/ItemView.vala"
			thisAllocation = _tmp88_;
#line 810 "../src/widgets/ItemView.vala"
			_tmp89_ = pAllocation;
#line 810 "../src/widgets/ItemView.vala"
			_tmp90_ = thisAllocation;
#line 810 "../src/widgets/ItemView.vala"
			_tmp91_ = self->priv->manager;
#line 810 "../src/widgets/ItemView.vala"
			_tmp92_ = desktop_folder_item_manager_get_folder (_tmp91_);
#line 810 "../src/widgets/ItemView.vala"
			_tmp93_ = _tmp92_;
#line 810 "../src/widgets/ItemView.vala"
			_tmp94_ = desktop_folder_folder_manager_get_arrangement (_tmp93_);
#line 810 "../src/widgets/ItemView.vala"
			_tmp95_ = _tmp94_;
#line 810 "../src/widgets/ItemView.vala"
			self->priv->maxx = desktop_folder_item_view_RoundDownToMultiple (_tmp89_.width - _tmp90_.width, desktop_folder_folder_arrangement_get_sensitivity (_tmp95_));
#line 810 "../src/widgets/ItemView.vala"
			_g_object_unref0 (_tmp95_);
#line 810 "../src/widgets/ItemView.vala"
			_g_object_unref0 (_tmp93_);
#line 811 "../src/widgets/ItemView.vala"
			_tmp96_ = pAllocation;
#line 811 "../src/widgets/ItemView.vala"
			_tmp97_ = thisAllocation;
#line 811 "../src/widgets/ItemView.vala"
			_tmp98_ = self->priv->manager;
#line 811 "../src/widgets/ItemView.vala"
			_tmp99_ = desktop_folder_item_manager_get_folder (_tmp98_);
#line 811 "../src/widgets/ItemView.vala"
			_tmp100_ = _tmp99_;
#line 811 "../src/widgets/ItemView.vala"
			_tmp101_ = desktop_folder_folder_manager_get_arrangement (_tmp100_);
#line 811 "../src/widgets/ItemView.vala"
			_tmp102_ = _tmp101_;
#line 811 "../src/widgets/ItemView.vala"
			self->priv->maxy = desktop_folder_item_view_RoundDownToMultiple (_tmp96_.height - _tmp97_.height, desktop_folder_folder_arrangement_get_sensitivity (_tmp102_));
#line 811 "../src/widgets/ItemView.vala"
			_g_object_unref0 (_tmp102_);
#line 811 "../src/widgets/ItemView.vala"
			_g_object_unref0 (_tmp100_);
#line 772 "../src/widgets/ItemView.vala"
			_g_object_unref0 (p);
#line 772 "../src/widgets/ItemView.vala"
			_g_object_unref0 (selecteds);
#line 4640 "ItemView.c"
		} else {
#line 814 "../src/widgets/ItemView.vala"
			result = TRUE;
#line 814 "../src/widgets/ItemView.vala"
			return result;
#line 4646 "ItemView.c"
		}
	} else {
#line 816 "../src/widgets/ItemView.vala"
		if (event->type == GDK_2BUTTON_PRESS) {
#line 817 "../src/widgets/ItemView.vala"
			if (!desktop_folder_item_view_is_selected (self)) {
#line 818 "../src/widgets/ItemView.vala"
				desktop_folder_item_view_select_only (self);
#line 4655 "ItemView.c"
			}
#line 820 "../src/widgets/ItemView.vala"
			desktop_folder_item_view_on_double_click (self);
#line 4659 "ItemView.c"
		} else {
			gboolean _tmp103_ = FALSE;
#line 821 "../src/widgets/ItemView.vala"
			if (event->type == GDK_BUTTON_PRESS) {
#line 821 "../src/widgets/ItemView.vala"
				_tmp103_ = event->button == ((guint) GDK_BUTTON_SECONDARY);
#line 4666 "ItemView.c"
			} else {
#line 821 "../src/widgets/ItemView.vala"
				_tmp103_ = FALSE;
#line 4670 "ItemView.c"
			}
#line 821 "../src/widgets/ItemView.vala"
			if (_tmp103_) {
#line 822 "../src/widgets/ItemView.vala"
				if (!desktop_folder_item_view_is_selected (self)) {
#line 823 "../src/widgets/ItemView.vala"
					desktop_folder_item_view_select_only (self);
#line 4678 "ItemView.c"
				}
#line 825 "../src/widgets/ItemView.vala"
				desktop_folder_item_view_show_popup (self, event);
#line 4682 "ItemView.c"
			}
		}
	}
#line 828 "../src/widgets/ItemView.vala"
	result = TRUE;
#line 828 "../src/widgets/ItemView.vala"
	return result;
#line 4690 "ItemView.c"
}

/**
     * @name on_double_click
     * @description double click event captured
     */
static void
desktop_folder_item_view_on_double_click (DesktopFolderItemView* self)
{
#line 835 "../src/widgets/ItemView.vala"
	g_return_if_fail (self != NULL);
#line 837 "../src/widgets/ItemView.vala"
	desktop_folder_item_view_execute (self);
#line 4704 "ItemView.c"
}

/**
     * @name execute
     * @description execute the action associated with the item
     */
void
desktop_folder_item_view_execute (DesktopFolderItemView* self)
{
	DesktopFolderItemManager* _tmp0_;
#line 844 "../src/widgets/ItemView.vala"
	g_return_if_fail (self != NULL);
#line 845 "../src/widgets/ItemView.vala"
	_tmp0_ = self->priv->manager;
#line 845 "../src/widgets/ItemView.vala"
	desktop_folder_item_manager_execute (_tmp0_);
#line 4721 "ItemView.c"
}

/**
     * @name show_popup
     * @description show the context popup for this item
     * @param EventButton event the event button that originates this context menu
     */
static Block23Data*
block23_data_ref (Block23Data* _data23_)
{
#line 853 "../src/widgets/ItemView.vala"
	g_atomic_int_inc (&_data23_->_ref_count_);
#line 853 "../src/widgets/ItemView.vala"
	return _data23_;
#line 4736 "ItemView.c"
}

static void
block23_data_unref (void * _userdata_)
{
	Block23Data* _data23_;
	_data23_ = (Block23Data*) _userdata_;
#line 853 "../src/widgets/ItemView.vala"
	if (g_atomic_int_dec_and_test (&_data23_->_ref_count_)) {
#line 4746 "ItemView.c"
		DesktopFolderItemView* self;
#line 853 "../src/widgets/ItemView.vala"
		self = _data23_->self;
#line 853 "../src/widgets/ItemView.vala"
		_g_free0 (_data23_->info_path);
#line 853 "../src/widgets/ItemView.vala"
		_g_free0 (_data23_->path);
#line 853 "../src/widgets/ItemView.vala"
		_g_object_unref0 (self);
#line 853 "../src/widgets/ItemView.vala"
		g_slice_free (Block23Data, _data23_);
#line 4758 "ItemView.c"
	}
}

static void
__lambda109_ (DesktopFolderItemView* self,
              GtkMenuItem* item)
{
	DesktopFolderItemManager* _tmp0_;
#line 867 "../src/widgets/ItemView.vala"
	g_return_if_fail (item != NULL);
#line 868 "../src/widgets/ItemView.vala"
	_tmp0_ = self->priv->manager;
#line 868 "../src/widgets/ItemView.vala"
	desktop_folder_item_manager_execute (_tmp0_);
#line 4773 "ItemView.c"
}

static void
___lambda109__gtk_menu_item_activate (GtkMenuItem* _sender,
                                      gpointer self)
{
#line 867 "../src/widgets/ItemView.vala"
	__lambda109_ ((DesktopFolderItemView*) self, _sender);
#line 4782 "ItemView.c"
}

static void
__lambda110_ (Block23Data* _data23_,
              GtkMenuItem* item)
{
	DesktopFolderItemView* self;
	DesktopFolderItemManager* _tmp0_;
	const gchar* _tmp1_;
#line 876 "../src/widgets/ItemView.vala"
	self = _data23_->self;
#line 876 "../src/widgets/ItemView.vala"
	g_return_if_fail (item != NULL);
#line 876 "../src/widgets/ItemView.vala"
	_tmp0_ = self->priv->manager;
#line 876 "../src/widgets/ItemView.vala"
	_tmp1_ = _data23_->path;
#line 876 "../src/widgets/ItemView.vala"
	desktop_folder_item_manager_openwith (_tmp0_, _tmp1_);
#line 4802 "ItemView.c"
}

static void
___lambda110__gtk_menu_item_activate (GtkMenuItem* _sender,
                                      gpointer self)
{
#line 876 "../src/widgets/ItemView.vala"
	__lambda110_ (self, _sender);
#line 4811 "ItemView.c"
}

static void
__lambda111_ (DesktopFolderItemView* self,
              GtkMenuItem* item)
{
	DesktopFolderItemManager* _tmp0_;
#line 885 "../src/widgets/ItemView.vala"
	g_return_if_fail (item != NULL);
#line 885 "../src/widgets/ItemView.vala"
	_tmp0_ = self->priv->manager;
#line 885 "../src/widgets/ItemView.vala"
	desktop_folder_item_manager_cut (_tmp0_);
#line 4825 "ItemView.c"
}

static void
___lambda111__gtk_menu_item_activate (GtkMenuItem* _sender,
                                      gpointer self)
{
#line 885 "../src/widgets/ItemView.vala"
	__lambda111_ ((DesktopFolderItemView*) self, _sender);
#line 4834 "ItemView.c"
}

static void
__lambda112_ (DesktopFolderItemView* self,
              GtkMenuItem* item)
{
	DesktopFolderItemManager* _tmp0_;
#line 890 "../src/widgets/ItemView.vala"
	g_return_if_fail (item != NULL);
#line 890 "../src/widgets/ItemView.vala"
	_tmp0_ = self->priv->manager;
#line 890 "../src/widgets/ItemView.vala"
	desktop_folder_item_manager_copy (_tmp0_);
#line 4848 "ItemView.c"
}

static void
___lambda112__gtk_menu_item_activate (GtkMenuItem* _sender,
                                      gpointer self)
{
#line 890 "../src/widgets/ItemView.vala"
	__lambda112_ ((DesktopFolderItemView*) self, _sender);
#line 4857 "ItemView.c"
}

static void
__lambda113_ (DesktopFolderItemView* self,
              GtkMenuItem* item)
{
	DesktopFolderEditableLabel* _tmp0_;
#line 899 "../src/widgets/ItemView.vala"
	g_return_if_fail (item != NULL);
#line 899 "../src/widgets/ItemView.vala"
	_tmp0_ = self->priv->label;
#line 899 "../src/widgets/ItemView.vala"
	desktop_folder_editable_label_start_editing (_tmp0_);
#line 4871 "ItemView.c"
}

static void
___lambda113__gtk_menu_item_activate (GtkMenuItem* _sender,
                                      gpointer self)
{
#line 899 "../src/widgets/ItemView.vala"
	__lambda113_ ((DesktopFolderItemView*) self, _sender);
#line 4880 "ItemView.c"
}

static void
__lambda114_ (DesktopFolderItemView* self,
              GtkMenuItem* item)
{
	DesktopFolderItemManager* _tmp0_;
#line 904 "../src/widgets/ItemView.vala"
	g_return_if_fail (item != NULL);
#line 904 "../src/widgets/ItemView.vala"
	_tmp0_ = self->priv->manager;
#line 904 "../src/widgets/ItemView.vala"
	desktop_folder_item_manager_trash_selected (_tmp0_);
#line 4894 "ItemView.c"
}

static void
___lambda114__gtk_menu_item_activate (GtkMenuItem* _sender,
                                      gpointer self)
{
#line 904 "../src/widgets/ItemView.vala"
	__lambda114_ ((DesktopFolderItemView*) self, _sender);
#line 4903 "ItemView.c"
}

static void
__lambda115_ (DesktopFolderItemView* self,
              GtkMenuItem* item)
{
#line 910 "../src/widgets/ItemView.vala"
	g_return_if_fail (item != NULL);
#line 910 "../src/widgets/ItemView.vala"
	desktop_folder_item_view_change_icon (self);
#line 4914 "ItemView.c"
}

static void
___lambda115__gtk_menu_item_activate (GtkMenuItem* _sender,
                                      gpointer self)
{
#line 910 "../src/widgets/ItemView.vala"
	__lambda115_ ((DesktopFolderItemView*) self, _sender);
#line 4923 "ItemView.c"
}

static void
__lambda116_ (Block23Data* _data23_,
              GtkMenuItem* item)
{
	DesktopFolderItemView* self;
	DesktopFolderItemManager* _tmp0_;
	const gchar* _tmp1_;
#line 921 "../src/widgets/ItemView.vala"
	self = _data23_->self;
#line 921 "../src/widgets/ItemView.vala"
	g_return_if_fail (item != NULL);
#line 921 "../src/widgets/ItemView.vala"
	_tmp0_ = self->priv->manager;
#line 921 "../src/widgets/ItemView.vala"
	_tmp1_ = _data23_->info_path;
#line 921 "../src/widgets/ItemView.vala"
	desktop_folder_item_manager_show_info (_tmp0_, _tmp1_);
#line 4943 "ItemView.c"
}

static void
___lambda116__gtk_menu_item_activate (GtkMenuItem* _sender,
                                      gpointer self)
{
#line 921 "../src/widgets/ItemView.vala"
	__lambda116_ (self, _sender);
#line 4952 "ItemView.c"
}

static void
___lambda117_ (Block23Data* _data23_,
               GtkMenuItem* item)
{
	DesktopFolderItemView* self;
	DesktopFolderItemManager* _tmp0_;
	const gchar* _tmp1_;
#line 932 "../src/widgets/ItemView.vala"
	self = _data23_->self;
#line 932 "../src/widgets/ItemView.vala"
	g_return_if_fail (item != NULL);
#line 932 "../src/widgets/ItemView.vala"
	_tmp0_ = self->priv->manager;
#line 932 "../src/widgets/ItemView.vala"
	_tmp1_ = _data23_->path;
#line 932 "../src/widgets/ItemView.vala"
	desktop_folder_item_manager_open_in_terminal (_tmp0_, _tmp1_);
#line 4972 "ItemView.c"
}

static void
____lambda117__gtk_menu_item_activate (GtkMenuItem* _sender,
                                       gpointer self)
{
#line 932 "../src/widgets/ItemView.vala"
	___lambda117_ (self, _sender);
#line 4981 "ItemView.c"
}

static void
desktop_folder_item_view_show_popup (DesktopFolderItemView* self,
                                     GdkEventButton* event)
{
	Block23Data* _data23_;
	GtkMenu* _tmp0_;
	gchar* label = NULL;
	gchar* _tmp1_;
	DesktopFolderItemManager* _tmp2_;
	GtkMenuItem* item = NULL;
	const gchar* _tmp4_;
	GtkMenuItem* _tmp5_;
	GtkMenuItem* _tmp6_;
	GtkMenuItem* _tmp7_;
	GtkMenu* _tmp8_;
	GtkMenuItem* _tmp9_;
	GtkMenuItem* _tmp10_;
	DesktopFolderItemManager* _tmp11_;
	gchar* _tmp12_;
	GtkMenuItem* _tmp13_;
	GtkMenuItem* _tmp14_;
	GtkMenu* _tmp15_;
	GtkMenuItem* _tmp16_;
	DesktopFolderMenuItemSeparator* _tmp17_;
	GtkMenuItem* _tmp18_;
	GtkMenu* _tmp19_;
	GtkMenuItem* _tmp20_;
	GtkMenuItem* _tmp21_;
	GtkMenuItem* _tmp22_;
	GtkMenuItem* _tmp23_;
	GtkMenu* _tmp24_;
	GtkMenuItem* _tmp25_;
	GtkMenuItem* _tmp26_;
	GtkMenuItem* _tmp27_;
	GtkMenuItem* _tmp28_;
	GtkMenu* _tmp29_;
	GtkMenuItem* _tmp30_;
	DesktopFolderMenuItemSeparator* _tmp31_;
	GtkMenuItem* _tmp32_;
	GtkMenu* _tmp33_;
	GtkMenuItem* _tmp34_;
	GtkMenuItem* _tmp35_;
	GtkMenuItem* _tmp36_;
	GtkMenuItem* _tmp37_;
	GtkMenu* _tmp38_;
	GtkMenuItem* _tmp39_;
	GtkMenuItem* _tmp40_;
	GtkMenuItem* _tmp41_;
	GtkMenuItem* _tmp42_;
	GtkMenu* _tmp43_;
	GtkMenuItem* _tmp44_;
	GtkMenuItem* _tmp45_;
	GtkMenuItem* _tmp46_;
	GtkMenuItem* _tmp47_;
	GtkMenu* _tmp48_;
	GtkMenuItem* _tmp49_;
	DesktopFolderMenuItemSeparator* _tmp50_;
	GtkMenuItem* _tmp51_;
	GtkMenu* _tmp52_;
	GtkMenuItem* _tmp53_;
	GtkMenuItem* _tmp54_;
	DesktopFolderItemManager* _tmp55_;
	gchar* _tmp56_;
	GtkMenuItem* _tmp57_;
	GtkMenuItem* _tmp58_;
	GtkMenu* _tmp59_;
	GtkMenuItem* _tmp60_;
	DesktopFolderItemManager* _tmp61_;
	GtkMenu* _tmp71_;
	GtkMenu* _tmp72_;
#line 853 "../src/widgets/ItemView.vala"
	g_return_if_fail (self != NULL);
#line 853 "../src/widgets/ItemView.vala"
	g_return_if_fail (event != NULL);
#line 853 "../src/widgets/ItemView.vala"
	_data23_ = g_slice_new0 (Block23Data);
#line 853 "../src/widgets/ItemView.vala"
	_data23_->_ref_count_ = 1;
#line 853 "../src/widgets/ItemView.vala"
	_data23_->self = g_object_ref (self);
#line 859 "../src/widgets/ItemView.vala"
	_tmp0_ = (GtkMenu*) gtk_menu_new ();
#line 859 "../src/widgets/ItemView.vala"
	g_object_ref_sink (_tmp0_);
#line 859 "../src/widgets/ItemView.vala"
	_g_object_unref0 (self->priv->menu);
#line 859 "../src/widgets/ItemView.vala"
	self->priv->menu = _tmp0_;
#line 861 "../src/widgets/ItemView.vala"
	_tmp1_ = g_strdup (DESKTOP_FOLDER_LANG_ITEM_MENU_OPEN);
#line 861 "../src/widgets/ItemView.vala"
	label = _tmp1_;
#line 862 "../src/widgets/ItemView.vala"
	_tmp2_ = self->priv->manager;
#line 862 "../src/widgets/ItemView.vala"
	if (desktop_folder_item_manager_is_executable (_tmp2_)) {
#line 5080 "ItemView.c"
		gchar* _tmp3_;
#line 863 "../src/widgets/ItemView.vala"
		_tmp3_ = g_strdup (DESKTOP_FOLDER_LANG_ITEM_MENU_EXECUTE);
#line 863 "../src/widgets/ItemView.vala"
		_g_free0 (label);
#line 863 "../src/widgets/ItemView.vala"
		label = _tmp3_;
#line 5088 "ItemView.c"
	}
#line 866 "../src/widgets/ItemView.vala"
	_tmp4_ = label;
#line 866 "../src/widgets/ItemView.vala"
	_tmp5_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_tmp4_);
#line 866 "../src/widgets/ItemView.vala"
	g_object_ref_sink (_tmp5_);
#line 866 "../src/widgets/ItemView.vala"
	item = _tmp5_;
#line 867 "../src/widgets/ItemView.vala"
	_tmp6_ = item;
#line 867 "../src/widgets/ItemView.vala"
	g_signal_connect_object (_tmp6_, "activate", (GCallback) ___lambda109__gtk_menu_item_activate, self, 0);
#line 871 "../src/widgets/ItemView.vala"
	_tmp7_ = item;
#line 871 "../src/widgets/ItemView.vala"
	gtk_widget_show ((GtkWidget*) _tmp7_);
#line 872 "../src/widgets/ItemView.vala"
	_tmp8_ = self->priv->menu;
#line 872 "../src/widgets/ItemView.vala"
	_tmp9_ = item;
#line 872 "../src/widgets/ItemView.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp8_, _tmp9_);
#line 874 "../src/widgets/ItemView.vala"
	_tmp10_ = (GtkMenuItem*) gtk_menu_item_new_with_label (DESKTOP_FOLDER_LANG_ITEM_MENU_OPEN_WITH);
#line 874 "../src/widgets/ItemView.vala"
	g_object_ref_sink (_tmp10_);
#line 874 "../src/widgets/ItemView.vala"
	_g_object_unref0 (item);
#line 874 "../src/widgets/ItemView.vala"
	item = _tmp10_;
#line 875 "../src/widgets/ItemView.vala"
	_tmp11_ = self->priv->manager;
#line 875 "../src/widgets/ItemView.vala"
	_tmp12_ = desktop_folder_item_manager_get_absolute_path (_tmp11_);
#line 875 "../src/widgets/ItemView.vala"
	_data23_->path = _tmp12_;
#line 876 "../src/widgets/ItemView.vala"
	_tmp13_ = item;
#line 876 "../src/widgets/ItemView.vala"
	g_signal_connect_data (_tmp13_, "activate", (GCallback) ___lambda110__gtk_menu_item_activate, block23_data_ref (_data23_), (GClosureNotify) block23_data_unref, 0);
#line 877 "../src/widgets/ItemView.vala"
	_tmp14_ = item;
#line 877 "../src/widgets/ItemView.vala"
	gtk_widget_show ((GtkWidget*) _tmp14_);
#line 878 "../src/widgets/ItemView.vala"
	_tmp15_ = self->priv->menu;
#line 878 "../src/widgets/ItemView.vala"
	_tmp16_ = item;
#line 878 "../src/widgets/ItemView.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp15_, _tmp16_);
#line 880 "../src/widgets/ItemView.vala"
	_tmp17_ = desktop_folder_menu_item_separator_new ();
#line 880 "../src/widgets/ItemView.vala"
	g_object_ref_sink (_tmp17_);
#line 880 "../src/widgets/ItemView.vala"
	_g_object_unref0 (item);
#line 880 "../src/widgets/ItemView.vala"
	item = (GtkMenuItem*) _tmp17_;
#line 881 "../src/widgets/ItemView.vala"
	_tmp18_ = item;
#line 881 "../src/widgets/ItemView.vala"
	gtk_widget_show ((GtkWidget*) _tmp18_);
#line 882 "../src/widgets/ItemView.vala"
	_tmp19_ = self->priv->menu;
#line 882 "../src/widgets/ItemView.vala"
	_tmp20_ = item;
#line 882 "../src/widgets/ItemView.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp19_, _tmp20_);
#line 884 "../src/widgets/ItemView.vala"
	_tmp21_ = (GtkMenuItem*) gtk_menu_item_new_with_label (DESKTOP_FOLDER_LANG_ITEM_MENU_CUT);
#line 884 "../src/widgets/ItemView.vala"
	g_object_ref_sink (_tmp21_);
#line 884 "../src/widgets/ItemView.vala"
	_g_object_unref0 (item);
#line 884 "../src/widgets/ItemView.vala"
	item = _tmp21_;
#line 885 "../src/widgets/ItemView.vala"
	_tmp22_ = item;
#line 885 "../src/widgets/ItemView.vala"
	g_signal_connect_object (_tmp22_, "activate", (GCallback) ___lambda111__gtk_menu_item_activate, self, 0);
#line 886 "../src/widgets/ItemView.vala"
	_tmp23_ = item;
#line 886 "../src/widgets/ItemView.vala"
	gtk_widget_show ((GtkWidget*) _tmp23_);
#line 887 "../src/widgets/ItemView.vala"
	_tmp24_ = self->priv->menu;
#line 887 "../src/widgets/ItemView.vala"
	_tmp25_ = item;
#line 887 "../src/widgets/ItemView.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp24_, _tmp25_);
#line 889 "../src/widgets/ItemView.vala"
	_tmp26_ = (GtkMenuItem*) gtk_menu_item_new_with_label (DESKTOP_FOLDER_LANG_ITEM_MENU_COPY);
#line 889 "../src/widgets/ItemView.vala"
	g_object_ref_sink (_tmp26_);
#line 889 "../src/widgets/ItemView.vala"
	_g_object_unref0 (item);
#line 889 "../src/widgets/ItemView.vala"
	item = _tmp26_;
#line 890 "../src/widgets/ItemView.vala"
	_tmp27_ = item;
#line 890 "../src/widgets/ItemView.vala"
	g_signal_connect_object (_tmp27_, "activate", (GCallback) ___lambda112__gtk_menu_item_activate, self, 0);
#line 891 "../src/widgets/ItemView.vala"
	_tmp28_ = item;
#line 891 "../src/widgets/ItemView.vala"
	gtk_widget_show ((GtkWidget*) _tmp28_);
#line 892 "../src/widgets/ItemView.vala"
	_tmp29_ = self->priv->menu;
#line 892 "../src/widgets/ItemView.vala"
	_tmp30_ = item;
#line 892 "../src/widgets/ItemView.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp29_, _tmp30_);
#line 894 "../src/widgets/ItemView.vala"
	_tmp31_ = desktop_folder_menu_item_separator_new ();
#line 894 "../src/widgets/ItemView.vala"
	g_object_ref_sink (_tmp31_);
#line 894 "../src/widgets/ItemView.vala"
	_g_object_unref0 (item);
#line 894 "../src/widgets/ItemView.vala"
	item = (GtkMenuItem*) _tmp31_;
#line 895 "../src/widgets/ItemView.vala"
	_tmp32_ = item;
#line 895 "../src/widgets/ItemView.vala"
	gtk_widget_show ((GtkWidget*) _tmp32_);
#line 896 "../src/widgets/ItemView.vala"
	_tmp33_ = self->priv->menu;
#line 896 "../src/widgets/ItemView.vala"
	_tmp34_ = item;
#line 896 "../src/widgets/ItemView.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp33_, _tmp34_);
#line 898 "../src/widgets/ItemView.vala"
	_tmp35_ = (GtkMenuItem*) gtk_menu_item_new_with_label (DESKTOP_FOLDER_LANG_ITEM_MENU_RENAME);
#line 898 "../src/widgets/ItemView.vala"
	g_object_ref_sink (_tmp35_);
#line 898 "../src/widgets/ItemView.vala"
	_g_object_unref0 (item);
#line 898 "../src/widgets/ItemView.vala"
	item = _tmp35_;
#line 899 "../src/widgets/ItemView.vala"
	_tmp36_ = item;
#line 899 "../src/widgets/ItemView.vala"
	g_signal_connect_object (_tmp36_, "activate", (GCallback) ___lambda113__gtk_menu_item_activate, self, 0);
#line 900 "../src/widgets/ItemView.vala"
	_tmp37_ = item;
#line 900 "../src/widgets/ItemView.vala"
	gtk_widget_show ((GtkWidget*) _tmp37_);
#line 901 "../src/widgets/ItemView.vala"
	_tmp38_ = self->priv->menu;
#line 901 "../src/widgets/ItemView.vala"
	_tmp39_ = item;
#line 901 "../src/widgets/ItemView.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp38_, _tmp39_);
#line 903 "../src/widgets/ItemView.vala"
	_tmp40_ = (GtkMenuItem*) gtk_menu_item_new_with_label (DESKTOP_FOLDER_LANG_ITEM_MENU_TRASH);
#line 903 "../src/widgets/ItemView.vala"
	g_object_ref_sink (_tmp40_);
#line 903 "../src/widgets/ItemView.vala"
	_g_object_unref0 (item);
#line 903 "../src/widgets/ItemView.vala"
	item = _tmp40_;
#line 904 "../src/widgets/ItemView.vala"
	_tmp41_ = item;
#line 904 "../src/widgets/ItemView.vala"
	g_signal_connect_object (_tmp41_, "activate", (GCallback) ___lambda114__gtk_menu_item_activate, self, 0);
#line 905 "../src/widgets/ItemView.vala"
	_tmp42_ = item;
#line 905 "../src/widgets/ItemView.vala"
	gtk_widget_show ((GtkWidget*) _tmp42_);
#line 906 "../src/widgets/ItemView.vala"
	_tmp43_ = self->priv->menu;
#line 906 "../src/widgets/ItemView.vala"
	_tmp44_ = item;
#line 906 "../src/widgets/ItemView.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp43_, _tmp44_);
#line 909 "../src/widgets/ItemView.vala"
	_tmp45_ = (GtkMenuItem*) gtk_menu_item_new_with_label (DESKTOP_FOLDER_LANG_ITEM_MENU_CHANGEICON);
#line 909 "../src/widgets/ItemView.vala"
	g_object_ref_sink (_tmp45_);
#line 909 "../src/widgets/ItemView.vala"
	_g_object_unref0 (item);
#line 909 "../src/widgets/ItemView.vala"
	item = _tmp45_;
#line 910 "../src/widgets/ItemView.vala"
	_tmp46_ = item;
#line 910 "../src/widgets/ItemView.vala"
	g_signal_connect_object (_tmp46_, "activate", (GCallback) ___lambda115__gtk_menu_item_activate, self, 0);
#line 911 "../src/widgets/ItemView.vala"
	_tmp47_ = item;
#line 911 "../src/widgets/ItemView.vala"
	gtk_widget_show ((GtkWidget*) _tmp47_);
#line 912 "../src/widgets/ItemView.vala"
	_tmp48_ = self->priv->menu;
#line 912 "../src/widgets/ItemView.vala"
	_tmp49_ = item;
#line 912 "../src/widgets/ItemView.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp48_, _tmp49_);
#line 915 "../src/widgets/ItemView.vala"
	_tmp50_ = desktop_folder_menu_item_separator_new ();
#line 915 "../src/widgets/ItemView.vala"
	g_object_ref_sink (_tmp50_);
#line 915 "../src/widgets/ItemView.vala"
	_g_object_unref0 (item);
#line 915 "../src/widgets/ItemView.vala"
	item = (GtkMenuItem*) _tmp50_;
#line 916 "../src/widgets/ItemView.vala"
	_tmp51_ = item;
#line 916 "../src/widgets/ItemView.vala"
	gtk_widget_show ((GtkWidget*) _tmp51_);
#line 917 "../src/widgets/ItemView.vala"
	_tmp52_ = self->priv->menu;
#line 917 "../src/widgets/ItemView.vala"
	_tmp53_ = item;
#line 917 "../src/widgets/ItemView.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp52_, _tmp53_);
#line 919 "../src/widgets/ItemView.vala"
	_tmp54_ = (GtkMenuItem*) gtk_menu_item_new_with_label (DESKTOP_FOLDER_LANG_ITEM_PROPSWINDOW_SHOW_FILEINFO);
#line 919 "../src/widgets/ItemView.vala"
	g_object_ref_sink (_tmp54_);
#line 919 "../src/widgets/ItemView.vala"
	_g_object_unref0 (item);
#line 919 "../src/widgets/ItemView.vala"
	item = _tmp54_;
#line 920 "../src/widgets/ItemView.vala"
	_tmp55_ = self->priv->manager;
#line 920 "../src/widgets/ItemView.vala"
	_tmp56_ = desktop_folder_item_manager_get_absolute_path (_tmp55_);
#line 920 "../src/widgets/ItemView.vala"
	_data23_->info_path = _tmp56_;
#line 921 "../src/widgets/ItemView.vala"
	_tmp57_ = item;
#line 921 "../src/widgets/ItemView.vala"
	g_signal_connect_data (_tmp57_, "activate", (GCallback) ___lambda116__gtk_menu_item_activate, block23_data_ref (_data23_), (GClosureNotify) block23_data_unref, 0);
#line 922 "../src/widgets/ItemView.vala"
	_tmp58_ = item;
#line 922 "../src/widgets/ItemView.vala"
	gtk_widget_show ((GtkWidget*) _tmp58_);
#line 923 "../src/widgets/ItemView.vala"
	_tmp59_ = self->priv->menu;
#line 923 "../src/widgets/ItemView.vala"
	_tmp60_ = item;
#line 923 "../src/widgets/ItemView.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp59_, _tmp60_);
#line 926 "../src/widgets/ItemView.vala"
	_tmp61_ = self->priv->manager;
#line 926 "../src/widgets/ItemView.vala"
	if (desktop_folder_dragn_drop_dnd_view_is_folder ((DesktopFolderDragnDropDndView*) _tmp61_)) {
#line 5336 "ItemView.c"
		DesktopFolderMenuItemSeparator* _tmp62_;
		GtkMenuItem* _tmp63_;
		GtkMenu* _tmp64_;
		GtkMenuItem* _tmp65_;
		GtkMenuItem* _tmp66_;
		GtkMenuItem* _tmp67_;
		GtkMenuItem* _tmp68_;
		GtkMenu* _tmp69_;
		GtkMenuItem* _tmp70_;
#line 927 "../src/widgets/ItemView.vala"
		_tmp62_ = desktop_folder_menu_item_separator_new ();
#line 927 "../src/widgets/ItemView.vala"
		g_object_ref_sink (_tmp62_);
#line 927 "../src/widgets/ItemView.vala"
		_g_object_unref0 (item);
#line 927 "../src/widgets/ItemView.vala"
		item = (GtkMenuItem*) _tmp62_;
#line 928 "../src/widgets/ItemView.vala"
		_tmp63_ = item;
#line 928 "../src/widgets/ItemView.vala"
		gtk_widget_show ((GtkWidget*) _tmp63_);
#line 929 "../src/widgets/ItemView.vala"
		_tmp64_ = self->priv->menu;
#line 929 "../src/widgets/ItemView.vala"
		_tmp65_ = item;
#line 929 "../src/widgets/ItemView.vala"
		gtk_menu_shell_append ((GtkMenuShell*) _tmp64_, _tmp65_);
#line 931 "../src/widgets/ItemView.vala"
		_tmp66_ = (GtkMenuItem*) gtk_menu_item_new_with_label (DESKTOP_FOLDER_LANG_DESKTOPFOLDER_MENU_OPEN_IN_TERMINAL);
#line 931 "../src/widgets/ItemView.vala"
		g_object_ref_sink (_tmp66_);
#line 931 "../src/widgets/ItemView.vala"
		_g_object_unref0 (item);
#line 931 "../src/widgets/ItemView.vala"
		item = _tmp66_;
#line 932 "../src/widgets/ItemView.vala"
		_tmp67_ = item;
#line 932 "../src/widgets/ItemView.vala"
		g_signal_connect_data (_tmp67_, "activate", (GCallback) ____lambda117__gtk_menu_item_activate, block23_data_ref (_data23_), (GClosureNotify) block23_data_unref, 0);
#line 933 "../src/widgets/ItemView.vala"
		_tmp68_ = item;
#line 933 "../src/widgets/ItemView.vala"
		gtk_widget_show ((GtkWidget*) _tmp68_);
#line 934 "../src/widgets/ItemView.vala"
		_tmp69_ = self->priv->menu;
#line 934 "../src/widgets/ItemView.vala"
		_tmp70_ = item;
#line 934 "../src/widgets/ItemView.vala"
		gtk_menu_shell_append ((GtkMenuShell*) _tmp69_, _tmp70_);
#line 5386 "ItemView.c"
	}
#line 937 "../src/widgets/ItemView.vala"
	_tmp71_ = self->priv->menu;
#line 937 "../src/widgets/ItemView.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp71_);
#line 941 "../src/widgets/ItemView.vala"
	_tmp72_ = self->priv->menu;
#line 941 "../src/widgets/ItemView.vala"
	gtk_menu_popup_at_pointer (_tmp72_, NULL);
#line 853 "../src/widgets/ItemView.vala"
	_g_object_unref0 (item);
#line 853 "../src/widgets/ItemView.vala"
	_g_free0 (label);
#line 853 "../src/widgets/ItemView.vala"
	block23_data_unref (_data23_);
#line 853 "../src/widgets/ItemView.vala"
	_data23_ = NULL;
#line 5404 "ItemView.c"
}

/**
     * @name cut
     * @description cut the file to the clipboard
     */
void
desktop_folder_item_view_cut (DesktopFolderItemView* self)
{
	DesktopFolderItemManager* _tmp0_;
#line 948 "../src/widgets/ItemView.vala"
	g_return_if_fail (self != NULL);
#line 949 "../src/widgets/ItemView.vala"
	_tmp0_ = self->priv->manager;
#line 949 "../src/widgets/ItemView.vala"
	desktop_folder_item_manager_cut (_tmp0_);
#line 5421 "ItemView.c"
}

/**
     * @name copy
     * @description copy the file to the clipboard
     */
void
desktop_folder_item_view_copy (DesktopFolderItemView* self)
{
	DesktopFolderItemManager* _tmp0_;
#line 956 "../src/widgets/ItemView.vala"
	g_return_if_fail (self != NULL);
#line 957 "../src/widgets/ItemView.vala"
	_tmp0_ = self->priv->manager;
#line 957 "../src/widgets/ItemView.vala"
	desktop_folder_item_manager_copy (_tmp0_);
#line 5438 "ItemView.c"
}

/**
     * @name copy
     * @description copy the file to the clipboard
     */
void
desktop_folder_item_view_trash (DesktopFolderItemView* self)
{
	DesktopFolderItemManager* _tmp0_;
#line 964 "../src/widgets/ItemView.vala"
	g_return_if_fail (self != NULL);
#line 965 "../src/widgets/ItemView.vala"
	_tmp0_ = self->priv->manager;
#line 965 "../src/widgets/ItemView.vala"
	desktop_folder_item_manager_trash (_tmp0_);
#line 5455 "ItemView.c"
}

/**
     * @name delete_dialog
     * @description the user wants to delete the item. It should be confirmed before the deletion occurs
     */
static Block24Data*
block24_data_ref (Block24Data* _data24_)
{
#line 972 "../src/widgets/ItemView.vala"
	g_atomic_int_inc (&_data24_->_ref_count_);
#line 972 "../src/widgets/ItemView.vala"
	return _data24_;
#line 5469 "ItemView.c"
}

static void
block24_data_unref (void * _userdata_)
{
	Block24Data* _data24_;
	_data24_ = (Block24Data*) _userdata_;
#line 972 "../src/widgets/ItemView.vala"
	if (g_atomic_int_dec_and_test (&_data24_->_ref_count_)) {
#line 5479 "ItemView.c"
		DesktopFolderItemView* self;
#line 972 "../src/widgets/ItemView.vala"
		self = _data24_->self;
#line 972 "../src/widgets/ItemView.vala"
		_g_object_unref0 (_data24_->msg);
#line 972 "../src/widgets/ItemView.vala"
		_g_object_unref0 (self);
#line 972 "../src/widgets/ItemView.vala"
		g_slice_free (Block24Data, _data24_);
#line 5489 "ItemView.c"
	}
}

static void
__lambda121_ (Block24Data* _data24_,
              gint response_id)
{
	DesktopFolderItemView* self;
#line 986 "../src/widgets/ItemView.vala"
	self = _data24_->self;
#line 987 "../src/widgets/ItemView.vala"
	switch (response_id) {
#line 987 "../src/widgets/ItemView.vala"
		case GTK_RESPONSE_OK:
#line 5504 "ItemView.c"
		{
#line 989 "../src/widgets/ItemView.vala"
			gtk_widget_destroy ((GtkWidget*) _data24_->msg);
#line 990 "../src/widgets/ItemView.vala"
			if (_data24_->isdir) {
#line 5510 "ItemView.c"
				DesktopFolderItemManager* _tmp0_;
#line 991 "../src/widgets/ItemView.vala"
				_tmp0_ = self->priv->manager;
#line 991 "../src/widgets/ItemView.vala"
				desktop_folder_item_manager_trash (_tmp0_);
#line 992 "../src/widgets/ItemView.vala"
				break;
#line 5518 "ItemView.c"
			} else {
				DesktopFolderItemManager* _tmp1_;
#line 994 "../src/widgets/ItemView.vala"
				_tmp1_ = self->priv->manager;
#line 994 "../src/widgets/ItemView.vala"
				desktop_folder_item_manager_trash (_tmp1_);
#line 5525 "ItemView.c"
			}
#line 996 "../src/widgets/ItemView.vala"
			break;
#line 5529 "ItemView.c"
		}
		default:
		{
#line 998 "../src/widgets/ItemView.vala"
			gtk_widget_destroy ((GtkWidget*) _data24_->msg);
#line 999 "../src/widgets/ItemView.vala"
			break;
#line 5537 "ItemView.c"
		}
	}
}

static void
___lambda121__gtk_dialog_response (GtkDialog* _sender,
                                   gint response_id,
                                   gpointer self)
{
#line 986 "../src/widgets/ItemView.vala"
	__lambda121_ (self, response_id);
#line 5549 "ItemView.c"
}

void
desktop_folder_item_view_delete_dialog (DesktopFolderItemView* self)
{
	Block24Data* _data24_;
	gchar* message = NULL;
	gchar* _tmp0_;
	GtkWindow* window = NULL;
	GtkWidget* _tmp1_;
	GtkWindow* _tmp2_;
	DesktopFolderItemManager* _tmp3_;
	DesktopFolderItemManager* _tmp5_;
	GtkWindow* _tmp7_;
	const gchar* _tmp8_;
	GtkMessageDialog* _tmp9_;
#line 972 "../src/widgets/ItemView.vala"
	g_return_if_fail (self != NULL);
#line 972 "../src/widgets/ItemView.vala"
	_data24_ = g_slice_new0 (Block24Data);
#line 972 "../src/widgets/ItemView.vala"
	_data24_->_ref_count_ = 1;
#line 972 "../src/widgets/ItemView.vala"
	_data24_->self = g_object_ref (self);
#line 973 "../src/widgets/ItemView.vala"
	_tmp0_ = g_strdup (DESKTOP_FOLDER_LANG_ITEM_DELETE_FOLDER_MESSAGE);
#line 973 "../src/widgets/ItemView.vala"
	message = _tmp0_;
#line 974 "../src/widgets/ItemView.vala"
	_tmp1_ = gtk_widget_get_toplevel ((GtkWidget*) self);
#line 974 "../src/widgets/ItemView.vala"
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_window_get_type (), GtkWindow));
#line 974 "../src/widgets/ItemView.vala"
	window = _tmp2_;
#line 975 "../src/widgets/ItemView.vala"
	_tmp3_ = self->priv->manager;
#line 975 "../src/widgets/ItemView.vala"
	_data24_->isdir = desktop_folder_dragn_drop_dnd_view_is_folder ((DesktopFolderDragnDropDndView*) _tmp3_);
#line 976 "../src/widgets/ItemView.vala"
	if (!_data24_->isdir) {
#line 5590 "ItemView.c"
		gchar* _tmp4_;
#line 977 "../src/widgets/ItemView.vala"
		_tmp4_ = g_strdup (DESKTOP_FOLDER_LANG_ITEM_DELETE_FILE_MESSAGE);
#line 977 "../src/widgets/ItemView.vala"
		_g_free0 (message);
#line 977 "../src/widgets/ItemView.vala"
		message = _tmp4_;
#line 5598 "ItemView.c"
	}
#line 979 "../src/widgets/ItemView.vala"
	_tmp5_ = self->priv->manager;
#line 979 "../src/widgets/ItemView.vala"
	if (desktop_folder_item_manager_is_link (_tmp5_)) {
#line 5604 "ItemView.c"
		gchar* _tmp6_;
#line 980 "../src/widgets/ItemView.vala"
		_tmp6_ = g_strdup (DESKTOP_FOLDER_LANG_ITEM_DELETE_LINK_MESSAGE);
#line 980 "../src/widgets/ItemView.vala"
		_g_free0 (message);
#line 980 "../src/widgets/ItemView.vala"
		message = _tmp6_;
#line 5612 "ItemView.c"
	}
#line 983 "../src/widgets/ItemView.vala"
	_tmp7_ = window;
#line 983 "../src/widgets/ItemView.vala"
	_tmp8_ = message;
#line 983 "../src/widgets/ItemView.vala"
	_tmp9_ = (GtkMessageDialog*) gtk_message_dialog_new (_tmp7_, GTK_DIALOG_MODAL, GTK_MESSAGE_WARNING, GTK_BUTTONS_OK_CANCEL, "%s", _tmp8_);
#line 983 "../src/widgets/ItemView.vala"
	g_object_ref_sink (_tmp9_);
#line 983 "../src/widgets/ItemView.vala"
	_data24_->msg = _tmp9_;
#line 985 "../src/widgets/ItemView.vala"
	g_object_set (_data24_->msg, "use-markup", TRUE, NULL);
#line 986 "../src/widgets/ItemView.vala"
	g_signal_connect_data ((GtkDialog*) _data24_->msg, "response", (GCallback) ___lambda121__gtk_dialog_response, block24_data_ref (_data24_), (GClosureNotify) block24_data_unref, 0);
#line 1003 "../src/widgets/ItemView.vala"
	gtk_widget_show ((GtkWidget*) _data24_->msg);
#line 972 "../src/widgets/ItemView.vala"
	_g_object_unref0 (window);
#line 972 "../src/widgets/ItemView.vala"
	_g_free0 (message);
#line 972 "../src/widgets/ItemView.vala"
	block24_data_unref (_data24_);
#line 972 "../src/widgets/ItemView.vala"
	_data24_ = NULL;
#line 5638 "ItemView.c"
}

/**
     * @name change_icon
     * @description change the icon of an executable item
     */
static void
desktop_folder_item_view_change_icon (DesktopFolderItemView* self)
{
	GtkFileChooserDialog* chooser = NULL;
	DesktopFolderItemManager* _tmp0_;
	GtkApplicationWindow* _tmp1_;
	GtkApplicationWindow* _tmp2_;
	GtkFileChooserDialog* _tmp3_;
	GtkFileChooserDialog* _tmp4_;
	GtkFileFilter* filter = NULL;
	GtkFileFilter* _tmp5_;
	GtkFileFilter* _tmp6_;
	GtkFileFilter* _tmp7_;
	GtkFileFilter* _tmp8_;
	GtkFileFilter* _tmp9_;
	GtkFileFilter* _tmp10_;
	GtkFileFilter* _tmp11_;
	GtkFileFilter* _tmp12_;
	GtkFileFilter* _tmp13_;
	GtkFileFilter* _tmp14_;
	GtkFileFilter* _tmp15_;
	GtkFileFilter* _tmp16_;
	GtkFileFilter* _tmp17_;
	GtkFileChooserDialog* _tmp18_;
	GtkFileFilter* _tmp19_;
	GtkFileFilter* _tmp20_;
	GtkFileChooserDialog* _tmp21_;
	GtkFileChooserDialog* _tmp26_;
#line 1010 "../src/widgets/ItemView.vala"
	g_return_if_fail (self != NULL);
#line 1011 "../src/widgets/ItemView.vala"
	_tmp0_ = self->priv->manager;
#line 1011 "../src/widgets/ItemView.vala"
	_tmp1_ = desktop_folder_dragn_drop_dnd_view_get_application_window ((DesktopFolderDragnDropDndView*) _tmp0_);
#line 1011 "../src/widgets/ItemView.vala"
	_tmp2_ = _tmp1_;
#line 1011 "../src/widgets/ItemView.vala"
	_tmp3_ = (GtkFileChooserDialog*) gtk_file_chooser_dialog_new (DESKTOP_FOLDER_LANG_ITEM_CHANGEICON_MESSAGE, (GtkWindow*) _tmp2_, GTK_FILE_CHOOSER_ACTION_OPEN, DESKTOP_FOLDER_LANG_DIALOG_CANCEL, GTK_RESPONSE_CANCEL, DESKTOP_FOLDER_LANG_DIALOG_SELECT, GTK_RESPONSE_ACCEPT, NULL);
#line 1011 "../src/widgets/ItemView.vala"
	g_object_ref_sink (_tmp3_);
#line 1011 "../src/widgets/ItemView.vala"
	_tmp4_ = _tmp3_;
#line 1011 "../src/widgets/ItemView.vala"
	_g_object_unref0 (_tmp2_);
#line 1011 "../src/widgets/ItemView.vala"
	chooser = _tmp4_;
#line 1019 "../src/widgets/ItemView.vala"
	_tmp5_ = gtk_file_filter_new ();
#line 1019 "../src/widgets/ItemView.vala"
	g_object_ref_sink (_tmp5_);
#line 1019 "../src/widgets/ItemView.vala"
	filter = _tmp5_;
#line 1020 "../src/widgets/ItemView.vala"
	_tmp6_ = filter;
#line 1020 "../src/widgets/ItemView.vala"
	gtk_buildable_set_name ((GtkBuildable*) _tmp6_, "Images");
#line 1021 "../src/widgets/ItemView.vala"
	_tmp7_ = filter;
#line 1021 "../src/widgets/ItemView.vala"
	gtk_file_filter_add_mime_type (_tmp7_, "image");
#line 1022 "../src/widgets/ItemView.vala"
	_tmp8_ = filter;
#line 1022 "../src/widgets/ItemView.vala"
	gtk_file_filter_add_mime_type (_tmp8_, "image/png");
#line 1023 "../src/widgets/ItemView.vala"
	_tmp9_ = filter;
#line 1023 "../src/widgets/ItemView.vala"
	gtk_file_filter_add_mime_type (_tmp9_, "image/jpeg");
#line 1024 "../src/widgets/ItemView.vala"
	_tmp10_ = filter;
#line 1024 "../src/widgets/ItemView.vala"
	gtk_file_filter_add_mime_type (_tmp10_, "image/gif");
#line 1025 "../src/widgets/ItemView.vala"
	_tmp11_ = filter;
#line 1025 "../src/widgets/ItemView.vala"
	gtk_file_filter_add_mime_type (_tmp11_, "image/svg+xml");
#line 1026 "../src/widgets/ItemView.vala"
	_tmp12_ = filter;
#line 1026 "../src/widgets/ItemView.vala"
	gtk_file_filter_add_pattern (_tmp12_, "*.png");
#line 1027 "../src/widgets/ItemView.vala"
	_tmp13_ = filter;
#line 1027 "../src/widgets/ItemView.vala"
	gtk_file_filter_add_pattern (_tmp13_, "*.jpg");
#line 1028 "../src/widgets/ItemView.vala"
	_tmp14_ = filter;
#line 1028 "../src/widgets/ItemView.vala"
	gtk_file_filter_add_pattern (_tmp14_, "*.svg");
#line 1029 "../src/widgets/ItemView.vala"
	_tmp15_ = filter;
#line 1029 "../src/widgets/ItemView.vala"
	gtk_file_filter_add_pattern (_tmp15_, "*.gif");
#line 1030 "../src/widgets/ItemView.vala"
	_tmp16_ = filter;
#line 1030 "../src/widgets/ItemView.vala"
	gtk_file_filter_add_pattern (_tmp16_, "*.tif");
#line 1031 "../src/widgets/ItemView.vala"
	_tmp17_ = filter;
#line 1031 "../src/widgets/ItemView.vala"
	gtk_file_filter_add_pattern (_tmp17_, "*.xpm");
#line 1032 "../src/widgets/ItemView.vala"
	_tmp18_ = chooser;
#line 1032 "../src/widgets/ItemView.vala"
	_tmp19_ = filter;
#line 1032 "../src/widgets/ItemView.vala"
	_tmp20_ = _g_object_ref0 (_tmp19_);
#line 1032 "../src/widgets/ItemView.vala"
	gtk_file_chooser_add_filter ((GtkFileChooser*) _tmp18_, _tmp20_);
#line 1035 "../src/widgets/ItemView.vala"
	_tmp21_ = chooser;
#line 1035 "../src/widgets/ItemView.vala"
	if (gtk_dialog_run ((GtkDialog*) _tmp21_) == ((gint) GTK_RESPONSE_ACCEPT)) {
#line 5757 "ItemView.c"
		gchar* filename = NULL;
		GtkFileChooserDialog* _tmp22_;
		gchar* _tmp23_;
		DesktopFolderItemManager* _tmp24_;
		const gchar* _tmp25_;
#line 1036 "../src/widgets/ItemView.vala"
		_tmp22_ = chooser;
#line 1036 "../src/widgets/ItemView.vala"
		_tmp23_ = gtk_file_chooser_get_filename ((GtkFileChooser*) _tmp22_);
#line 1036 "../src/widgets/ItemView.vala"
		filename = _tmp23_;
#line 1037 "../src/widgets/ItemView.vala"
		_tmp24_ = self->priv->manager;
#line 1037 "../src/widgets/ItemView.vala"
		_tmp25_ = filename;
#line 1037 "../src/widgets/ItemView.vala"
		desktop_folder_item_manager_change_icon (_tmp24_, _tmp25_);
#line 1035 "../src/widgets/ItemView.vala"
		_g_free0 (filename);
#line 5777 "ItemView.c"
	}
#line 1039 "../src/widgets/ItemView.vala"
	_tmp26_ = chooser;
#line 1039 "../src/widgets/ItemView.vala"
	g_signal_emit_by_name ((GtkDialog*) _tmp26_, "close");
#line 1010 "../src/widgets/ItemView.vala"
	_g_object_unref0 (filter);
#line 1010 "../src/widgets/ItemView.vala"
	_g_object_unref0 (chooser);
#line 5787 "ItemView.c"
}

/**
     * @name modify
     * @description raise the flat modify
     */
void
desktop_folder_item_view_modify (DesktopFolderItemView* self)
{
#line 1046 "../src/widgets/ItemView.vala"
	g_return_if_fail (self != NULL);
#line 1047 "../src/widgets/ItemView.vala"
	self->priv->flagModified = TRUE;
#line 5801 "ItemView.c"
}

void
desktop_folder_item_view_get_bounding_box (DesktopFolderItemView* self,
                                           GdkRectangle* result)
{
	GtkAllocation allocation = {0};
	GtkAllocation _tmp0_ = {0};
	GtkAllocation _tmp1_;
	GtkAllocation _tmp2_;
#line 1050 "../src/widgets/ItemView.vala"
	g_return_if_fail (self != NULL);
#line 1052 "../src/widgets/ItemView.vala"
	gtk_widget_get_allocation ((GtkWidget*) self, &_tmp0_);
#line 1052 "../src/widgets/ItemView.vala"
	allocation = _tmp0_;
#line 1053 "../src/widgets/ItemView.vala"
	_tmp1_ = allocation;
#line 1053 "../src/widgets/ItemView.vala"
	allocation.y = _tmp1_.y + DESKTOP_FOLDER_ITEM_VIEW_PADDING_Y;
#line 1054 "../src/widgets/ItemView.vala"
	_tmp2_ = allocation;
#line 1054 "../src/widgets/ItemView.vala"
	allocation.x = _tmp2_.x + DESKTOP_FOLDER_ITEM_VIEW_PADDING_X;
#line 1055 "../src/widgets/ItemView.vala"
	*result = allocation;
#line 1055 "../src/widgets/ItemView.vala"
	return;
#line 5830 "ItemView.c"
}

/**
     * @name on_motion
     * @description the on_motion event captured to allow the movement of the icon
     * @param EventMotion event @see the on_motion signal
     * @return bool @see the on_motion signal
     */
static gboolean
desktop_folder_item_view_on_motion (DesktopFolderItemView* self,
                                    GdkEventMotion* event)
{
	gboolean _tmp0_ = FALSE;
	DesktopFolderItemManager* _tmp1_;
	DesktopFolderFolderManager* _tmp2_;
	DesktopFolderFolderManager* _tmp3_;
	gboolean _tmp4_;
	gboolean result;
#line 1064 "../src/widgets/ItemView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1064 "../src/widgets/ItemView.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 1065 "../src/widgets/ItemView.vala"
	_tmp1_ = self->priv->manager;
#line 1065 "../src/widgets/ItemView.vala"
	_tmp2_ = desktop_folder_item_manager_get_folder (_tmp1_);
#line 1065 "../src/widgets/ItemView.vala"
	_tmp3_ = _tmp2_;
#line 1065 "../src/widgets/ItemView.vala"
	_tmp4_ = !desktop_folder_folder_manager_are_items_locked (_tmp3_);
#line 1065 "../src/widgets/ItemView.vala"
	_g_object_unref0 (_tmp3_);
#line 1065 "../src/widgets/ItemView.vala"
	if (_tmp4_) {
#line 5865 "ItemView.c"
		DesktopFolderItemManager* _tmp5_;
		DesktopFolderFolderManager* _tmp6_;
		DesktopFolderFolderManager* _tmp7_;
		DesktopFolderFolderArrangement* _tmp8_;
		DesktopFolderFolderArrangement* _tmp9_;
#line 1065 "../src/widgets/ItemView.vala"
		_tmp5_ = self->priv->manager;
#line 1065 "../src/widgets/ItemView.vala"
		_tmp6_ = desktop_folder_item_manager_get_folder (_tmp5_);
#line 1065 "../src/widgets/ItemView.vala"
		_tmp7_ = _tmp6_;
#line 1065 "../src/widgets/ItemView.vala"
		_tmp8_ = desktop_folder_folder_manager_get_arrangement (_tmp7_);
#line 1065 "../src/widgets/ItemView.vala"
		_tmp9_ = _tmp8_;
#line 1065 "../src/widgets/ItemView.vala"
		_tmp0_ = desktop_folder_folder_arrangement_can_drag (_tmp9_);
#line 1065 "../src/widgets/ItemView.vala"
		_g_object_unref0 (_tmp9_);
#line 1065 "../src/widgets/ItemView.vala"
		_g_object_unref0 (_tmp7_);
#line 5887 "ItemView.c"
	} else {
#line 1065 "../src/widgets/ItemView.vala"
		_tmp0_ = FALSE;
#line 5891 "ItemView.c"
	}
#line 1065 "../src/widgets/ItemView.vala"
	if (_tmp0_) {
#line 5895 "ItemView.c"
		DesktopFolderEditableLabel* _tmp10_;
		gboolean _tmp11_;
		gboolean _tmp12_;
		GdkModifierType mods = 0U;
		gboolean control_pressed = FALSE;
		gint x = 0;
		gint y = 0;
		DesktopFolderFolderSettings* folder_settings = NULL;
		DesktopFolderItemManager* _tmp18_;
		DesktopFolderFolderManager* _tmp19_;
		DesktopFolderFolderManager* _tmp20_;
		DesktopFolderFolderSettings* _tmp21_;
		DesktopFolderFolderSettings* _tmp22_;
		DesktopFolderFolderSettings* _tmp23_;
		gint _tmp24_;
		gint _tmp25_;
		DesktopFolderFolderSettings* _tmp26_;
		gint _tmp27_;
		gint _tmp28_;
		GdkRectangle icon_rectangle = {0};
		gint qwidth = 0;
		GeeList* ims = NULL;
		DesktopFolderItemManager* _tmp29_;
		DesktopFolderFolderManager* _tmp30_;
		DesktopFolderFolderManager* _tmp31_;
		GdkRectangle _tmp32_;
		GeeList* _tmp33_;
		GeeList* _tmp34_;
		gboolean _tmp50_ = FALSE;
#line 1068 "../src/widgets/ItemView.vala"
		_tmp10_ = self->priv->label;
#line 1068 "../src/widgets/ItemView.vala"
		_tmp11_ = desktop_folder_editable_label_get_editing (_tmp10_);
#line 1068 "../src/widgets/ItemView.vala"
		_tmp12_ = _tmp11_;
#line 1068 "../src/widgets/ItemView.vala"
		if (_tmp12_) {
#line 1070 "../src/widgets/ItemView.vala"
			result = FALSE;
#line 1070 "../src/widgets/ItemView.vala"
			return result;
#line 5937 "ItemView.c"
		}
#line 1072 "../src/widgets/ItemView.vala"
		mods = event->state & gtk_accelerator_get_default_mod_mask ();
#line 1073 "../src/widgets/ItemView.vala"
		control_pressed = (mods & GDK_CONTROL_MASK) != 0;
#line 1074 "../src/widgets/ItemView.vala"
		if (control_pressed) {
#line 1075 "../src/widgets/ItemView.vala"
			result = FALSE;
#line 1075 "../src/widgets/ItemView.vala"
			return result;
#line 5949 "ItemView.c"
		}
#line 1079 "../src/widgets/ItemView.vala"
		self->priv->flagModified = TRUE;
#line 1081 "../src/widgets/ItemView.vala"
		if (!self->priv->flagMoved) {
#line 5955 "ItemView.c"
			DesktopFolderItemManager* _tmp13_;
			DesktopFolderFolderManager* _tmp14_;
			DesktopFolderFolderManager* _tmp15_;
			DesktopFolderFolderWindow* _tmp16_;
			DesktopFolderFolderWindow* _tmp17_;
#line 1083 "../src/widgets/ItemView.vala"
			_tmp13_ = self->priv->manager;
#line 1083 "../src/widgets/ItemView.vala"
			_tmp14_ = desktop_folder_item_manager_get_folder (_tmp13_);
#line 1083 "../src/widgets/ItemView.vala"
			_tmp15_ = _tmp14_;
#line 1083 "../src/widgets/ItemView.vala"
			_tmp16_ = desktop_folder_folder_manager_get_view (_tmp15_);
#line 1083 "../src/widgets/ItemView.vala"
			_tmp17_ = _tmp16_;
#line 1083 "../src/widgets/ItemView.vala"
			desktop_folder_folder_window_on_item_moving (_tmp17_, TRUE);
#line 1083 "../src/widgets/ItemView.vala"
			_g_object_unref0 (_tmp17_);
#line 1083 "../src/widgets/ItemView.vala"
			_g_object_unref0 (_tmp15_);
#line 1084 "../src/widgets/ItemView.vala"
			self->priv->flagMoved = TRUE;
#line 5979 "ItemView.c"
		}
#line 1092 "../src/widgets/ItemView.vala"
		x = ((gint) event->x_root) - self->priv->offsetx;
#line 1093 "../src/widgets/ItemView.vala"
		y = ((gint) event->y_root) - self->priv->offsety;
#line 1102 "../src/widgets/ItemView.vala"
		_tmp18_ = self->priv->manager;
#line 1102 "../src/widgets/ItemView.vala"
		_tmp19_ = desktop_folder_item_manager_get_folder (_tmp18_);
#line 1102 "../src/widgets/ItemView.vala"
		_tmp20_ = _tmp19_;
#line 1102 "../src/widgets/ItemView.vala"
		_tmp21_ = desktop_folder_folder_manager_get_settings (_tmp20_);
#line 1102 "../src/widgets/ItemView.vala"
		_tmp22_ = _tmp21_;
#line 1102 "../src/widgets/ItemView.vala"
		_g_object_unref0 (_tmp20_);
#line 1102 "../src/widgets/ItemView.vala"
		folder_settings = _tmp22_;
#line 1103 "../src/widgets/ItemView.vala"
		_tmp23_ = folder_settings;
#line 1103 "../src/widgets/ItemView.vala"
		_tmp24_ = desktop_folder_position_settings_get_x ((DesktopFolderPositionSettings*) _tmp23_);
#line 1103 "../src/widgets/ItemView.vala"
		_tmp25_ = _tmp24_;
#line 1103 "../src/widgets/ItemView.vala"
		x = (x - _tmp25_) + DESKTOP_FOLDER_WINDOW_DECORATION_MARGIN;
#line 1104 "../src/widgets/ItemView.vala"
		_tmp26_ = folder_settings;
#line 1104 "../src/widgets/ItemView.vala"
		_tmp27_ = desktop_folder_position_settings_get_y ((DesktopFolderPositionSettings*) _tmp26_);
#line 1104 "../src/widgets/ItemView.vala"
		_tmp28_ = _tmp27_;
#line 1104 "../src/widgets/ItemView.vala"
		y = (y - _tmp28_) + DESKTOP_FOLDER_WINDOW_DECORATION_MARGIN;
#line 1108 "../src/widgets/ItemView.vala"
		memset (&icon_rectangle, 0, sizeof (GdkRectangle));
#line 1109 "../src/widgets/ItemView.vala"
		qwidth = DESKTOP_FOLDER_ICON_DEFAULT_WIDTH / 2;
#line 1110 "../src/widgets/ItemView.vala"
		icon_rectangle.x = x + qwidth;
#line 1111 "../src/widgets/ItemView.vala"
		icon_rectangle.y = y + qwidth;
#line 1112 "../src/widgets/ItemView.vala"
		icon_rectangle.width = DESKTOP_FOLDER_ICON_DEFAULT_WIDTH - qwidth;
#line 1113 "../src/widgets/ItemView.vala"
		icon_rectangle.height = DESKTOP_FOLDER_ICON_DEFAULT_WIDTH - qwidth;
#line 1114 "../src/widgets/ItemView.vala"
		_tmp29_ = self->priv->manager;
#line 1114 "../src/widgets/ItemView.vala"
		_tmp30_ = desktop_folder_item_manager_get_folder (_tmp29_);
#line 1114 "../src/widgets/ItemView.vala"
		_tmp31_ = _tmp30_;
#line 1114 "../src/widgets/ItemView.vala"
		_tmp32_ = icon_rectangle;
#line 1114 "../src/widgets/ItemView.vala"
		_tmp33_ = desktop_folder_folder_manager_get_items_at (_tmp31_, &_tmp32_);
#line 1114 "../src/widgets/ItemView.vala"
		_tmp34_ = _tmp33_;
#line 1114 "../src/widgets/ItemView.vala"
		_g_object_unref0 (_tmp31_);
#line 1114 "../src/widgets/ItemView.vala"
		ims = _tmp34_;
#line 6043 "ItemView.c"
		{
			gint i = 0;
#line 1115 "../src/widgets/ItemView.vala"
			i = 0;
#line 6048 "ItemView.c"
			{
				gboolean _tmp35_ = FALSE;
#line 1115 "../src/widgets/ItemView.vala"
				_tmp35_ = TRUE;
#line 1115 "../src/widgets/ItemView.vala"
				while (TRUE) {
#line 6055 "ItemView.c"
					GeeList* _tmp37_;
					gint _tmp38_;
					gint _tmp39_;
					DesktopFolderItemManager* im = NULL;
					GeeList* _tmp40_;
					gpointer _tmp41_;
					gboolean _tmp42_ = FALSE;
					gboolean _tmp43_ = FALSE;
					gboolean _tmp44_ = FALSE;
					DesktopFolderItemManager* _tmp45_;
#line 1115 "../src/widgets/ItemView.vala"
					if (!_tmp35_) {
#line 6068 "ItemView.c"
						gint _tmp36_;
#line 1115 "../src/widgets/ItemView.vala"
						_tmp36_ = i;
#line 1115 "../src/widgets/ItemView.vala"
						i = _tmp36_ + 1;
#line 6074 "ItemView.c"
					}
#line 1115 "../src/widgets/ItemView.vala"
					_tmp35_ = FALSE;
#line 1115 "../src/widgets/ItemView.vala"
					_tmp37_ = ims;
#line 1115 "../src/widgets/ItemView.vala"
					_tmp38_ = gee_collection_get_size ((GeeCollection*) _tmp37_);
#line 1115 "../src/widgets/ItemView.vala"
					_tmp39_ = _tmp38_;
#line 1115 "../src/widgets/ItemView.vala"
					if (!(i < _tmp39_)) {
#line 1115 "../src/widgets/ItemView.vala"
						break;
#line 6088 "ItemView.c"
					}
#line 1116 "../src/widgets/ItemView.vala"
					_tmp40_ = ims;
#line 1116 "../src/widgets/ItemView.vala"
					_tmp41_ = gee_list_get (_tmp40_, i);
#line 1116 "../src/widgets/ItemView.vala"
					im = (DesktopFolderItemManager*) _tmp41_;
#line 1120 "../src/widgets/ItemView.vala"
					_tmp45_ = im;
#line 1120 "../src/widgets/ItemView.vala"
					if (_tmp45_ != NULL) {
#line 6100 "ItemView.c"
						DesktopFolderItemManager* _tmp46_;
						DesktopFolderItemManager* _tmp47_;
#line 1120 "../src/widgets/ItemView.vala"
						_tmp46_ = im;
#line 1120 "../src/widgets/ItemView.vala"
						_tmp47_ = self->priv->manager;
#line 1120 "../src/widgets/ItemView.vala"
						_tmp44_ = _tmp46_ != _tmp47_;
#line 6109 "ItemView.c"
					} else {
#line 1120 "../src/widgets/ItemView.vala"
						_tmp44_ = FALSE;
#line 6113 "ItemView.c"
					}
#line 1120 "../src/widgets/ItemView.vala"
					if (_tmp44_) {
#line 6117 "ItemView.c"
						DesktopFolderItemManager* _tmp48_;
#line 1120 "../src/widgets/ItemView.vala"
						_tmp48_ = im;
#line 1120 "../src/widgets/ItemView.vala"
						_tmp43_ = desktop_folder_dragn_drop_dnd_view_is_folder ((DesktopFolderDragnDropDndView*) _tmp48_);
#line 6123 "ItemView.c"
					} else {
#line 1120 "../src/widgets/ItemView.vala"
						_tmp43_ = FALSE;
#line 6127 "ItemView.c"
					}
#line 1120 "../src/widgets/ItemView.vala"
					if (_tmp43_) {
#line 6131 "ItemView.c"
						DesktopFolderItemManager* _tmp49_;
#line 1120 "../src/widgets/ItemView.vala"
						_tmp49_ = im;
#line 1120 "../src/widgets/ItemView.vala"
						_tmp42_ = !desktop_folder_item_manager_is_selected (_tmp49_);
#line 6137 "ItemView.c"
					} else {
#line 1120 "../src/widgets/ItemView.vala"
						_tmp42_ = FALSE;
#line 6141 "ItemView.c"
					}
#line 1120 "../src/widgets/ItemView.vala"
					if (_tmp42_) {
#line 1121 "../src/widgets/ItemView.vala"
						desktop_folder_item_view_cancel_movement_and_start_drag_action (self, (GdkEvent*) event);
#line 1122 "../src/widgets/ItemView.vala"
						_g_object_unref0 (im);
#line 1122 "../src/widgets/ItemView.vala"
						break;
#line 6151 "ItemView.c"
					}
#line 1115 "../src/widgets/ItemView.vala"
					_g_object_unref0 (im);
#line 6155 "ItemView.c"
				}
			}
		}
#line 1137 "../src/widgets/ItemView.vala"
		if (x != self->priv->px) {
#line 1137 "../src/widgets/ItemView.vala"
			_tmp50_ = TRUE;
#line 6163 "ItemView.c"
		} else {
#line 1137 "../src/widgets/ItemView.vala"
			_tmp50_ = y != self->priv->py;
#line 6167 "ItemView.c"
		}
#line 1137 "../src/widgets/ItemView.vala"
		if (_tmp50_) {
#line 6171 "ItemView.c"
			GtkAllocation allocation0 = {0};
			GtkAllocation _tmp51_ = {0};
			DesktopFolderFolderWindow* window = NULL;
			DesktopFolderItemManager* _tmp52_;
			DesktopFolderFolderManager* _tmp53_;
			DesktopFolderFolderManager* _tmp54_;
			DesktopFolderFolderWindow* _tmp55_;
			DesktopFolderFolderWindow* _tmp56_;
			DesktopFolderFolderWindow* _tmp57_;
			gint diff_x = 0;
			GtkAllocation _tmp58_;
			gint diff_y = 0;
			GtkAllocation _tmp59_;
			GeeList* selecteds = NULL;
			DesktopFolderItemManager* _tmp60_;
			DesktopFolderFolderManager* _tmp61_;
			DesktopFolderFolderManager* _tmp62_;
			GeeList* _tmp63_;
			GeeList* _tmp64_;
			DesktopFolderItemManager* _tmp79_;
			DesktopFolderFolderManager* _tmp80_;
			DesktopFolderFolderManager* _tmp81_;
			DesktopFolderFolderArrangement* _tmp82_;
			DesktopFolderFolderArrangement* _tmp83_;
#line 1138 "../src/widgets/ItemView.vala"
			self->priv->px = x;
#line 1139 "../src/widgets/ItemView.vala"
			self->priv->py = y;
#line 1142 "../src/widgets/ItemView.vala"
			gtk_widget_get_allocation ((GtkWidget*) self, &_tmp51_);
#line 1142 "../src/widgets/ItemView.vala"
			allocation0 = _tmp51_;
#line 1143 "../src/widgets/ItemView.vala"
			_tmp52_ = self->priv->manager;
#line 1143 "../src/widgets/ItemView.vala"
			_tmp53_ = desktop_folder_item_manager_get_folder (_tmp52_);
#line 1143 "../src/widgets/ItemView.vala"
			_tmp54_ = _tmp53_;
#line 1143 "../src/widgets/ItemView.vala"
			_tmp55_ = desktop_folder_folder_manager_get_view (_tmp54_);
#line 1143 "../src/widgets/ItemView.vala"
			_tmp56_ = _tmp55_;
#line 1143 "../src/widgets/ItemView.vala"
			_g_object_unref0 (_tmp54_);
#line 1143 "../src/widgets/ItemView.vala"
			window = _tmp56_;
#line 1144 "../src/widgets/ItemView.vala"
			_tmp57_ = window;
#line 1144 "../src/widgets/ItemView.vala"
			desktop_folder_folder_window_move_item (_tmp57_, self, x + DESKTOP_FOLDER_ITEM_VIEW_PADDING_X, y);
#line 1145 "../src/widgets/ItemView.vala"
			_tmp58_ = allocation0;
#line 1145 "../src/widgets/ItemView.vala"
			diff_x = _tmp58_.x - (x + DESKTOP_FOLDER_ITEM_VIEW_PADDING_X);
#line 1146 "../src/widgets/ItemView.vala"
			_tmp59_ = allocation0;
#line 1146 "../src/widgets/ItemView.vala"
			diff_y = _tmp59_.y - y;
#line 1149 "../src/widgets/ItemView.vala"
			_tmp60_ = self->priv->manager;
#line 1149 "../src/widgets/ItemView.vala"
			_tmp61_ = desktop_folder_item_manager_get_folder (_tmp60_);
#line 1149 "../src/widgets/ItemView.vala"
			_tmp62_ = _tmp61_;
#line 1149 "../src/widgets/ItemView.vala"
			_tmp63_ = desktop_folder_folder_manager_get_selected_items (_tmp62_);
#line 1149 "../src/widgets/ItemView.vala"
			_tmp64_ = _tmp63_;
#line 1149 "../src/widgets/ItemView.vala"
			_g_object_unref0 (_tmp62_);
#line 1149 "../src/widgets/ItemView.vala"
			selecteds = _tmp64_;
#line 6244 "ItemView.c"
			{
				gint i = 0;
#line 1150 "../src/widgets/ItemView.vala"
				i = 0;
#line 6249 "ItemView.c"
				{
					gboolean _tmp65_ = FALSE;
#line 1150 "../src/widgets/ItemView.vala"
					_tmp65_ = TRUE;
#line 1150 "../src/widgets/ItemView.vala"
					while (TRUE) {
#line 6256 "ItemView.c"
						GeeList* _tmp67_;
						gint _tmp68_;
						gint _tmp69_;
						DesktopFolderItemView* selected = NULL;
						GeeList* _tmp70_;
						gpointer _tmp71_;
						DesktopFolderItemView* _tmp72_;
#line 1150 "../src/widgets/ItemView.vala"
						if (!_tmp65_) {
#line 6266 "ItemView.c"
							gint _tmp66_;
#line 1150 "../src/widgets/ItemView.vala"
							_tmp66_ = i;
#line 1150 "../src/widgets/ItemView.vala"
							i = _tmp66_ + 1;
#line 6272 "ItemView.c"
						}
#line 1150 "../src/widgets/ItemView.vala"
						_tmp65_ = FALSE;
#line 1150 "../src/widgets/ItemView.vala"
						_tmp67_ = selecteds;
#line 1150 "../src/widgets/ItemView.vala"
						_tmp68_ = gee_collection_get_size ((GeeCollection*) _tmp67_);
#line 1150 "../src/widgets/ItemView.vala"
						_tmp69_ = _tmp68_;
#line 1150 "../src/widgets/ItemView.vala"
						if (!(i < _tmp69_)) {
#line 1150 "../src/widgets/ItemView.vala"
							break;
#line 6286 "ItemView.c"
						}
#line 1151 "../src/widgets/ItemView.vala"
						_tmp70_ = selecteds;
#line 1151 "../src/widgets/ItemView.vala"
						_tmp71_ = gee_list_get (_tmp70_, i);
#line 1151 "../src/widgets/ItemView.vala"
						selected = (DesktopFolderItemView*) _tmp71_;
#line 1152 "../src/widgets/ItemView.vala"
						_tmp72_ = selected;
#line 1152 "../src/widgets/ItemView.vala"
						if (_tmp72_ != self) {
#line 6298 "ItemView.c"
							GtkAllocation allocation = {0};
							DesktopFolderItemView* _tmp73_;
							GtkAllocation _tmp74_ = {0};
							DesktopFolderFolderWindow* _tmp75_;
							DesktopFolderItemView* _tmp76_;
							GtkAllocation _tmp77_;
							GtkAllocation _tmp78_;
#line 1154 "../src/widgets/ItemView.vala"
							_tmp73_ = selected;
#line 1154 "../src/widgets/ItemView.vala"
							gtk_widget_get_allocation ((GtkWidget*) _tmp73_, &_tmp74_);
#line 1154 "../src/widgets/ItemView.vala"
							allocation = _tmp74_;
#line 1155 "../src/widgets/ItemView.vala"
							_tmp75_ = window;
#line 1155 "../src/widgets/ItemView.vala"
							_tmp76_ = selected;
#line 1155 "../src/widgets/ItemView.vala"
							_tmp77_ = allocation;
#line 1155 "../src/widgets/ItemView.vala"
							_tmp78_ = allocation;
#line 1155 "../src/widgets/ItemView.vala"
							desktop_folder_folder_window_move_item (_tmp75_, _tmp76_, _tmp77_.x - diff_x, _tmp78_.y - diff_y);
#line 6322 "ItemView.c"
						}
#line 1150 "../src/widgets/ItemView.vala"
						_g_object_unref0 (selected);
#line 6326 "ItemView.c"
					}
				}
			}
#line 1162 "../src/widgets/ItemView.vala"
			_tmp79_ = self->priv->manager;
#line 1162 "../src/widgets/ItemView.vala"
			_tmp80_ = desktop_folder_item_manager_get_folder (_tmp79_);
#line 1162 "../src/widgets/ItemView.vala"
			_tmp81_ = _tmp80_;
#line 1162 "../src/widgets/ItemView.vala"
			_tmp82_ = desktop_folder_folder_manager_get_arrangement (_tmp81_);
#line 1162 "../src/widgets/ItemView.vala"
			_tmp83_ = _tmp82_;
#line 1162 "../src/widgets/ItemView.vala"
			desktop_folder_folder_arrangement_motion_drag (_tmp83_, x + DESKTOP_FOLDER_ITEM_VIEW_PADDING_X, y);
#line 1162 "../src/widgets/ItemView.vala"
			_g_object_unref0 (_tmp83_);
#line 1162 "../src/widgets/ItemView.vala"
			_g_object_unref0 (_tmp81_);
#line 1137 "../src/widgets/ItemView.vala"
			_g_object_unref0 (selecteds);
#line 1137 "../src/widgets/ItemView.vala"
			_g_object_unref0 (window);
#line 6350 "ItemView.c"
		}
#line 1165 "../src/widgets/ItemView.vala"
		result = TRUE;
#line 1165 "../src/widgets/ItemView.vala"
		_g_object_unref0 (ims);
#line 1165 "../src/widgets/ItemView.vala"
		_g_object_unref0 (folder_settings);
#line 1165 "../src/widgets/ItemView.vala"
		return result;
#line 6360 "ItemView.c"
	} else {
#line 1167 "../src/widgets/ItemView.vala"
		result = FALSE;
#line 1167 "../src/widgets/ItemView.vala"
		return result;
#line 6366 "ItemView.c"
	}
}

/**
     * @name RoundDownToMultiple
     * @description util function for the movement of icons
     */
static inline gint
desktop_folder_item_view_RoundDownToMultiple (gint i,
                                              gint m)
{
	gint result;
#line 1176 "../src/widgets/ItemView.vala"
	result = (i / m) * m;
#line 1176 "../src/widgets/ItemView.vala"
	return result;
#line 6383 "ItemView.c"
}

/**
     * @name RoundToNearestMultiple
     * @description util function for the movement of icons
     */
gint
desktop_folder_item_view_RoundToNearestMultiple (gint i,
                                                 gint m)
{
	gint result;
#line 1184 "../src/widgets/ItemView.vala"
	if (((gdouble) (i % m)) > (((gdouble) m) / 2.0)) {
#line 1185 "../src/widgets/ItemView.vala"
		result = ((i / m) + 1) * m;
#line 1185 "../src/widgets/ItemView.vala"
		return result;
#line 6401 "ItemView.c"
	}
#line 1186 "../src/widgets/ItemView.vala"
	result = (i / m) * m;
#line 1186 "../src/widgets/ItemView.vala"
	return result;
#line 6407 "ItemView.c"
}

static void
desktop_folder_item_view_class_init (DesktopFolderItemViewClass * klass,
                                     gpointer klass_data)
{
	GError* _inner_error0_ = NULL;
#line 18 "../src/widgets/ItemView.vala"
	desktop_folder_item_view_parent_class = g_type_class_peek_parent (klass);
#line 18 "../src/widgets/ItemView.vala"
	g_type_class_adjust_private_offset (klass, &DesktopFolderItemView_private_offset);
#line 18 "../src/widgets/ItemView.vala"
	((DesktopFolderItemViewClass *) klass)->create_label = (void (*) (DesktopFolderItemView*, const gchar*)) desktop_folder_item_view_real_create_label;
#line 18 "../src/widgets/ItemView.vala"
	G_OBJECT_CLASS (klass)->finalize = desktop_folder_item_view_finalize;
#line 6423 "ItemView.c"
	{
		gint scale = 0;
		GdkPixbuf* _tmp0_ = NULL;
		GdkPixbuf* _tmp1_;
		GdkPixbuf* _tmp2_;
		GdkPixbuf* _tmp3_;
		GdkPixbuf* _tmp4_;
#line 66 "../src/widgets/ItemView.vala"
		scale = DESKTOP_FOLDER_ICON_SIZE / 3;
#line 67 "../src/widgets/ItemView.vala"
		_tmp1_ = gdk_pixbuf_new_from_resource ("/com/github/spheras/desktopfolder/link.svg", &_inner_error0_);
#line 67 "../src/widgets/ItemView.vala"
		_tmp0_ = _tmp1_;
#line 67 "../src/widgets/ItemView.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6439 "ItemView.c"
			goto __catch0_g_error;
		}
#line 67 "../src/widgets/ItemView.vala"
		_tmp2_ = _tmp0_;
#line 67 "../src/widgets/ItemView.vala"
		_tmp0_ = NULL;
#line 67 "../src/widgets/ItemView.vala"
		_g_object_unref0 (desktop_folder_item_view_LINK_PIXBUF);
#line 67 "../src/widgets/ItemView.vala"
		desktop_folder_item_view_LINK_PIXBUF = _tmp2_;
#line 68 "../src/widgets/ItemView.vala"
		_tmp3_ = desktop_folder_item_view_LINK_PIXBUF;
#line 68 "../src/widgets/ItemView.vala"
		_tmp4_ = gdk_pixbuf_scale_simple (_tmp3_, scale, scale, GDK_INTERP_BILINEAR);
#line 68 "../src/widgets/ItemView.vala"
		_g_object_unref0 (desktop_folder_item_view_LINK_PIXBUF);
#line 68 "../src/widgets/ItemView.vala"
		desktop_folder_item_view_LINK_PIXBUF = _tmp4_;
#line 65 "../src/widgets/ItemView.vala"
		_g_object_unref0 (_tmp0_);
#line 6460 "ItemView.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		FILE* _tmp5_;
		GError* _tmp6_;
		const gchar* _tmp7_;
		GError* _tmp8_;
		const gchar* _tmp9_;
#line 65 "../src/widgets/ItemView.vala"
		e = _inner_error0_;
#line 65 "../src/widgets/ItemView.vala"
		_inner_error0_ = NULL;
#line 70 "../src/widgets/ItemView.vala"
		_tmp5_ = stderr;
#line 70 "../src/widgets/ItemView.vala"
		_tmp6_ = e;
#line 70 "../src/widgets/ItemView.vala"
		_tmp7_ = _tmp6_->message;
#line 70 "../src/widgets/ItemView.vala"
		fprintf (_tmp5_, "Error: %s\n", _tmp7_);
#line 71 "../src/widgets/ItemView.vala"
		_tmp8_ = e;
#line 71 "../src/widgets/ItemView.vala"
		_tmp9_ = _tmp8_->message;
#line 71 "../src/widgets/ItemView.vala"
		desktop_folder_util_show_error_dialog ("Error", _tmp9_);
#line 65 "../src/widgets/ItemView.vala"
		_g_error_free0 (e);
#line 6491 "ItemView.c"
	}
	__finally0:
#line 65 "../src/widgets/ItemView.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 65 "../src/widgets/ItemView.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 65 "../src/widgets/ItemView.vala"
		g_clear_error (&_inner_error0_);
#line 6500 "ItemView.c"
	}
}

static void
desktop_folder_item_view_instance_init (DesktopFolderItemView * self,
                                        gpointer klass)
{
	gchar* _tmp0_;
#line 18 "../src/widgets/ItemView.vala"
	self->priv = desktop_folder_item_view_get_instance_private (self);
#line 29 "../src/widgets/ItemView.vala"
	self->priv->flagModified = FALSE;
#line 30 "../src/widgets/ItemView.vala"
	self->priv->flagMoved = FALSE;
#line 34 "../src/widgets/ItemView.vala"
	self->priv->menu = NULL;
#line 37 "../src/widgets/ItemView.vala"
	self->priv->hide_extension = FALSE;
#line 39 "../src/widgets/ItemView.vala"
	_tmp0_ = g_strdup ("");
#line 39 "../src/widgets/ItemView.vala"
	self->priv->hidden_extension = _tmp0_;
#line 46 "../src/widgets/ItemView.vala"
	self->priv->icon = NULL;
#line 48 "../src/widgets/ItemView.vala"
	self->priv->flag_dragdrop_started = FALSE;
#line 722 "../src/widgets/ItemView.vala"
	memset (&self->priv->start_drag_point, 0, sizeof (GdkPoint));
#line 6529 "ItemView.c"
}

static void
desktop_folder_item_view_finalize (GObject * obj)
{
	DesktopFolderItemView * self;
#line 18 "../src/widgets/ItemView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DESKTOP_FOLDER_TYPE_ITEM_VIEW, DesktopFolderItemView);
#line 32 "../src/widgets/ItemView.vala"
	_g_object_unref0 (self->priv->manager);
#line 34 "../src/widgets/ItemView.vala"
	_g_object_unref0 (self->priv->menu);
#line 39 "../src/widgets/ItemView.vala"
	_g_free0 (self->priv->hidden_extension);
#line 42 "../src/widgets/ItemView.vala"
	_g_object_unref0 (self->priv->container);
#line 44 "../src/widgets/ItemView.vala"
	_g_object_unref0 (self->priv->label);
#line 46 "../src/widgets/ItemView.vala"
	_g_object_unref0 (self->priv->icon);
#line 50 "../src/widgets/ItemView.vala"
	_g_object_unref0 (self->priv->drag_context);
#line 18 "../src/widgets/ItemView.vala"
	G_OBJECT_CLASS (desktop_folder_item_view_parent_class)->finalize (obj);
#line 6554 "ItemView.c"
}

static GType
desktop_folder_item_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DesktopFolderItemViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) desktop_folder_item_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DesktopFolderItemView), 0, (GInstanceInitFunc) desktop_folder_item_view_instance_init, NULL };
	GType desktop_folder_item_view_type_id;
	desktop_folder_item_view_type_id = g_type_register_static (gtk_event_box_get_type (), "DesktopFolderItemView", &g_define_type_info, 0);
	DesktopFolderItemView_private_offset = g_type_add_instance_private (desktop_folder_item_view_type_id, sizeof (DesktopFolderItemViewPrivate));
	return desktop_folder_item_view_type_id;
}

GType
desktop_folder_item_view_get_type (void)
{
	static volatile gsize desktop_folder_item_view_type_id__once = 0;
	if (g_once_init_enter (&desktop_folder_item_view_type_id__once)) {
		GType desktop_folder_item_view_type_id;
		desktop_folder_item_view_type_id = desktop_folder_item_view_get_type_once ();
		g_once_init_leave (&desktop_folder_item_view_type_id__once, desktop_folder_item_view_type_id);
	}
	return desktop_folder_item_view_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

